/*****************************************************************************/
/* BEDIT.C     Keyboard/Screan Input/Output  Interface                       */
/*****************************************************************************/
/* Used        Cursor(), and include file KEYCODE.II                         */
/*****************************************************************************/

#include<alloc.h>
#include<bios.h>
#include<conio.h>
#include<ctype.h>
#include<stdio.h>
#include<string.h>
#include"keycode.ii"
#include"lee_sub.i"

int BInvertF=YELLOW;     /* 112 */
int BInvertB=BLUE;       /*   7 */
int BNormalF=LIGHTGRAY;  /*   7 */
int BNormalB=BLACK;      /*   0 */

void GetBlockColor(int FFFF,int BBBB)  { BInvertF=FFFF; BInvertB=BBBB; }
void ShowBlockColor(int FFFF,int BBBB) { BNormalF=FFFF; BNormalB=BBBB; }

void ShowOneBlockLine(char *word,char width,char bfill)
{
   char j,slen=strlen(word);
   slen=(slen>width)?(j=1,width):(j=0,slen);
   if(bfill!=1 && j==0)
      cprintf("%s",word);
   else
      cprintf("%-*.*s",width,slen,word);
}
void LineScrollUp(char *newword,char ScrL,char ScrT,char ScrR,char ScrB)
{
   char *vbuf;
   char bwidth,bheight;
   struct text_info R;
   gettextinfo(&R);

   bheight=ScrB-ScrT+1;
   bwidth=ScrR-ScrL+1;

   vbuf=(char *)malloc(sizeof(char)*bheight*2);
   window(1,1,80,25);
   gettext(ScrR+1,ScrT,ScrR+1,ScrB,vbuf);

   window(ScrL,ScrT,ScrR+1,ScrB);
   gotoxy(1,1); delline();
   gotoxy(1,bheight);
   if(newword!=NULL)
      ShowOneBlockLine(newword,bwidth,0);

   window(1,1,80,25);
   puttext(ScrR+1,ScrT,ScrR+1,ScrB,vbuf);

   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(R.curx,R.cury);
}
void LineScrollDown(char *newword,char ScrL,char ScrT,char ScrR,char ScrB)
{
   char *vbuf;
   char bwidth,bheight;
   struct text_info R;
   gettextinfo(&R);

   bheight=ScrB-ScrT+1;
   bwidth=ScrR-ScrL+1;

   vbuf=(char *)malloc(sizeof(char)*bheight*2);
   window(1,1,80,25);
   gettext(ScrR+1,ScrT,ScrR+1,ScrB,vbuf);

   window(ScrL,ScrT,ScrR+1,ScrB);
   gotoxy(1,bheight); delline();
   gotoxy(1,1); insline();
   gotoxy(1,1);
   if(newword!=NULL)
      ShowOneBlockLine(newword,bwidth,0);

   window(1,1,80,25);
   puttext(ScrR+1,ScrT,ScrR+1,ScrB,vbuf);

   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(R.curx,R.cury);
}
void DrawBlock(char **word,int wRow,int fIndex)
{                                   /* fIndex_0_base */
   char i;
   char bheight,bwidth;
   struct text_info R;
   gettextinfo(&R);
   bheight=R.winbottom-R.wintop+1;
   bwidth=R.winright-R.winleft+1;
   window(R.winleft,R.wintop,R.winright-1,R.winbottom);  /* notice here */
   clrscr();                 /* -1 for GetBlock Only */
   for(i=0;i+fIndex<wRow;i++)
   {
      gotoxy(1,i+1);
      ShowOneBlockLine(word[i+fIndex],bwidth,0);
      if(i+1==bheight) break;
   }
   window(R.winleft,R.wintop,R.winright,R.winbottom);
}
void InsertLine(char **word,int *wRow,int rIns)    /* rIns_0_base */
{                                                  /* wRow_1_base */
   int i;
   for(i=*wRow;i>rIns;i--)                /* rIns is the no of word[0..] */
      strcpy(word[i],word[i-1]);          /*      that don't change      */
   strcpy(word[i],"\0");
   *wRow+=1;
}
void DeleteLine(char **word,int *wRow,int rDel)    /* rDel_0_base */
{                                                  /* wRow_1_base */
   int i;
   for(i=rDel;i<*wRow-1;i++)
      strcpy(word[i],word[i+1]);
   strcpy(word[i],"\0");
   *wRow-=1;
}
void SplitLine(char **word,int *wRow,int rSplit,char sCol)
{                                /* rSpt_0_base  sCol_0_base wRow_1_base */
   InsertLine(word,wRow,rSplit+1);
   strcpy(word[rSplit+1],&word[rSplit][sCol]);
   word[rSplit][sCol]='\0';
}
int  JoinLine(char **word,int *wRow,int rJoin,char wCol)
{                                /* rJoin_0_base  wRow,wCol_1_base */
   char *stmp;
   char slen;
   stmp=(char *)calloc(wCol*2+2,sizeof(char));
   strcpy(stmp,word[rJoin]);
   strcat(stmp,word[rJoin+1]);
   if((slen=strlen(stmp))<=wCol)
   {
      strncpy(word[rJoin],stmp,wCol);
      DeleteLine(word,wRow,rJoin+1);
   }
   else
   {
      if(CwordInString(stmp,wCol-1)==1)
      {
         strncpy(word[rJoin+1],&stmp[wCol-1],wCol);
         stmp[wCol-1]='\0';
         strncpy(word[rJoin],stmp,wCol);
      }
      else
      {
         strncpy(word[rJoin+1],&stmp[wCol],wCol);
         stmp[wCol]='\0';
         strncpy(word[rJoin],stmp,wCol);
      }
   }
   free(stmp);
   if(slen<=wCol)return 1;
   else          return 0;
}
int  StringKillBlank(char *word)
{
   int i=strlen(word)-1;
   for(;i>=0;i--)
      if(word[i]==' ' || word[i]=='\t')   word[i]='\0';
      else break;
   return i+1;
}
int  StringKillBlankBoth(char *word)
{
   int i;
   for(i=0;word[i];i++)
      if(word[i]==' ' || word[i]=='\t') continue;
      else break;
   if(i!=0) memcpy(&word[0],&word[i],strlen(word)-i+1);
   return StringKillBlank(word);
}
int  StringKillBlankAll(char *word)
{
   StringKillString(word," ");
   return strlen(word);
}
int  GetLineBlock(char *word,char *cCol,int ScrX,int ScrY,int Long,char fullflag)
{                            /* cCol_0_base */
   int  i;     /* Current Position */
   int  j;     /* End Word Position */
   int  k,l;
   int  ch;    /* Get BiosKey */

   if(0x0080 & bioskey(2))Cursor(2);else Cursor(1);/* Check if INS */
   textcolor(BInvertF); textbackground(BInvertB);

   gotoxy(ScrX+(*cCol),ScrY);                      /* goto cCol position */
   i=(*cCol);                                      /* i,j = 0 to Long */
   j=(strlen(word)>Long)?Long:strlen(word);

   while(1)
   {
      switch(ch=bioskey(0))
      {                                         /* Exit Key Code */
         case Enter:                            /* down to next line (split) */
         case PgUp: case PgDn:                  /* Page Control */
         case C_PgUp: case C_PgDn:
         case C_Home: case C_End:
         case Up:                               /* switch to prev line */
         case Down:                             /* switch to next line */
         case Tab:                              /* switch to next block */
         case S_Tab:                            /* switch to prev block */
         case C_BackSpace: case C_Y:            /* line delete */
         case A_J:                              /* line joint */
         case A_S:                              /* line split */
         case Esc:                              /* exit edit */
           StringKillBlank(word);               /* Set other char to NULL */
           *cCol=i;                             /* Set column position */
           return (ch);

         case BackSpace:
            if(j<i){i=wherex()-ScrX-1;gotoxy(ScrX+i,ScrY);break;}
            if(i>0)
            {
               i=wherex()-ScrX-1;
               j=(j>i)?j-1:i;
               gotoxy(ScrX+i,ScrY);
               for(k=i;k<j;k++)
               {
                  word[k]=word[k+1];
                  putch(word[k]);
               }
               word[k]='\0';putch(' ');
               gotoxy(ScrX+i,ScrY);
            }
            break;
         case Del:
            if(j<i)break;
            if(i>=0)
            {
               i=wherex()-ScrX;
               gotoxy(ScrX+i,ScrY);
               for(k=i;k<j;k++)
               {
                  word[k]=word[k+1];
                  putch(word[k]);
               }
             /*  word[k]='\0';putch(' '); */
               gotoxy(ScrX+i,ScrY);
               j=(j>i)?j-1:i;
            }
            break;
         case Home:
            gotoxy(ScrX,ScrY);
            i=0;
            break;
         case End:
            i=j=StringKillBlank(word);
            gotoxy(ScrX+j,ScrY);
            break;
         case Left:
            if(i!=0)
            {
               gotoxy(wherex()-1,ScrY);
               i-=1;
            }
            break;
         case Right:
            if(i<Long)
            {
               gotoxy(wherex()+1,ScrY);
               i+=1;
            }
            break;
         case Ins:
            if(0x0080 & bioskey(2))Cursor(2);else Cursor(1);
            break;
         default:
            if((char)ch!=0 && i!=Long)
            {
               if(i>j)
               {
                  for(k=j;k<=i && k<=Long;k++)word[k]=' ';
                  j=i=k-1;
               }
               if(!(0x0080 & bioskey(2)))            /* Replace */
               {
                  word[i]=(char)ch;
                  if(j==Long)word[Long]='\0';
                  i++;j=(i>j)?i:j;
                  putch(ch);
               }
               else                 /* Insert */
               {
                  for(k=j;k>=i;k--)word[k+1]=(k+1>=Long)?'\0':word[k];
                  word[i]=(char)ch;
                  gotoxy(ScrX+i,ScrY);
                  i++;j=(j>=Long)?Long:j+1;
                  for(k=i-1;k<j;k++)putch(word[k]);
                  gotoxy(ScrX+i,ScrY);
               }
               if(fullflag==1 && i==1)
               {
                  StringKillBlank(word);            /* Set other char to NULL */
                  *cCol=i;                             /* Set column position */
                  return (1);               /* right before chars full a line */
               }
               if(i==Long)
               {
                  StringKillBlank(word);            /* Set other char to NULL */
                  *cCol=0;                             /* Set column position */
                  return (0);      /* chars full a line and push to next line */
               }
            }
            break;
      }
   }
}
int  FindBlockEnd(char **word,int bMaxRow)   /* 0_base */
{
   int i;
   for(i=bMaxRow-1;i>=0;i--)
      if(word[i][0]!='\0')
         return(i);
   return(0);
}
int  GetBlock(char **word,int *wRow,int bMaxRow,char ScrL,char ScrT,char ScrR,char ScrB)
{
   char *stmp; /* temp for deal with half chinese word */
   struct text_info R;
   int  i;     /* Current Line Position/Index */   /* 0_base */
   int  j;     /* Top Line Position/Index */       /* 0_base */
   char sx,sy; /* Current Cursor position */       /* 0_base */
   int  ch;    /* Get BiosKey */
   int  k;
   char chead,cend;  /* save chars */
   char fullflag;
   char width=ScrR-ScrL+1;
   char height=ScrB-ScrT+1;

   stmp=(char *)calloc(width*2+2,sizeof(char));
   if(0x0080 & bioskey(2))Cursor(2);else Cursor(1);   /* Check if INS */

   gettextinfo(&R);
   window(ScrL,ScrT,ScrR+1,ScrB);
   textcolor(BInvertF), textbackground(BInvertB);  /* set Invert Color */
   DrawBlock(word,*wRow,0);

   i=j=0;                                          /* at the first line */
   sx=sy=0;                                        /* at HOME position */
   gotoxy(sx+1,sy+1);                              /* goto HOME position */
   fullflag=0;
   while(1)
   {
      switch(ch=GetLineBlock(word[i],&sx,1,sy+1,width,fullflag))
      {
         case 0:           /* chars full a line and push to next line */
            fullflag=1;
            sx=0;
            if(i+1>=bMaxRow) break;
            if(sy+1==height) j++,LineScrollUp(word[i+1],ScrL,ScrT,ScrR,ScrB);
            else sy+=1;
            i++;
            chead=word[i][0],cend=word[i][width-1];
            break;
         case 1:
            fullflag=0;
            strcpy(stmp,word[i-1]);
            strcat(stmp,word[i]);
            if(CwordInString(stmp,width-1)==1)
            {
               word[i-1][width-1]='\0';
               if(!(0x0080 & bioskey(2)))word[i][0]=chead;
               else strncpy(word[i],&stmp[width+1],width),word[i][width-1]=cend;
               gotoxy(1,sy);ShowOneBlockLine(word[i-1],width,1);
               gotoxy(1,sy+1);ShowOneBlockLine(word[i],width,1);  /* rewrite curline */
               sx=0;
            }
            break;
         case Enter:                            /* down to next line (split) */
            if(!(0x0080 & bioskey(2)))          /* Check INS */
            {
               sx=0;
               if(i+1>=bMaxRow) break;
               if(sy+1==height) j+=1,LineScrollUp(word[i+1],ScrL,ScrT,ScrR,ScrB);
               else sy+=1;
               i++;
               break;
            }
         case A_S:                              /* line split */
            if(i+1>=bMaxRow) break;
            k=FindBlockEnd(word,bMaxRow)+1;
            SplitLine(word,&k,i,sx);
            gotoxy(1,sy+1);ShowOneBlockLine(word[i],width,1);  /* rewrite curline */
            if(sy+1==height) j+=1,LineScrollUp(word[i+1],ScrL,ScrT,ScrR,ScrB);
            else    sy+=1,LineScrollDown(word[i+1],ScrL,ScrT+sy,ScrR,ScrB);
            i++;
            sx=0;
            break;
         case PgUp:                             /* Page Control */
            if(i==0)break;
            if(j==0)    /* at the top page */
               i=0,sy=0;
            else
               j-=height-1,j=(j<0)?0:j,i=j+sy,DrawBlock(word,bMaxRow,j);
            break;
         case PgDn:
            k=FindBlockEnd(word,bMaxRow);
            if(i==k)break;     /* at the end */
            if(j+height-1==k)  /* at the bottom page */
               i=k,sy=i-j;
            else
               j+=height-1,j=(j>k-height+1)?k-height+1:j,i=j+sy,i=(i>k)?k:i,sy=i-j,DrawBlock(word,k+1,j);
            break;
         case C_PgUp:
            if(sy==0)break;
            sy=0;          i=j;
            break;
         case C_PgDn:
            if(sy+1==height)break;
            sy=height-1;   i=j+sy;
            break;
         case C_Home:
            if(i==0)break;
            if(j==0)    /* at the top page */
               i=0,sy=0;
            else
               j=0,i=0,sy=0,DrawBlock(word,height,j);
            break;
         case C_End:
            k=FindBlockEnd(word,bMaxRow);
            if(i==k)break;
            if(j+height-1==k)  /* at the bottom page */
               i=k,sy=i-j;
            else
               j=k-height+1,j=(j<0)?0:j,i=k,sy=i-j,DrawBlock(word,k+1,j);
            break;
         case Up:                               /* switch to prev line */
            if(i==0)break;
            if(i==j) j-=1,LineScrollDown(word[i-1],ScrL,ScrT,ScrR,ScrB);
            else     sy--;
            i--;
            break;
         case Down:                             /* switch to next line */
            if(i+1>=bMaxRow)break;
            if(sy+1==height)j+=1,LineScrollUp(word[i+1],ScrL,ScrT,ScrR,ScrB);
            else    sy++;
            i++;
            break;
         case C_BackSpace: case C_Y:            /* line delete */
            k=FindBlockEnd(word,bMaxRow)+1;
            if(i>=k)break;
            DeleteLine(word,&k,i);
            LineScrollUp(word[j+height-1],ScrL,ScrT+sy,ScrR,ScrB);
            break;
         case A_J:                              /* line joint */
            if(strlen(word[i])>=width)break;
            k=FindBlockEnd(word,bMaxRow)+1;
            sx=strlen(word[i]);
            k=JoinLine(word,&k,i,width);
            gotoxy(1,sy+1),ShowOneBlockLine(word[i],width,1);  /* rewrite curline */
            if(k==1)
               gotoxy(1,sy+1),LineScrollUp(word[j+height-1],ScrL,ScrT+sy+1,ScrR,ScrB);
            else if(sy+1!=height)
               gotoxy(1,sy+2),ShowOneBlockLine(word[i+1],width,1); /* rewrite curline */
            break;
         case Esc:                              /* exit edit */
         case Tab:                              /* switch to next block */
         case S_Tab:                            /* switch to prev block */
            window(R.winleft,R.wintop,R.winright,R.winbottom);
            gotoxy(R.curx,R.cury);
            *wRow=FindBlockEnd(word,bMaxRow)+1;
            free(stmp);
            return(ch);
      }
      if(ch!=0 && ch!=1) fullflag=0;
      /*********************************************** for Checking & Debug ***
      window(1,1,80,25);
      gotoxy(40,2);printf("w =%3d   h=%3d",width,height);
      gotoxy(40,3);printf("i =%3d   j=%3d",i,j);
      gotoxy(40,4);printf("sx=%3d  sy=%3d",sx,sy);
      gotoxy(40,4);printf("sx=%3d  sy=%3d",sx,sy);
      gotoxy(40,6);printf("    5    0    5    0    5    0");
      gotoxy(40,7);printf("1234 6789 1234 6789 1234 6789");
      for(k=-2;k<3;k++)
      {
         gotoxy(39,k+10);
         printf("\"");
         printf("                              ");
         gotoxy(40,k+10);
         if((i+k >= 0) && (i+k < bMaxRow)) printf(word[i+k]);
         printf("\"");
      }
      gotoxy(40,13);printf("1234 6789 1234 6789 1234 6789");
      gotoxy(40,14);printf("    5    0    5    0    5    0");
      gotoxy(35,10);printf("-->>");
      window(ScrL,ScrT,ScrR+1,ScrB);
      ************************************************************************/
   }
}

/******** BEDIT.C ***************************************** Test Program 1 ****
main()
{
   char **test;
   char  *testbase;
   char  *testindex;
   unsigned int ALL_seg;   /* for far pointer of ALL */
   unsigned int ALL_off;   /* for far pointer of ALL */
   int i,rows,cols,wrow;
   rows=100;
   cols=80;

   test=(char **)calloc(rows,sizeof(char *));
   testbase=(char *)calloc(rows,sizeof(char)*cols);

   testindex=(char *)testbase;
   for(i=0;i<rows;i++)
   {
      test[i]=(char *)testindex;
      testindex+=sizeof(char)*cols;
      itoa(i,test[i],10);
   }
   clrscr();
   Insert_Mode();
   normvideo();
   clrscr();
   wrow=100;
   CFrame(1,1,31,24,1);
   GetBlock(test,&wrow,100,3,2,30,23);
   free(testbase);
   free(test);
   Cursor(1);
}
******************************************************************************/
