/*---------------------------------------------------------------------------//
// CFILE.CPP      Convert Data file to ETen USERfont data file <TC++/BC++>   //
//---------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

/*-------------
   FA40 -- FEFE   785         MSB   A1 -- FE       LSB   40 -- 7E   63
   8E40 -- A0FE  2983               8E -- A0             A1 -- FE   94
   8140 -- 8DFE  2041               81 -- 8D                       157
                 5809                                      5809/157=37
--------------*/

unsigned char ufontmsb[37];      /* FA -- FE , 8E -- A0 , 81 -- 8D */
unsigned char ufontlsb[157];     /* 40 -- 7E , A1 -- FE            */
void presetufont(void)
{
   int i;
   unsigned char j;
   for(i=0,j=0xFA;j<=0xFE;i++,j++)ufontmsb[i]=j;
   for(    j=0x8E;j<=0xA0;i++,j++)ufontmsb[i]=j;
   for(    j=0x81;j<=0x8D;i++,j++)ufontmsb[i]=j;
   for(i=0,j=0x40;j<=0x7E;i++,j++)ufontlsb[i]=j;
   for(    j=0xA1;j<=0xFE;i++,j++)ufontlsb[i]=j;
}


void main(int argc,char *argv[])
{
   FILE *in,*out;
            int cb[2];
            int mindex;
   unsigned int findex;

   if(argc<4)
   {
      printf("USAGE:\n %s datafile outputfile msbindex\n",argv[0]);
      exit(0);
   }
   if((in=fopen(argv[1],"rb"))==NULL)
   {
      printf(">> %s open error !!",argv[1]);
      exit(0);
   }
   if((out=fopen(argv[2],"wb"))==NULL)
   {
      printf(">> %s open error !!",argv[2]);
      exit(0);
   }
   presetufont();
   mindex=atoi(argv[3]);
   while(1)
   {
      if((cb[0]=fgetc(in))==EOF)break;

      if(cb[0]<mindex) fputc(cb[0],out);
      else
      {
         if((cb[1]=fgetc(in))==EOF)break;
	 findex=(cb[0]-mindex)*256+cb[1];
	 if(findex>5808)findex=0;
         fputc(ufontmsb[findex/157],out);
         fputc(ufontlsb[findex%157],out);
      }
   }
   fcloseall();
}
