/*****************************************************************************/
/* CHINCODE.C    Chinese Code for BIG-5,Club,ETen Identification             */
/*****************************************************************************/
#pragma inline

#include <dos.h>
#include <string.h>
#include"lee_sub.i"

typedef union
   {
      struct
      {
         unsigned   internalcode:4;
         unsigned      inputcode:4;
         unsigned            res:4;
         unsigned   hardwardflag:1;
         unsigned hardwardscroll:1;
         unsigned      font24x24:1;
         unsigned      pureascii:1;
      } e;
      struct
      {
         unsigned int flag;
      } f;
   }ET_EQ_FLAG;


ET_GRAPHIC ETen;

char BIG5_Code(char *word)             /* Check if word[] is BIG5_Code */
{                                      /* BIG5_Code in Appendix A      */
   if(word[0]>='\x81' && word[0]<='\xFE')
      if((word[1]>='\x40' && word[1]<='\x7E')
      || (word[1]>='\xA1' && word[0]<='\xFE'))
         return (1);
   return(0);
}

char Club_Code(char *word)             /* Check if word[] is Club_Code */
{                                      /* Club_Code in Appendix B      */
   if(word[0]>='\x81' && word[0]<='\xFD')
      if((word[1]>='\x30' && word[1]<='\x39')
      || (word[1]>='\x41' && word[0]<='\x5A')
      || (word[1]>='\x61' && word[0]<='\x7A')
      || (word[1]>='\x80' && word[0]<='\xFD'))
         return (1);
   return(0);
}

char ETen_Code(char *word)             /* Check if word[] is ETen_Code */
{                                      /* ETen_Code in Appendix C      */
   if((word[0]>='\x81' && word[0]<='\xAF')
   || (word[1]>='\xDD' && word[0]<='\xFF'))
      if((word[1]>='\x30' && word[1]<='\x39')
      || (word[1]>='\x41' && word[0]<='\x5A')
      || (word[1]>='\x61' && word[0]<='\x7A')
      || (word[1]>='\x80' && word[0]<='\xFD'))
         return (1);
   return(0);
}

char CWord(char *word)
{
   return (BIG5_Code(word));
}
void ChineseInt10(char ch)
{
   short aa=ch;
   asm   mov   ah,80h
   asm   mov   al,aa
   asm   int   10h
}
char CwordInString(char *word,int offset)
{                             /* offset_0_base */
   int i;
   for(i=0;i<offset;)
   {
      if(BIG5_Code(&word[i]))i+=2;
      else                  i+=1;
   }
   if(i==offset && BIG5_Code(&word[offset]))return(1);
   else         return(0);
}
int  NumOfCword(char *word)
{
   char c0,c1;
   int i,numC;
   int slen=strlen(word);
   for(i=numC=0,c0=1,c1=0;i<slen;c0=c1)
      if(BIG5_Code(&word[i])) i+=2,c1=1,numC++;
      else                    i+=1,c1=0,numC+=(c0==1)?1:0;
   return (numC);
}
BOOL2 ETinfo(unsigned int *etVer,unsigned char *scrCrol,unsigned char *prnCrol)
{
   unsigned int  v,c,f;
   unsigned char s;
   unsigned char p;
   ET_EQ_FLAG ff;

   asm   mov   ax,09100h
   asm   mov   bx,0
   asm   mov   cx,0
   asm   mov   dx,0
   asm   int   10h

   asm   mov   v,ax
   asm   mov   c,bx
   asm   mov   s,ch
   asm   mov   p,cl
   asm   mov   f,dx

   asm   cmp   bx,0
   asm   je    NotInET
   asm   jmp   InET

NotInET:
   return NotOK;

InET:
   *etVer=v;
   *scrCrol=s;
   *prnCrol=p;

   ETen.ver=v;
   ETen.comseg=c;
   ETen.screenC=s;
   ETen.printerC=p;
   ff.f.flag=f;
   ETen.internalcode   = (unsigned char)ff.e.internalcode;
   ETen.inputcode      = (unsigned char)ff.e.inputcode;
   ETen.hardwardflag   = (unsigned char)ff.e.hardwardflag;
   ETen.hardwardscroll = (unsigned char)ff.e.hardwardscroll;
   ETen.font24x24      = (unsigned char)ff.e.font24x24;
   ETen.pureascii      = (unsigned char)ff.e.pureascii;

   return OK;
}
BOOL2 CheckChineseSystem(void)
{
   asm   mov   ax,09100h
   asm   mov   bx,0
   asm   int   10h

   asm   cmp   bx,0
   asm   je    NotInET

   return OK;

NotInET:
   return NotOK;
}
void SetChineseInput(void)
{
   ChineseInt10('C');
}
void SetEnglishInput(void)
{
   ChineseInt10('N');
   ChineseInt10('F');
   ChineseInt10('f');
}

BOOL2 InitializeETen(void)
{
   ET_GRAPHIC far *b;
   ET_EQ_FLAG ff;
   unsigned int S,O,f;

   if(CheckChineseSystem()!=OK)return NotOK;

   b=(ET_GRAPHIC far *)&ETen;
   S=FP_SEG(b);
   O=FP_OFF(b);

   asm   mov   ax,S
   asm   mov   es,ax
   asm   mov   ax,O
   asm   mov   di,ax
   asm   mov   ah,08Dh
   asm   mov   al, 01h
   asm   int   10h               /* Get Graphics Info */


   asm   mov   ax,09100h
   asm   mov   bx,0
   asm   mov   cx,0
   asm   mov   dx,0
   asm   int   10h               /* Get General Info */

   asm   mov   ETen.ver,ax
   asm   mov   ETen.comseg,bx
   asm   mov   BYTE PTR ETen.screenC,ch
   asm   mov   BYTE PTR ETen.printerC,cl
   asm   mov   f,dx

   ff.f.flag=f;
   ETen.internalcode   = (unsigned char)ff.e.internalcode;
   ETen.inputcode      = (unsigned char)ff.e.inputcode;
   ETen.hardwardflag   = (unsigned char)ff.e.hardwardflag;
   ETen.hardwardscroll = (unsigned char)ff.e.hardwardscroll;
   ETen.font24x24      = (unsigned char)ff.e.font24x24;
   ETen.pureascii      = (unsigned char)ff.e.pureascii;

   return OK;
}

/*****************************************************************************
void ShowStatus(ET_GRAPHIC a)
{
   int i;
   printf("        width = %8u\n",a.width        );
   printf("       height = %8u\n",a.height       );
   printf("    main_UL_x = %8u\n",a.main_UL_x    );
   printf("    main_UL_y = %8u\n",a.main_UL_y    );
   printf("   main_width = %8u\n",a.main_width   );
   printf("  main_height = %8u\n",a.main_height  );
   printf("  ascii_width = %8u\n",a.ascii_width  );
   printf(" ascii_height = %8u\n",a.ascii_height );
   printf("      vp_UL_x = %8u\n",a.vp_UL_x      );
   printf("      vp_UL_y = %8u\n",a.vp_UL_y      );
   printf("      vp_BR_x = %8u\n",a.vp_BR_x      );
   printf("      vp_BR_y = %8u\n",a.vp_BR_y      );
   printf("        LPR_x = %8u\n",a.LPR_x        );
   printf("        LPR_y = %8u\n",a.LPR_y        );
   printf("         flag = %8u\n",a.flag         );
   printf("    MaxColors = %8u\n",a.MaxColors    );
   printf("DefaultColor0 = %8u\n",a.DefaultColor0);
   printf("DefaultColor1 = %8u\n",a.DefaultColor1);
   printf("      res[32] = ");
   for(i=0;i<32;i++)
   {
      if(i%16==0 && i!=0) printf("\n                ");
      printf("%02X ",a.res[i]);
   }
}

main()
{
   static ET_GRAPHIC a;
   ET_GRAPHIC far *b;
   unsigned int S,O;

   b=(ET_GRAPHIC far *)&a;
   S=FP_SEG(b);
   O=FP_OFF(b);

   asm   mov   ax,S
   asm   mov   es,ax
   asm   mov   ax,O
   asm   mov   di,ax
   asm   mov   ah,08Dh
   asm   mov   al, 01h
   asm   int   10h

   ShowStatus(a);
}
*****************************************************************************/
/*****************************************************************************
main()
{
   unsigned int etVer;
   unsigned char scrCrol;
   unsigned char prnCrol;

   if(ETinfo(&etVer,&scrCrol,&prnCrol)==OK)
   {
      printf("ETVer  =%04X\n",etVer);
      printf("scrCrol=%02X\n",scrCrol);
      printf("prnCrol=%02X\n",prnCrol);
   }
   else
      printf("Not in ET Chinese system!");
}
*****************************************************************************/
/********************************************************** Appendix A *******
   BIG-5 Code:
      High Byte :    A1h ~ FEh         81h ~ FEh
                     8Eh ~ A0h
                     81h ~ 8Dh         total number = 126
      Low  Byte :    40h ~ 7Eh
                     A1h ~ FEh         total number = 157     126*157=19782

      STDFONT:
                      | Range Used  | Words | Range Resver| Words |
         Offen Use    | A440 - C67E |  5401 |             |     0 |
         2nd offen Use| C940 - F9D5 |  7652 |             |     0 |
         Eten Word    | F9D6 - F9FE |    41 |             |     0 |
         Total        |               13094 |                   0 |

      SPCFONT:
                      | Range Used  | Words | Range Resver| Words |
         Standard Word| A140 - A3BF |   408 |             |     0 |
         Control Code | A3C0 - A3E0 |    33 | A3E1 - A3FE |    30 |
         Total        |                 441 |                  30 |

      SPCSUPP:
                      | Range Used  | Words | Range Resver| Words |
         Standard Word| C6A1 - C8FE |   408 |             |     0 |
         Total        |                 408 |                   0 |

      USRFONT:
                      | Range Used  | Words | Range Resver| Words |
         1st Range    | FA40 - FEFE |   785 |             |     0 |
         2nd Range    | 8E40 - A0FE |  2983 |             |     0 |
         3rd Range    | 8140 - 8DFE |  2041 |             |     0 |
         Total        |                5809 |                   0 |
/************ for get All Big-5 words ****************/
#include<stdio.h>
FILE *T;
void W(unsigned char lHi,unsigned char hHi)
{
   unsigned char Hi,Lo,i;
   for(Hi=lHi;Hi<=hHi;Hi++)
   {
      for(Lo=0x40,i=0;Lo<=0x7E;Lo++)
      {
         fprintf(T,"%02X%02X %c%c  ",Hi,Lo,Hi,Lo);
         i++;
         i%=8;
         if(i==0)fprintf(T,"\x0D\x0A");
      }
      fprintf(T,"\x0D\x0A");
      for(Lo=0xA1,i=0;Lo<=0xFE;Lo++)
      {
         fprintf(T,"%02X%02X %c%c  ",Hi,Lo,Hi,Lo);
         i++;
         i%=8;
         if(i==0)fprintf(T,"\x0D\x0A");
      }
      fprintf(T,"\x0D\x0A");
   }
}

main()
{
   T=fopen("123.dat","wb");
   W(0xA4,0xC6);
   W(0xC9,0xF9);
   W(0xA1,0xA3);
   W(0xC6,0xC8);
   W(0xFA,0xFE);
   W(0x8E,0xA0);
   W(0x81,0x8D);
   fclose(T);
}
******************************************************************************/
/********************************************************** Appendix B *******
   Club Code:
      High Byte :    81h ~ FDh         total number = 125
      Low  Byte :    30h ~ 39h
                     41h ~ 5Ah
                     61h ~ 7Ah
                     80h ~ FDh         total number = 188     125*188=23500

      STDFONT:
                      | Range Used  | Words | Range Resver| Words |
         Offen Use    | 92A0 - AF67 |  5401 |             |     0 |
         2nd offen Use| B030 - D8C3 |  7650 |             |     0 |
         Eten Word    | D8C4 - D8EC |    41 |             |     0 |
         Total        |               13092 |                   0 |

      SPCFONT:
                      | Range Used  | Words | Range Resver| Words |
         Standard Word| 8130 - 826A |   234 | 8550 - 89FD |   915 |
                      | 82A0 - 8391 |   174 |             |     0 |
                      | 83A0 - 83BD |    30 |             |     0 |
                      | 8430 - 854F |   213 |             |     0 |
         Control Code | A3C0 - A3E0 |    33 |             |     0 |
         Total        |                 441 |                 915 |

      SPCSUPP:
                      | Range Used  | Words | Range Resver| Words |
         Standard Word| 826B - 829F |    48 |             |     0 |
                      | 8392 - 839F |    14 |             |     0 |
                      | 83BE - 83FD |    64 |             |     0 |
                      | AF68 - AFFD |   145 |             |     0 |
         Total        |                 271 |                   0 |

      USRFONT:
                      | Range Used  | Words | Range Resver| Words |
         1st Range    | DF30 - FCFD |  5640 |             |     0 |
         2nd Range    | 8A30 - 919F |  1410 |             |     0 |
         Total        |                7050 |                   0 |

******************************************************************************/
/********************************************************** Appendix C *******
   ETen Code:
      High Byte :    81h ~ AFh
                     DDh ~ FFh         total number =  81
      Low  Byte :    30h ~ 39h
                     41h ~ 5Ah
                     61h ~ 7Ah
                     80h ~ FDh         total number = 188      81*188=15228

      STDFONT:
                      | Range Used  | Words | Range Resver| Words |
         Offen Use    | 92A0 - AF67 |  5401 |             |     0 |
         2nd offen Use| DD30 - FEFD |  6392 |             |     0 |
                      | 8550 - 8BDC |  1258 |             |     0 |
         Eten Word    | 8BDD - 8C37 |    41 |             |     0 |
         Total        |               13092 |                   0 |

      SPCFONT:
                      | Range Used  | Words | Range Resver| Words |
         Standard Word| 8130 - 826A |   234 |             |     0 |
                      | 82A0 - 8391 |   174 |             |     0 |
                      | 83A0 - 83BD |    30 |             |     0 |
                      | 8430 - 854F |   213 |             |     0 |
         Control Code | 91A0 - 91C0 |    33 |             |     0 |
         Total        |                 684 |                   0 |

      SPCSUPP:
                      | Range Used  | Words | Range Resver| Words |
         Standard Word| 826B - 829F |    48 |             |     0 |
                      | 8392 - 839F |    14 |             |     0 |
                      | 83BE - 83FD |    64 |             |     0 |
                      | AF68 - AFFD |   145 |             |     0 |
         Total        |                 271 |                   0 |

      USRFONT:
                      | Range Used  | Words | Range Resver| Words |
         1st Range    | 8C38 - 919F |  1026 |             |     0 |
         Total        |                1026 |                   0 |

      p.s. Reserved range [8550 - 919F] Usage ..
            [8550 - 8BDC] STDFONT 2nd offen Use
            [8BDD - 8C37] STDFONT Eten Word
            [8C38 - 919F] USRFONT
******************************************************************************/
