/*****************************************************************************/
/* CURSOR.C    Set Cursor Type -- Replace ,Insert,and Back to Orginal Size   */
/*****************************************************************************/
#pragma inline

char VideoMode(void)                   /* Rerurn the video mode */
{                                      /* for mode check Appendix below */
   char vmode;
   asm   mov   ah,0Fh
   asm   int   10h
   asm   mov   vmode,al
   return vmode;
}
char VideoCombination(void)
{
   char cvmode;
   asm   mov   ah,1Ah
   asm   mov   al,00h
   asm   int   10h
   asm   mov   cvmode,bl
   return cvmode;
}
char VideoOriginal(void)
{
   char vmode;
   asm   int   11h
   asm   mov   cl,4
   asm   shr   al,cl
   asm   and   al,03h
   asm   mov   vmode,al
   return   vmode;
}

unsigned int CurSize=0;                         /* Save old Cursor type */
unsigned int  GetCursorSize(void)
{
   unsigned int cursor_size;
   asm   mov   ah,3
   asm   mov   bh,1
   asm   int   10h
   asm   mov   cursor_size,cx
   return cursor_size;
}
void PutCursorSize(unsigned int cursor_size)
{
   asm   mov   cx,cursor_size
   asm   mov   ah,1
   asm   int   10h
}
void Cursor(int on)                    /* on = 0       Off cursor   */
{                                      /* on = 1       Replace mode */
   char vmode;                         /* on = 2       Insert mode  */
   vmode=VideoMode();                  /* on = other   Back to old  */

   if(CurSize==0)
      CurSize=GetCursorSize();

   switch(on)
   {
      case 0:                          /* Cursor Off */
         PutCursorSize(0x2000);
         break;
      case 1:                          /* Cursor On (Replace) */
         if(vmode==7)                  /* MGA */
            PutCursorSize(0x0B0C);
         else                          /* VGA */
            PutCursorSize(0x0D0E);
         break;
      case 2:                          /* Cursor On (Insert) */
         if(vmode==7)                  /* MGA */
            PutCursorSize(0x010C);
         else                          /* VGA */
            PutCursorSize(0x010E);
         break;
      default:                         /* Cursor On (Orginal) */
         PutCursorSize(CurSize);
         break;
   }
}
void Clear_KeyBuf(void)
{
   while(bioskey(1)!=0) bioskey(0);
}

char far *shift_key_status=(char far *)0x00400017;
void Insert_Mode(void)
{
   *shift_key_status|=0x80;      /* bit map 1000-0000 */
}
void Replace_Mode(void)
{
   *shift_key_status&=0x7F;      /* bit map 0111-1111 */
}
char Get_Insert_Flag(void)
{
   if((*shift_key_status)&0x80==0x80)return(1);
   return(0);
}
void CapsLockON(void)
{
   *shift_key_status|=0x40;      /* bit map 0100-0000 */
}
void CapsLockOFF(void)
{
   *shift_key_status&=0xBF;      /* bit map 1011-1111 */
}
char Get_CapsLock(void)
{
   if((*shift_key_status)&0x40==0x40)return(1);
   return(0);
}
void NumLockON(void)
{
   *shift_key_status|=0x20;      /* bit map 0010-0000 */
}
void NumLockOFF(void)
{
   *shift_key_status&=0xDF;      /* bit map 1101-1111 */
}
char Get_NumLock(void)
{
   if((*shift_key_status)&0x20==0x20)return(1);
   return(0);
}
void ScrollLockON(void)
{
   *shift_key_status|=0x10;      /* bit map 0001-0000 */
}
void ScrollLockOFF(void)
{
   *shift_key_status&=0xEF;      /* bit map 1110-1111 */
}
char Get_ScrollLock(void)
{
   if((*shift_key_status)&0x10==0x10)return(1);
   return(0);
}
/******** CURSOR.C **************************************** Test Program ******
main()
{
   char *imode[]={
           "unused",                                            /*00*/
           "40x25 color",                                       /*01*/
           "80x25 color",                                       /*10*/
           "80x25 monochrome" };                                /*11*/
   char *cmode[]={
           "Unrecognized video system",                         /*FF*/
           "No display",                                        /*00*/
           "MDA with monochrome display",                       /*01*/
           "CGA with color display",                            /*02*/
           "Reserved",                                          /*03*/
           "EGA with color display",                            /*04*/
           "EGA with monochrome display",                       /*05*/
           "Professional graphics controller",                  /*06*/
           "VGA with analog monochrome display",                /*07*/
           "VGA with analog color display",                     /*08*/
           "Reserved",                                          /*09*/
           "MCGA with digital color display",                   /*0A*/
           "MCGA with analog monochrome display",               /*0B*/
           "MCGA with analog color display"   };                /*0C*/
   char *vmode[]={
           "40x25 B/W text (CGA,EGA,MCGA,VGA)",                 /*00*/
           "40x25 16 color text (CGA,EGA,MCGA,VGA)",            /*01*/
           "80x25 16 shades of gray text (CGA,EGA,MCGA,VGA)",   /*02*/
           "80x25 16 color text (CGA,EGA,MCGA,VGA)",            /*03*/
           "320x200 4 color graphics (CGA,EGA,MCGA,VGA)",       /*04*/
           "320x200 4 color graphics (CGA,EGA,MCGA,VGA)",       /*05*/
           "640x200 B/W graphics (CGA,EGA,MCGA,VGA)",           /*06*/
           "80x25 Monochrome text (MDA,HERC,EGA,VGA)",          /*07*/
           "160x200 16 color graphics (PCjr)",                  /*08*/
           "320x200 16 color graphics (PCjr)",                  /*09*/
           "640x200 4 color graphics (PCjr)",                   /*0A*/
           "Reserved (EGA BIOS function 11)",                   /*0B*/
           "Reserved (EGA BIOS function 11)",                   /*0C*/
           "320x200 16 color graphics (EGA,VGA)",               /*0D*/
           "640x200 16 color graphics (EGA,VGA)",               /*0E*/
           "640x350 Monochrome graphics (EGA,VGA)",             /*0F*/
           "640x350 16 color graphics (EGA or VGA with 128K)"   /*10*/
           "\n640x350 4 color graphics (64K EGA)",              /*  */
           "640x480 B/W graphics (MCGA,VGA)",                   /*11*/
           "640x480 16 color graphics (VGA)",                   /*12*/
           "320x200 256 color graphics (MCGA,VGA)",             /*13*/
           "EGA, MCGA or VGA ignore bit 7, see below",          /*8x*/
           "EGA, MCGA or VGA ignore bit 7, see below"    };     /*9x*/

   char mode,cvmode,ivmode;
   mode=VideoMode();
   cvmode=VideoCombination();
   ivmode=VideoOriginal();

   printf("\nTest Cursor program ...in imode = %d",ivmode);
   printf("\n%s\n",imode[ivmode]);
   printf("\nTest Cursor program ...in cmode = %d",cvmode);
   printf("\n%s\n",((cvmode=='\xFF')?cmode[0]:(('\x00'<=cvmode && cvmode<='\x0C')?cmode[cvmode+1]:"")));
   printf("\nTest Cursor program ...in mode = %d",mode);
   printf("\n%s\n",(('\x00'<=mode && mode<='\x13')?vmode[mode]:""));
   printf("\nOriginal Cursor ...");getch();
   printf("\nInsert Cursor ...");Cursor(2);getch();
   printf("\nReplace Cursor ...");Cursor(1);getch();
   printf("\nOff Cursor ...");Cursor(0);getch();
   printf("\nBack Original ...");Cursor(3);getch();
   printf("\n");
}
******************************************************************************/
