/*****************************************************************************/
/* C_HELP.C      Chinese Help                                                */
/*****************************************************************************/
/* Call :   BLFill(),Message(),Clrscr(),                                     */
/*****************************************************************************/

#include<alloc.h>
#include<conio.h>
#include<stdio.h>
#include<string.h>
#include"lee_sub.i"
#include"keycode.ii"

#define MAXHELPLINE 800
#define HelpFirst 1
#define HelpPAGEL 23

FILE *File_HELP;
char *HelpBuf;
unsigned int *IndexOfHelp;
int  Total_Help_Line;

int  HelpMarkF=WHITE;
int  HelpMarkB=BLACK;
void HelpColor(int FFFF,int BBBB){HelpMarkF=FFFF;HelpMarkB=BBBB;}
void HelpMark(char ScrII)
{
   BLfill(ScrII,HelpMarkF+HelpMarkB*16);
}
char InitHelp(char *HelpFile)
{
   long FileLens;
   unsigned int i;
   if(FileExist(HelpFile)!=TRUE)
   {
      Message(1,0,0,"DUɤsbI");
      return ERROR;                    /* ERROR -> Error As Open Help File */
   }
   if((File_HELP=fopen(HelpFile,"r"))==NULL)
   {
      Message(1,0,0,"DUɶ}ҿ~I");
      return ERROR;                    /* ERROR -> Error As Open Help File */
   }
   FileLens=filelength(fileno(File_HELP));
   HelpBuf=(char *)calloc(FileLens,sizeof(char));
   IndexOfHelp=(unsigned int *)calloc(MAXHELPLINE,sizeof(unsigned int));
   rewind(File_HELP);
   fread(HelpBuf,FileLens,1,File_HELP);
   for(i=0,IndexOfHelp[0]=0,Total_Help_Line=1;i<FileLens;i++)
      if(HelpBuf[i]=='\n')
         HelpBuf[i]='\0', IndexOfHelp[Total_Help_Line++]=i+1;
   Total_Help_Line--;
   return OK;                           /* OK -> Read Help File to Buf */
}
void OffHelp(void)
{
   free(IndexOfHelp);
   free(HelpBuf);
   fclose(File_HELP);
}
void showh1(int ScrJ,int ScrI)               /* show help as total not */
{                                            /* enough for a page      */
   int i;                                    /* or specific top of help */
   Clrscr();
   gotoxy(1,HelpFirst);
   for(i=ScrJ;i<ScrJ+HelpPAGEL && i<Total_Help_Line;i++)
      printf("%s\n",&HelpBuf[IndexOfHelp[i]]);
   if(i>=Total_Help_Line)
      for(;i<ScrJ+HelpPAGEL;i++)printf("\n");
   HelpMark(ScrI-ScrJ+HelpFirst);
}
void showh2(int ScrJ,int ScrI)                  /* show help  only mark */
{                                               /* different position   */
   HelpMark(ScrI-ScrJ+HelpFirst);
}
void showh3(int ScrJ,int ScrI)                  /* show help Up scroll */
{
   window(1,HelpFirst,80,HelpFirst+HelpPAGEL-1);
   gotoxy(1,1);
   delline();
   gotoxy(1,HelpPAGEL);
   if(Total_Help_Line-ScrJ>=HelpPAGEL)
      printf("%s\n",&HelpBuf[IndexOfHelp[ScrJ+HelpPAGEL-1]]);
   else
      printf("\n");
   window(1,1,80,25);
   HelpMark(ScrI-ScrJ+HelpFirst);
}
void showh4(int ScrJ,int ScrI)                  /* show help Down Scroll */
{
   window(1,HelpFirst,80,HelpFirst+HelpPAGEL-1);
   gotoxy(1,HelpPAGEL);
   delline();
   gotoxy(1,1);
   insline();
   gotoxy(1,1);
   printf("%s\n",&HelpBuf[IndexOfHelp[ScrJ]]);
   window(1,1,80,25);
   HelpMark(ScrI-ScrJ+HelpFirst);
}
void ShowHelpInfo(int ScrI)
{
   Message(0,0,0,"ШϥδӬdݻAESC BF8 ^ɡC");
   gotoxy(63,25);
   printf("@%4d %4d",Total_Help_Line,ScrI+1);
}
void NoHelpFound(int *ScrJ,int *ScrI)
{
   Clrscr();
   *ScrJ=*ScrI=0;
   ShowHelpInfo(*ScrI);
   showh2(*ScrJ,*ScrI);
}
void ShowHelp(int *ScrJ,int *ScrI,int keystroke)
{                                                 /* ScrJ -- Top Line No */
   static int  totalpages;                        /* ScrI -- Current Line No */
   void  (*showh)();
   char  cmdflag;
   int   tmpI;

   if(Total_Help_Line==0){ NoHelpFound(ScrJ,ScrI);return; }
   totalpages=((Total_Help_Line%HelpPAGEL == 0) ? Total_Help_Line/HelpPAGEL : Total_Help_Line/HelpPAGEL+1) ;

   UnMarkLine(*ScrI-*ScrJ+HelpFirst);                  /* need unmark line first */
   cmdflag=0;showh=showh2;
   switch(keystroke)
   {
      case Up     :  if(*ScrI<=0)break;             /* top already */
                     cmdflag=1;
                     if(*ScrJ==*ScrI)                /* current at the top */
                        *ScrJ-=1, *ScrI-=1, showh=showh4;
                     else
                        *ScrI-=1,           showh=showh2;
                     break;
      case Down   :  if(*ScrI>=Total_Help_Line-1)break;    /* end already */
                     cmdflag=1;
                     if(*ScrI-*ScrJ==HelpPAGEL-1)    /* current at the bottom */
                        *ScrJ+=1, *ScrI+=1, showh=showh3;
                     else
                        *ScrI+=1,           showh=showh2;
                     break;
      case Home   :  if(*ScrI==*ScrJ)break;       /* current at the top already */
                     cmdflag=1;
                     *ScrI=*ScrJ,  showh=showh2;
                     break;
      case End    :  if(*ScrI-*ScrJ==HelpPAGEL-1)break;  /* current at the bottom already */
                     cmdflag=1;
                     *ScrI=*ScrJ+HelpPAGEL-1,
                     *ScrI=((*ScrI>=Total_Help_Line-1)?Total_Help_Line-1:*ScrI), showh=showh2;
                     break;
      case C_Home :  if(*ScrI==0)break;          /* current at home already */
                     cmdflag=1;
                     if(*ScrJ==0)                /* at the first page */
                        *ScrI=0,         showh=showh2;
                     else
                        *ScrJ=0, *ScrI=0, showh=showh1;
                     break;
      case C_End  :  if(*ScrI==Total_Help_Line-1)break; /* current at the end already */
                     cmdflag=1;
                     if(*ScrJ>=Total_Help_Line-HelpPAGEL && Total_Help_Line>*ScrJ)   /* at the end page */
                        *ScrI=Total_Help_Line-1,            showh=showh2;
                     else
                        *ScrJ=((Total_Help_Line-HelpPAGEL<0)?0:Total_Help_Line-HelpPAGEL), *ScrI=Total_Help_Line-1, showh=showh1;
                     break;
      case PgUp   :  if(*ScrJ==0 && *ScrI==0)break;/* at the top already */
                     cmdflag=1;
                     if(*ScrJ==0)   /* at the first page */
                        *ScrI=0, showh=showh2;
                     else
                     {
                        tmpI=*ScrI-*ScrJ;
                        *ScrJ-=HelpPAGEL-1;             /* turn 1 page */
                        *ScrJ=(*ScrJ<0)?0:*ScrJ;
                        *ScrI=*ScrJ+tmpI;
                        showh=showh1;
                     }
                     break;
      case PgDn   :  if(*ScrJ>=Total_Help_Line-HelpPAGEL && Total_Help_Line>*ScrJ && *ScrI==Total_Help_Line-1)break;/* at the end already */
                     cmdflag=1;
                     if(*ScrJ>=Total_Help_Line-HelpPAGEL && Total_Help_Line>*ScrJ)   /* at the end page */
                        *ScrI=Total_Help_Line-1,            showh=showh2;
                     else
                     {
                        tmpI=*ScrI-*ScrJ;
                        *ScrJ+=HelpPAGEL-1;             /* turn 1 page */
                        *ScrJ=(*ScrJ>Total_Help_Line-HelpPAGEL)?Total_Help_Line-HelpPAGEL:*ScrJ;
                        *ScrI=*ScrJ+tmpI;
                        *ScrI=((*ScrI>=Total_Help_Line-1)?Total_Help_Line-1:*ScrI);
                        showh=showh1;
                     }
                     break;
      case C_PgUp :  if(*ScrJ==0)break;          /* at the first page already */
                     cmdflag=1;
                     tmpI=*ScrI-*ScrJ;
                     *ScrJ-=(HelpPAGEL-1)*5;         /* turn 5 page */
                     *ScrJ=(*ScrJ<0)?0:*ScrJ;
                     *ScrI=*ScrJ+tmpI;
                     showh=showh1;
                     break;
      case C_PgDn :  if(*ScrJ>=Total_Help_Line-HelpPAGEL)break;/* at the end page already */
                     cmdflag=1;
                     tmpI=*ScrI-*ScrJ;
                     *ScrJ+=(HelpPAGEL-1)*5;         /* turn 5 page */
                     *ScrJ=(*ScrJ>Total_Help_Line-HelpPAGEL)?Total_Help_Line-HelpPAGEL:*ScrJ;
                     *ScrI=*ScrJ+tmpI;
                     *ScrI=((*ScrI>=Total_Help_Line-1)?Total_Help_Line-1:*ScrI);
                     showh=showh1;
                     break;
      case 0      :  cmdflag=1;                 /* I.C. at the current pos */
                     Clrscr();
                     *ScrJ=(*ScrJ>Total_Help_Line-HelpPAGEL)?Total_Help_Line-HelpPAGEL:*ScrJ;
                     *ScrI=(*ScrI>Total_Help_Line-1    )?Total_Help_Line      :*ScrI;
                     *ScrJ=(*ScrJ<0)?0:*ScrJ;
                     *ScrI=(*ScrI<0)?0:*ScrI;
                     showh=showh1;
                     break;
   }
   showh(*ScrJ,*ScrI);
   if(cmdflag==0)return;            /* other key input */
   ShowHelpInfo(*ScrI);
}
void Help(char *HelpFilename,char **CharIndex,int HelpItem)
{
   char *HelpIndexString;
   char *scrbuf;
   int II,JJ;                       /* JJ -- first line, II -- current line */
   int ch;

   if(InitHelp(HelpFilename)!=OK) return;
   HelpIndexString=(char *)calloc(7,sizeof(char)); /* Max 30 Index */
   scrbuf=(char *)calloc(80*24*2,sizeof(char));
   gettext(1,1,80,24,scrbuf);
   if(HelpItem>0 && HelpItem<30)
   {
      if(HelpItem/20>=1)               /* three digit */
      {
         strcpy(HelpIndexString,CharIndex[9]);
         strcat(HelpIndexString,CharIndex[9]);
         if(HelpItem!=20)
            strcat(HelpIndexString,CharIndex[(HelpItem%20)-1]);
      }
      else  if(HelpItem/10>=1)         /* two digit */
            {
               strcpy(HelpIndexString,CharIndex[9]);
               if(HelpItem!=10)
                  strcat(HelpIndexString,CharIndex[(HelpItem%10)-1]);
            }
            else                       /* one digit */
               strcpy(HelpIndexString,CharIndex[HelpItem-1]);
      JJ=strlen(HelpIndexString);
      for(II=0;II<=Total_Help_Line;II++)
         if(strncmp(HelpIndexString,&HelpBuf[IndexOfHelp[II]],JJ)==0)break;
      if(II==Total_Help_Line+1) II=0;         /* not found */
      JJ=II;
   }
   else
      JJ=II;
   ch=0;
   while(ch!=Esc && ch!=F8)
   {
      ShowHelp(&II,&JJ,ch);
      ch=bioskey(0);
   }
   OffHelp();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   free(HelpIndexString);
}
/******************************************************************************
void HelpColor(int FFFF,int BBBB);
void HelpMark(char ScrII);
char InitHelp(char *HelpFile);
void OffHelp(void);
void showh1(int ScrJ,int ScrI);
void showh2(int ScrJ,int ScrI);
void showh3(int ScrJ,int ScrI);
void showh4(int ScrJ,int ScrI);
void ShowHelpInfo(int ScrI);
void NoHelpFound(int *ScrJ,int *ScrI);
void ShowHelp(int *ScrJ,int *ScrI,int keystroke);
void Help(char *HelpFilename,char *CharIndex,int HelpItem);
******************************************************************************/
