/*****************************************************************************/
/* DYNAMIC_.C  the test of TWO Dimensions array  (Dyanmic Allocate Memory)   */
/*****************************************************************************/

#include<alloc.h>
#include<mem.h>
#include<dos.h>
#include"lee_sub.i"

typedef struct
   {
      void far *base;
      void far * far *main;
   } TWO_D;

void far **TwoD(TWO_D *ptr,unsigned size,unsigned size1,unsigned size2)
{
   char far *index;
   unsigned index_seg;
   unsigned index_off;
   unsigned i;

   ptr->main=(void far * far *)farcalloc(size1,sizeof(void far *));
   ptr->base=(void far *)farcalloc(size1,size*size2);
   if(ptr->base==(void far *)NULL)
   {
      farfree(ptr->main);
      return (void far **)NULL;
   }

   index=(char far *)ptr->base;
   for(i=0;i<size1;i++)
   {
      ptr->main[i]=(void far *)index;
      index+=size*size2;
      index_off=FP_OFF(index);
      index_seg=FP_SEG(index);
      index=MK_FP(index_seg+(index_off>>4),index_off%16);
   }
   return (void far **)ptr->main;
}
void FreeTwoD(TWO_D *ptr)
{
   farfree(ptr->base);
   farfree(ptr->main);
}

typedef struct
   {
      void far *base1;
      void far * far *base2;
      void far * far * far *main;
   } THREE_D;

void far ***ThreeD(THREE_D *ptr,unsigned size,unsigned size1,unsigned size2,unsigned size3)
{
   char far *index;
   unsigned index_seg;
   unsigned index_off;
   unsigned i;

   ptr->main =(void far * far * far *)farcalloc(size1,sizeof(void far * far *));
   ptr->base2=(void far * far *)farcalloc(size1,sizeof(void far *));
   ptr->base1=(void far *)farcalloc(size1,size*size2);
   if(ptr->base1==(void far *)NULL)
   {
      farfree(ptr->main);
      farfree(ptr->base2);
      return (void far **)NULL;
   }

   index=(char far *)ptr->base;
   for(i=0;i<size1;i++)
   {
      ptr->main[i]=(void far *)index;
      index+=size*size2;
      index_off=FP_OFF(index);
      index_seg=FP_SEG(index);
      index=MK_FP(index_seg+(index_off>>4),index_off%16);
   }
   return (void far **)ptr->main;
}
void FreeTwoD(TWO_D *ptr)
{
   farfree(ptr->base);
   farfree(ptr->main);
}

main()
{
   TWO_D t;
   int far **array2;
   int i,j;

   printf("\nmemonry left = %lu",farcoreleft());
   array2=(int far **)TwoD(&t,sizeof(int),10,20);
   printf("\nmemonry left = %lu\n",farcoreleft());

   for(i=0;i<10;i++)
      for(j=0;j<20;j++)
         array2[i][j]=j+20*(i+1);

   for(i=0;i<10;i++)
      for(j=0;j<20;j++)
         printf("%4d",array2[i][j]);

   FreeTwoD(&t);
   printf("\nmemonry left = %lu",farcoreleft());
}
