/*****************************************************************************/
/* FRAME.C     Drawing Frame in CHINESE Mode and ENGLISH Mode                */
/*****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "lee_sub.i"
/* Frame : draw frame (english four modes ) */
void Frame(char left,char top,char right,char bottom,char mode)
{
   char  i;
   char  topleft,topright,bottomleft,bottomright,v,h;
   char  x=wherex(),y=wherey();

   gotoxy(left,top);
   switch(mode)
   {
      case 1:  topleft     = '';
               topright    = '';
               bottomleft  = '';
               bottomright = '';
               v           = '';
               h           = '';
               break;
      case 2:  topleft     = '';
               topright    = '';
               bottomleft  = '';
               bottomright = '';
               v           = '';
               h           = '';
               break;
      case 3:  topleft     = '';
               topright    = '';
               bottomleft  = '';
               bottomright = '';
               v           = '';
               h           = '';
               break;
      case 4:
      default: topleft     = '';
               topright    = '';
               bottomleft  = '';
               bottomright = '';
               v           = '';
               h           = '';
               break;
   }
   putch(topleft);
   for(i=left+1;i<right;i++)
      gotoxy(i,top),putch(h),gotoxy(i,bottom),putch(h);
   for(i=top+1;i<bottom;i++)
      gotoxy(left,i),putch(v),gotoxy(right,i),putch(v);
   gotoxy(right,bottom),putch(bottomright);
   gotoxy(right,top),putch(topright);
   gotoxy(left,bottom),putch(bottomleft);
   gotoxy(x,y);
}

/* CFrame : draw frame (chinese seven modes ) */
void CFrame(char left,char top,char right,char bottom,char mode)
{
   char  i;
   char  topleft[2],topright[2],bottomleft[2],bottomright[2],v[2],h[2];
   char  x=wherex(),y=wherey();

   switch(mode)
   {
      case 1:  topleft[0]     = '';  topleft[1]     = '';    /*    */
               topright[0]    = '';  topright[1]    = '';    /*    */
               bottomleft[0]  = '';  bottomleft[1]  = '';    /*    */
               bottomright[0] = '';  bottomright[1] = '';    /*    */
               v[0]           = '';  v[1]           = '';    /*    */
               h[0]           = '';  h[1]           = '';    /*    */
               break;
      case 2:  topleft[0]     = '';  topleft[1]     = '';    /*    */
               topright[0]    = '';  topright[1]    = '';    /*    */
               bottomleft[0]  = '';  bottomleft[1]  = '';    /*    */
               bottomright[0] = '';  bottomright[1] = '';    /*    */
               v[0]           = '';  v[1]           = 'x';    /*  x  */
               h[0]           = '';  h[1]           = '';    /*    */
               break;
      case 3:  topleft[0]     = '';  topleft[1]     = '';    /*    */
               topright[0]    = '';  topright[1]    = '';    /*    */
               bottomleft[0]  = '';  bottomleft[1]  = '';    /*    */
               bottomright[0] = '';  bottomright[1] = '';    /*    */
               v[0]           = '';  v[1]           = '';    /*    */
               h[0]           = '';  h[1]           = 'w';    /*  w  */
               break;
      case 4:  topleft[0]     = '';  topleft[1]     = '~';    /*  ~  */
               topright[0]    = '';  topright[1]    = '';    /*    */
               bottomleft[0]  = '';  bottomleft[1]  = '';    /*    */
               bottomright[0] = '';  bottomright[1] = '';    /*    */
               v[0]           = '';  v[1]           = 'x';    /*  x  */
               h[0]           = '';  h[1]           = 'w';    /*  w  */
               break;
      case 5:  topleft[0]     = '';  topleft[1]     = '';    /*    */
               topright[0]    = '';  topright[1]    = '';    /*    */
               bottomleft[0]  = '';  bottomleft[1]  = '';    /*    */
               bottomright[0] = '';  bottomright[1] = '';    /*    */
               v[0]           = '';  v[1]           = '';    /*    */
               h[0]           = '';  h[1]           = '';    /*    */
               break;
      case 6:  topleft[0]     = '';  topleft[1]     = 'i';    /*  i  */
               topright[0]    = '';  topright[1]    = 'n';    /*  n  */
               bottomleft[0]  = '';  bottomleft[1]  = 'i';    /*  i  */
               bottomright[0] = '';  bottomright[1] = 'n';    /*  n  */
               v[0]           = '';  v[1]           = 'n';    /*  n  */
               h[0]           = '';  h[1]           = 'i';    /*  i  */
               break;
      default:
      case 7:  topleft[0]     = '';  topleft[1]     = 'z';    /*  z  */
               topright[0]    = '';  topright[1]    = '{';    /*  {  */
               bottomleft[0]  = '';  bottomleft[1]  = '|';    /*  |  */
               bottomright[0] = '';  bottomright[1] = '}';    /*  }  */
               v[0]           = '';  v[1]           = 'x';    /*  x  */
               h[0]           = '';  h[1]           = 'w';    /*  w  */
               break;
   }
   gotoxy(left,top),putch(topleft[0]),putch(topleft[1]);
   for(i=left+2;i<right;i=i+2)
      gotoxy(i,top),putch(h[0]),putch(h[1]),gotoxy(i,bottom),putch(h[0]),putch(h[1]);
   for(i=top+1;i<bottom;i++)
      gotoxy(left,i),putch(v[0]),putch(v[1]),gotoxy(right,i),putch(v[0]),putch(v[1]);
   gotoxy(right,bottom),putch(bottomright[0]),putch(bottomright[1]);
   gotoxy(right,top),putch(topright[0]),putch(topright[1]);
   gotoxy(left,bottom),putch(bottomleft[0]),putch(bottomleft[1]);
   gotoxy(x,y);
}

void Clear_Frame(char left,char top,char right,char bottom)
{
   struct text_info R;
   gettextinfo(&R);

   window(left,top,right,bottom);
   clrscr();

   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(R.curx,R.cury);
}

#define SCR_LENGTH 2000
void Afill(char far *farptr,unsigned char Attribute)
{
   int addr;
   for(addr=0;addr<SCR_LENGTH;addr++)
      *(farptr + addr*2) = Attribute;
}
void Bfill(unsigned char Attribute)
{
   char far *farptr;
   if(VideoMode()==7) farptr = (char far *)0xB0000001;
   else               farptr = (char far *)0xB8000001;
   Afill(farptr,Attribute);
}
void ALfill(char Fline,char far *farptr,unsigned char Attribute)
{
   int addr;
   for(addr=80*(Fline-1);addr<80*Fline;addr++)
      *(farptr + addr*2) = Attribute;
}
void BLfill(char Fline,unsigned char Attribute)
{
   char far *farptr;
   if(VideoMode()==7) farptr = (char far *)0xB0000001;
   else               farptr = (char far *)0xB8000001;
   ALfill(Fline,farptr,Attribute);
}
void ABfill(char ScrL,char ScrT,char ScrR,char ScrB,char far *farptr,unsigned char Attribute)
{
   int addr;
   char Fline;
   for(Fline=ScrT-1;Fline<ScrB;Fline++)
      for(addr=80*Fline+ScrL-1;addr<80*Fline+ScrR;addr++)
         *(farptr + addr*2) = Attribute;
}
void BBfill(char ScrL,char ScrT,char ScrR,char ScrB,unsigned char Attribute)
{
   char far *farptr;
   if(VideoMode()==7) farptr = (char far *)0xB0000001;
   else               farptr = (char far *)0xB8000001;
   ABfill(ScrL,ScrT,ScrR,ScrB,farptr,Attribute);
}
void GetLineText(char *texttmp,char textline)
{
   char far *farptr;
   int  addr;
   char i;
   if(VideoMode()==7) farptr = (char far *)0xB0000000;
   else               farptr = (char far *)0xB8000000;
   for(i=0,addr=80*(textline-1);addr<80*textline;addr++,i++)
      texttmp[i] = (*(farptr + addr*2) == 0) ? ' ' : *(farptr + addr*2) ;
   texttmp[i] = '\0';
}
void GetLineTextBuf(char *texttmp,char textline,char *textbuf)
{
   int  addr;
   char i;
   for(i=0,addr=80*(textline-1);addr<80*textline;addr++,i++)
      texttmp[i] = (*(textbuf + addr*2) == 0) ? ' ' : *(textbuf + addr*2) ;
   texttmp[i] = '\0';
}
