/*****************************************************************************/
/* KEYIO.C     Keyboard/Screan Input/Output  Interface                       */
/*****************************************************************************/
/* Used        Cursor(), and include file KEYCODE.II                         */
/*****************************************************************************/

#include<alloc.h>
#include<bios.h>
#include<conio.h>
#include<ctype.h>
#include<stdio.h>
#include<string.h>
#include"keycode.ii"
#include"lee_sub.i"

int InvertF=YELLOW;     /* 112 */
int InvertB=BLUE;       /*   7 */
int WNormalF=LIGHTGRAY;  /*   7 */
int WNormalB=BLACK;      /*   0 */
int FNUM=5;

void GetWordColor(int FFFF,int BBBB)  { InvertF=FFFF; InvertB=BBBB; }
void ShowWordColor(int FFFF,int BBBB) { WNormalF=FFFF; WNormalB=BBBB; }

int  GetWordsAll(char *word,int ScrX,int ScrY,int Long,char Wflag,char Dflag)
{                                                  /* Wflag=0 clear old */
   int  i;     /* Current Position */              /* Wflag=1 keep old  */
   int  j;     /* End Word Position */             /* Wflag=2 draw line */
   int  k,l;                                       /* Dflag=1 digital input */
   int  ch;    /* Get BiosKey */
   char insflag=(0x0080 & bioskey(2))?1:0;
   char prelong=(strlen(word)>Long)?Long:strlen(word);
   int Tx=wherex(),Ty=wherey();                    /* Get current Pos */
   int samepos=0;

   if(insflag)Cursor(2);else Cursor(1);            /* Check if INS */
   if(Tx==ScrX&&Ty==ScrY)samepos=1;                /* if not the same pos */
   if(samepos==0)gotoxy(ScrX,ScrY);                /* change position */
   if(Wflag==2)                                    /* Set layout color */
      textcolor(WNormalF), textbackground(WNormalB);
   else
      textcolor(InvertF), textbackground(InvertB);
   for(i=0;i<prelong && Wflag!=0;i++)putch(word[i]);/* Draw words to the end */
   for(;i<Long;i++)putch(' ');
   if(Wflag==2)return(0);                          /* Draw Ok return */
   gotoxy(ScrX+prelong,ScrY);                      /* goto END position */

/* i=j=prelong;                                 */ /* i,j = 0 to Long */
   gotoxy(ScrX,ScrY);
   i=0;
   j=prelong;

/* Tx=wherex();Ty=wherey();            /* Check */
   gotoxy(1,20);
   printf("I=%2d J=%2d \nword=",i,j);puts(word);
   gotoxy(Tx,Ty);*/

   while(1)
   {
      switch(ch=bioskey(0))
      {
         case Enter:                            /* Exit Key Code */
         case F2:
         case Up:
         case Down:
         case Tab:
         case S_Tab:
         case Esc:
           for(;j<=Long;j++)word[j]='\0';       /* Set other char to NULL */
           return (ch);

         case BackSpace:
            if(i>0)
            {
               i=wherex()-ScrX-1;
               j=(j>i)?j-1:i;
               gotoxy(ScrX+i,ScrY);
               for(k=i;k<j;k++)
               {
                  word[k]=word[k+1];
                  putch(word[k]);
               }
               word[k]='\0';putch(' ');
               gotoxy(ScrX+i,ScrY);
            }
            break;
         case Del:
            if(i>=0)
            {
               i=wherex()-ScrX;
               j=(j>i)?j-1:i;
               gotoxy(ScrX+i,ScrY);
               for(k=i;k<j;k++)
               {
                  word[k]=word[k+1];
                  putch(word[k]);
               }
               word[k]='\0';putch(' ');
               gotoxy(ScrX+i,ScrY);
            }
            break;
/*         case Esc:                            /* Clear strings */
            gotoxy(ScrX,ScrY);
            for(k=0;k<Long;k++)putch(' ');
            gotoxy(ScrX,ScrY);
            i=0;j=0;word[0]='\0';
            break;      */
         case Home:
            gotoxy(ScrX,ScrY);
            i=0;
            break;
         case End:
            for(k=Long;k>=0;k--)
               if(word[k]!='\0' && word[k]!=' ')
                  break;
            i=j=(word[k]=='\0' || word[k]==' ')?k:k+1;
            gotoxy(ScrX+j,ScrY);
            break;
         case Left:
            if(i!=0)
            {
               gotoxy(wherex()-1,ScrY);
               i-=1;
            }
            break;
         case Right:
            if(i<Long)
               if(i<j)                          /* Digital input */
               {
                  gotoxy(wherex()+1,ScrY);
                  i+=1;
               }
               else if(Dflag!=1)                /* Acsii input */
               {
                  word[i]=' ';
                  putch(' ');
                  i+=1;
                  j+=1;
               }
            break;
         case Ins:
            insflag=(0x0080 & bioskey(2))?1:0;  /* Check INS */
            if(insflag)Cursor(2);else Cursor(1);
            break;
         case SpaceBar:             /* Send '0' in Digital input */
            if(Dflag==1)ch='\x30\x0B';
         default:
            if(Dflag==1 && isdigit((char)ch)==0)break;
            if((char)ch!=0 && i!=Long)
            {
               if(!insflag)            /* Replace */
               {
                     word[i]=(char)ch;
                     if(j==Long)word[Long]='\0';
                     i++;j=(i>j)?i:j;
                     putch(ch);
               }
               else                    /* Insert */
               {
                     for(k=j-1;k>=i;k--)word[k+1]=(k+1>=Long)?'\0':word[k];
                     word[i]=(char)ch;
                     gotoxy(ScrX+i,ScrY);
                     i++;j=(j>=Long)?Long:j+1;
                     for(k=i-1;k<j;k++)putch(word[k]);
                     gotoxy(ScrX+i,ScrY);
               }
            }
            break;
      }

/*    Tx=wherex();Ty=wherey();      /* Check */
      gotoxy(1,20);
      printf("I=%2d J=%2d \n",i,j);
      puts("                                                                             ");
      gotoxy(1,21);
      printf("word=");puts(word);
      gotoxy(Tx,Ty);       */
   }
}

int  GetNewWords(char *word,int ScrX,int ScrY,int Long)
{
   word[0]='\0';
   return GetWordsAll(word,ScrX,ScrY,Long,0,0);
}
int  DGetNewWords(char *word,int ScrX,int ScrY,int Long)
{
   word[0]='\0';
   return GetWordsAll(word,ScrX,ScrY,Long,0,1);
}
int  GetWords(char *word,int ScrX,int ScrY,int Long)
{
   return GetWordsAll(word,ScrX,ScrY,Long,1,0);
}
int  DGetWords(char *word,int ScrX,int ScrY,int Long)
{
   return GetWordsAll(word,ScrX,ScrY,Long,1,1);
}
void DrawWords(int ScrX,int ScrY,int Long)
{
   GetWordsAll("",ScrX,ScrY,Long,2,0);
}
void FDrawWords(int ScrX,int ScrY,char *fword)
{
   GetWordsAll(fword,ScrX,ScrY,strlen(fword),2,0);
}
void DrawWords2(char *word,int ScrX,int ScrY,int Long)
{
   GetWordsAll(word,ScrX,ScrY,Long,2,0);
}
int  GetWordsNotShow(char *word,int Long,int *CurrPos,char Dflag)
{
   int  i;     /* Current Position */
   int  j;     /* End Word Position */
   int  k;
   int  ch,ch2;/* Get BiosKey */
   char insflag=(0x0080 & bioskey(2))?1:0;      /* Check INS */
   char prelong=(strlen(word)>Long)?Long:strlen(word);

   if(insflag)Cursor(2);else Cursor(1);         /* Change cursor size */

   i=*CurrPos;
   j=prelong;                        /* i,j = 0 to Long-1 word[Long]='\0' */

   switch(ch2=ch=bioskey(0))
   {
   /* case Enter:                   /* Exit Key Code */
      case Up:
      case Down:
      case Tab:
      case S_Tab:
      case Esc:
         break;*/

      case BackSpace:
         if(i>0)
         {
            i-=1;
            j=(j>i)?j-1:i;
            for(k=i;k<j;k++)
               word[k]=word[k+1];
            word[k]='\0';
         }
         break;
      case Del:
         if(i>=0)
         {
            for(k=i;k<j;k++)
               word[k]=word[k+1];
            word[k]='\0';
            j=(j>i)?j-1:i;
         }
         break;
/*    case Esc:                        /* Clear Strings */
         i=0;j=0;word[0]='\0';
         break;*/
      case Home:
         i=0;
         break;
      case End:
         for(k=Long;k>0;k--)
            if(word[k]!='\0' && word[k]!=' ')
               break;
         i=j=(word[k]=='\0' || word[k]==' ')?k:k+1;
         break;
      case Left:
         if(i!=0)i-=1;
         break;
      case Right:
         if(i<Long)
            if(i<j)
               i+=1;
            else if(Dflag!=1)
            {
               word[i]=' ';
               i+=1;
               j+=1;
            }
         break;
      case Ins:
         insflag=(0x0080 & bioskey(2))?1:0;
         if(insflag)Cursor(2);else Cursor(1);
         break;
      case SpaceBar:                      /* Send '0' in Digital input */
         if(Dflag==1)ch='\x30\x0B';
      default:
         if(Dflag==1 && isdigit((char)ch)==0)break;
         if((char)ch!=0 && i!=Long)
         {
            if(!insflag)                  /* Replace */
            {
               word[i]=(char)ch;
               if(j==Long)word[Long]='\0';
               i++;j=(i>j)?i:j;
            }
            else                          /* Insert */
            {
               for(k=j;k>=i;k--)word[k+1]=(k+1>=Long)?'\0':word[k];
               word[i]=(char)ch;
               i++;j=(j>=Long)?Long:j+1;
            }
         }
         break;
   }
   for(;j<=Long;j++)word[j]='\0';
   *CurrPos=i;
   return (ch2);
}

void GetFormat(char *fword,char *fpos,char *fnum)
{
   char i;
   *fnum=0;
   for(i=0;fword[i];i++)
      if(fword[i]!=' ')fpos[(*fnum)++]=i;
}

void RemoveFormat(char *tword,char *sword,char *fword)
{                                                    /* format must be apart */
   char *fpos;
   char i;
   char j;
   fpos=(char *)calloc(FNUM,sizeof(char));
   GetFormat(fword,fpos,&j);
   if(fpos[0]==0 && fword[0]==' ')
      strcpy(tword,sword);
   else
   {
      for(i=0,j=0;fword[i+j];i++)
         tword[i]=(i+j==fpos[j])?(j+=1,sword[i+j]):sword[i+j];
      tword[i]='\0';
   }
   free(fpos);
}

void ToFormat(char *tword,char *sword,char *fword)
{
   char *fpos;
   char i,j;
   fpos=(char *)calloc(FNUM,sizeof(char));
   GetFormat(fword,fpos,&j);
   if(sword[0]=='\0')
      strcpy(tword,fword);
   else  if(fpos[0]==0 && fword[0]==' ')  /* No Format */
         {
            for(i=0;sword[i];i++);
            for(;fword[i];i++)sword[i]=' ';
            sword[i]='\0';
            strcpy(tword,sword);
         }
         else
         {
            for(i=0,j=0;fword[i];i++)
            tword[i]=(i==fpos[j])?(j+=1,fword[i]):((sword[i-j])?sword[i-j]:' ');
         }
   free(fpos);
}

int  FGetWordsAll(char *tword,char *fword,char ScrX,char ScrY,char Dflag)
{
   char *fpos;
   char fnum;
   int  Long;
   char *rword;
   char Tx,Ty,Cx;
   char samepos;
   int  i;
   char j;
   int  ch;

   Tx=wherex();Ty=wherey();
   if(Tx==ScrX&&Ty==ScrY)samepos=1;
   if(!samepos)gotoxy(ScrX,ScrY);

   Long=strlen(fword)+1;
   fpos=(char *)calloc(FNUM,sizeof(char));
   GetFormat(fword,fpos,&fnum);
   rword=(char *)calloc(Long-fnum,sizeof(char));
   RemoveFormat(rword,tword,fword);
   ToFormat(tword,rword,fword);
   textcolor(InvertF);                             /* Set layout color */
   textbackground(InvertB);
   gotoxy(ScrX,ScrY);
   cprintf("%s",tword);
   gotoxy(ScrX,ScrY);
   i=0;
   while((ch=GetWordsNotShow(rword,Long-fnum-1,&i,Dflag))!=Enter
       && ch!=Up && ch!=Down && ch!=Tab && ch!=S_Tab && ch!=Esc
       && ch!=F2)
   {
      ToFormat(tword,rword,fword);
      gotoxy(ScrX,ScrY);
      cprintf("%s",tword);
      for(j=0,Cx=(char)i;j<fnum;j++)
         Cx=(Cx>=fpos[j])?Cx+1:Cx;
      gotoxy(ScrX+Cx,ScrY);
   }

   if(!samepos)gotoxy(Tx,Ty);
   free(rword);
   free(fpos);
   return (ch);
}
int  FGetWords(char *tword,char *fword,char ScrX,char ScrY)
{
   return FGetWordsAll(tword,fword,ScrX,ScrY,0);
}
int  DFGetWords(char *tword,char *fword,char ScrX,char ScrY)
{
   return FGetWordsAll(tword,fword,ScrX,ScrY,1);
}

/******** KEYIO.C ***************************************** Test Program 1 ****
main(int argc,char *argv[])
{
   char i;
   char fnum;
   char *fpos;
   char *fwords="  /  /  ";
   char *fword;
   char *word;
   char *rword;

   clrscr();
   if(argc<2) fword=fwords;else fword=argv[1];
   fpos=(char *)calloc(FNUM,sizeof(char));
   word=(char *)calloc(strlen(fword)+1,sizeof(char));
   GetFormat(fword,fpos,&fnum);
   rword=(char *)calloc(strlen(fword)+1-fnum,sizeof(char));
   printf("\n%s",fword);
   printf("\n12345678901234567890");
   for(i=0;i<fnum;i++)
      printf("\nformat pos %d = %d",i+1,fpos[i]);
   printf("\nformat number %d\n",fnum);

   textattr('\x1A');
   CopyFormat(word,fword);
   puts("");cprintf(" word=%s",word);
   RemoveFormat(rword,word,fword);
   puts("");cprintf("rword=%s",rword);
   ToFormat(word,rword,fword);
   puts("");cprintf(" word=%s",word);
   puts("");cprintf(" word=");
   FGetWords(word,fword,(char)wherex(),(char)wherey());
   puts("");
   DFGetWords(word,fword,(char)wherex(),(char)wherey());
   normvideo();
   gotoxy(1,20);
   printf("\n word=%s",word);
}
******************************************************************************/
/******** KEYIO.C ***************************************** Test Program 2 ****
main(int argc,char *argv[])
{
   char *test;
   int  i;
   int  Long=70;
   test=(char *)calloc(1,Long);

   for (i=0;i<argc;i++)
       printf("\nargc=%d  argv[%d]=%s",i,i,argv[i]);

   if (argc>2)
   {
      InvertB=atoi(argv[1]);
      if (argc>3)
        InvertF=atoi(argv[2]);
   }

   Cursor(1);
   printf("\nBiosKey() testing... Enter to Abort.\n");
   while((i=bioskey(0))!=Enter)
   {
      printf("\nkeycode=%5d %06X to char=%c %06X",i,i,(char)i,(char)i);
   }
   clrscr();
   for(i=0;i<5;i++)DrawWords(3,3+i*3,Long);
   for(i=0;i<4;i++)
   {
      GetWords(test,3,3+i*3,Long);
      printf("\n  %s",test);
   }
   for(i=0;i<4;i++)
   {
      DGetWords(test,3,3+i*3,Long);
      printf("\n  %s",test);
   }
   GetNewWords(test,3,3+i*3,Long);
   printf("\n  %s",test);
   free(test);
   Cursor(3);
}
******************************************************************************/
