
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include "lee_sub.i"

void ShowStatus(ET_GRAPHIC a)
{
   int i;
   printf("        width = %8u\n",a.width        );
   printf("       height = %8u\n",a.height       );
   printf("    main_UL_x = %8u\n",a.main_UL_x    );
   printf("    main_UL_y = %8u\n",a.main_UL_y    );
   printf("   main_width = %8u\n",a.main_width   );
   printf("  main_height = %8u\n",a.main_height  );
   printf("  ascii_width = %8u\n",a.ascii_width  );
   printf(" ascii_height = %8u\n",a.ascii_height );
   printf("      vp_UL_x = %8u\n",a.vp_UL_x      );
   printf("      vp_UL_y = %8u\n",a.vp_UL_y      );
   printf("      vp_BR_x = %8u\n",a.vp_BR_x      );
   printf("      vp_BR_y = %8u\n",a.vp_BR_y      );
   printf("        LPR_x = %8u\n",a.LPR_x        );
   printf("        LPR_y = %8u\n",a.LPR_y        );
   printf("         flag = %8u\n",a.flag         );
   printf("    MaxColors = %8u\n",a.MaxColors    );
   printf("DefaultColor0 = %8u\n",a.DefaultColor0);
   printf("DefaultColor1 = %8u\n",a.DefaultColor1);
   printf("      res[20] = ");
   for(i=0;i<20;i++)
   {
/*      if(i%16==0 && i!=0) printf("\n                ");   */
      printf("%02X ",a.res[i]);
   }printf("\n");
   printf("           ver= %4X\n",a.ver           );
   printf("        comseg= %4X\n",a.comseg        );
   printf("       screenC= %2X\n",a.screenC       );
   printf("      printerC= %2X\n",a.printerC      );
   printf("  internalcode= %8u\n",a.internalcode  );
   printf("     inputcode= %8u\n",a.inputcode     );
   printf("  hardwardflag= %8u\n",a.hardwardflag  );
   printf("hardwardscroll= %8u\n",a.hardwardscroll);
   printf("     font24x24= %8u\n",a.font24x24     );
   printf("     pureascii= %8u\n",a.pureascii     );
}

void CenterCwords2(CWORDS *C,char *words,int rows,int limitrows)
{
   int  slen=strlen(words);
   int  tspace;
   int  i,c,e;
   int  size;

   C->words=words;
   C->mode='o';
   if(rows<=1)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(ETen.main_width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=(ETen.ascii_height-ETen.ascii_width*2)/2;
      C->scry=(C->scry<0)?0:C->scry;
      return;
   }

   size=((rows*ETen.ascii_height)/24)*24;
   while(size*slen*0.5>ETen.main_width)size-=24;
   while(size>limitrows*ETen.ascii_height)size-=24;
   if(size<24)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(ETen.main_width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=((ETen.ascii_height*rows-C->size)/2)/ETen.ascii_height*ETen.ascii_height;
      C->scry=(C->scry<0)?0:C->scry;
      return;
   }

   C->size=size;
   tspace=(slen==1)?0:((ETen.main_width - (C->size/2)*slen)/(slen-1));
   tspace=(tspace>80)?80:tspace;
   tspace=(tspace<0)?0:tspace;
   C->space=tspace;
   if(slen<2)e=1,c=0;
   else
      for(i=0,e=0,c=0;i<slen;i++)
         if(CwordInString(words,i)==1)c++,i++;
         else                         e++;
   if(ETen.ver>=0x3500)                            /* ET v3.5 or later  fixed */
   {
      tspace=e+c;
      tspace-=1;
   }
   else
   {
      tspace=e+c+c;
      if(slen>=2 && CwordInString(words,slen-2)==1) tspace-=2;
      else                                          tspace-=1;
   }
   C->scrx=(ETen.main_width - (C->size/2)*slen - ((float)C->space*0.5)*(tspace))/2;
   C->scry=(ETen.ascii_height*rows-C->size)/2;
   C->scry=(C->scry<0)?0:C->scry;
   return;
}
void BlockCenterCwords2(CWORDS *C,char *words,int ulx,int uly,int brx,int bry,int limitrows)
{                                      /* ul - upperleft  br - bottomright */
   int  slen=strlen(words);
   int  rows=bry-uly+1;
   int  width=(brx-ulx+1)*ETen.ascii_width;
   int  tspace;
   int  i,c,e;
   int  size;

   C->words=words;
   C->mode='o';
   if(rows<=1)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=(ETen.ascii_height-ETen.ascii_width*2)/2;
      C->scry=(C->scry<0)?0:C->scry;
      C->scry+=(uly-1)*ETen.ascii_height;
      C->scrx+=(ulx-1)*ETen.ascii_width;
      return;
   }

   size=((rows*ETen.ascii_height)/24)*24;
   while(size*slen*0.5>width)size-=24;
   while(size>limitrows*ETen.ascii_height)size-=24;
   if(size<24)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=((ETen.ascii_height*rows-C->size)/2)/ETen.ascii_height*ETen.ascii_height;
      C->scry=(C->scry<0)?0:C->scry;
      C->scry+=(uly-1)*ETen.ascii_height;
      C->scrx+=(ulx-1)*ETen.ascii_width;
      return;
   }

   C->size=size;
   tspace=(slen==1)?0:((width - (C->size/2)*slen)/(slen-1));
   tspace=(tspace>80)?80:tspace;
   tspace=(tspace<0)?0:tspace;
   C->space=tspace;
   if(slen<2)e=1,c=0;
   else
      for(i=0,e=0,c=0;i<slen;i++)
         if(CwordInString(words,i)==1)c++,i++;
         else                         e++;
   if(ETen.ver>=0x3500)                            /* ET v3.5 or later  fixed */
   {
      tspace=e+c;
      tspace-=1;
   }
   else
   {
      tspace=e+c+c;
      if(slen>=2 && CwordInString(words,slen-2)==1) tspace-=2;
      else                                          tspace-=1;
   }
   C->scrx=(width - (C->size/2)*slen - ((float)C->space*0.5)*(tspace))/2;
   C->scry=(ETen.ascii_height*rows-C->size)/2;
   C->scry=(C->scry<0)?0:C->scry;
   C->scry+=(uly-1)*ETen.ascii_height;
   C->scrx+=(ulx-1)*ETen.ascii_width;
   return;
}
void cline(int x1,int y1,int x2,int y2,int colors,char boundflag)
{
   gotoxy(1,1);
   printf("L%d,%d,%d,%d,%d,%c;",x1,y1,x2,y2,colors,((boundflag==1)?'B':' '));
}
main(int argc,char *argv[])
{
   CWORDS CC1;
   int rows;
   if(argc<4)
   {
      printf("..exe  [argv1=r] [argv2=jp] [argv3=jp]\n");
      exit(0);
   }
   InitializeETen();
   clrscr();
/* CenterCwords2(&CC1,argv[1],atoi(argv[2]),atoi(argv[3])); */
   BlockCenterCwords2(&CC1,argv[1],1,1,80,atoi(argv[2])-1,atoi(argv[3]));
   printfXY(1, 6,"123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 ");
   printfXY(1, 7,"         1         2         3         4         5         6         7         8");
   gotoxy(1,8);
   printf("lens =%d\n",strlen(argv[1]));
   printf("words=%s\n",CC1.words);
   printf("size =%d\n",CC1.size );
   printf("scrx =%d\n",CC1.scrx );
   printf("scry =%d\n",CC1.scry );
   printf("space=%d\n",CC1.space);
   printf("mode =%c\n",CC1.mode );
   Cwords(&CC1);
   gotoxy(1,24);
}
/*----------------------------------------------------------------------------
main(int argc,char *argv[])
{
   CWORDS CC1;
   int rows;
   if(argc<4)
   {
      printf("..exe  [argv1=r] [argv2=jp] [argv3=jp]\n");
      exit(0);
   }
   InitializeETen();
   clrscr();
   rows=atoi(argv[2]);
   BlockCenterCwords2(&CC1,argv[1],10,10,70,10+rows-1,atoi(argv[3]));
   cline((10-1)*ETen.ascii_width,(10-1)*ETen.ascii_height,
         (70)*ETen.ascii_width,  (10+rows-1)*ETen.ascii_height, 13,1);
   gotoxy(1,1);
   printf("lens =%d\n",strlen(argv[1]));
   printf("words=%s\n",CC1.words);
   printf("size =%d\n",CC1.size );
   printf("scrx =%d\n",CC1.scrx );
   printf("scry =%d\n",CC1.scry );
   printf("space=%d\n",CC1.space);
   printf("mode =%c\n",CC1.mode );
   printfXY(1, 8,"         1         2         3         4         5         6         7         8");
   printfXY(1, 9,"123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 ");
   Cwords(&CC1);
   cline((10-1)*ETen.ascii_width,(10-1)*ETen.ascii_height,
         CC1.scrx, (10+rows-1)*ETen.ascii_height, 15,1);
   cline((70+10-1)*ETen.ascii_width-1-CC1.scrx,(10+rows-1)*ETen.ascii_height,
         (70)*ETen.ascii_width,  (10-1)*ETen.ascii_height, 15,1);
   gotoxy(1,24);
}
-----------------------------------------------------------------------------*/
