/*****************************************************************************/
/* LEE_SUB.I   All Sub-Routine Profile and Usage           by Lee Dong Linag */
/*****************************************************************************/
/* If Use ETen Function,  BOOL2 InitializeETen(void)  must be call first !!! */
/*****************************************************************************/


typedef struct
   {
      char Numb;                       /* Number of items */
      char Len;                        /* Length of each item */
      char *Item;                      /* End each item with NULL char */
                                       /* and joining together */
   }  ItemType;

typedef struct
   {
      char  *words;                    /* words to show */
      int   size;                      /* size of chinese words  Txx */
      int   scrx;                      /* show position of X */
      int   scry;                      /* show position of Y */
      char  space;                     /* space between words */
      char  mode;                      /* the mode of show 'o'-> overwrite */
   }  CWORDS;


typedef struct                      /* UL - UpperLeft  BR - BottomRight   */
   {                                /* VP - ViewPort   LPR - Last Pt Ref. */
      unsigned int  width;
      unsigned int  height;
      unsigned int  main_UL_x;
      unsigned int  main_UL_y;
      unsigned int  main_width;
      unsigned int  main_height;
      unsigned int  ascii_width;
      unsigned int  ascii_height;
      unsigned int  vp_UL_x;
      unsigned int  vp_UL_y;
      unsigned int  vp_BR_x;
      unsigned int  vp_BR_y;
      unsigned int  LPR_x;
      unsigned int  LPR_y;
      unsigned char flag;
      unsigned char MaxColors;
      unsigned char DefaultColor0;
      unsigned char DefaultColor1;
      unsigned char res[20];        /* 32 - 12 */
      unsigned int  ver;
      unsigned int  comseg;
      unsigned char screenC;
      unsigned char printerC;
      unsigned char internalcode;
      unsigned char inputcode;
      unsigned char hardwardflag;
      unsigned char hardwardscroll;
      unsigned char font24x24;
      unsigned char pureascii;
   } ET_GRAPHIC;

#ifndef ET_GRAPHICS_STATUS
extern ET_GRAPHIC ETen;
#endif

typedef enum { FALSE, TRUE }  BOOL1;                      /* NotOK  ==  FALSE */
typedef enum { NotOK, OK, ERROR, USERBREAK, OTHER }BOOL2; /*    OK  ==  TRUE  */

/* KEYIO.C */
void GetWordColor(int FFFF,int BBBB);
void ShowWordColor(int FFFF,int BBBB);
int  GetWordsAll(char *words,int ScrX,int ScrY,int Long,char Wflag,char Dflag);
int  GetNewWords(char *words,int ScrX,int ScrY,int Long);
int  GetWords(char *words,int ScrX,int ScrY,int Long);
int  DGetNewWords(char *words,int ScrX,int ScrY,int Long);
int  DGetWords(char *words,int ScrX,int ScrY,int Long);
void DrawWords(int ScrX,int ScrY,int Long);
void DrawWords2(char *word,int ScrX,int ScrY,int Long);
int  GetWordsNotShow(char *word,int Long,int *CurrPos,char Dflag);
void GetFormat(char *fword,char *fpos,char *fnum);
void RemoveFormat(char *tword,char *sword,char *fword);
void ToFormat(char *tword,char *sword,char *fword);
int  FGetWordsAll(char *tword,char *fword,char ScrX,char ScrY,char Dflag);
int  FGetWords(char *tword,char *fword,char ScrX,char ScrY);
int  DFGetWords(char *tword,char *fword,char ScrX,char ScrY);
void FDrawWords(int ScrX,int ScrY,char *fword);
#define CopyFormat(tword,fword)  strcpy((tword),(fword))

/* CHINCODE.C */
char BIG5_Code(char *word);
char Club_Code(char *word);
char ETen_Code(char *word);
char CWord(char *word);
void ChineseInt10(char ch);
char CwordInString(char *word,int offset);
int  NumOfCword(char *word);
BOOL2 ETinfo(unsigned int *etVer,unsigned char *scrCrol,unsigned char *prnCrol);
BOOL2 CheckChineseSystem(void);
void SetChineseInput(void);
void SetEnglishInput(void);
BOOL2 InitializeETen(void);

/* CURSOR.C */
unsigned int  GetCursorSize(void);
void PutCursorSize(unsigned int cursor_size);
void Cursor(int on);
char VideoOriginal(void);
char VideoCombination(void);
char VideoMode(void);
void Clear_KeyBuf(void);
void Insert_Mode(void);
void Replace_Mode(void);
char Get_Insert(void);
void CapsLockON(void);
void CapsLockOFF(void);
char Get_CapsLock(void);
void NumLockON(void);
void NumLockOFF(void);
char Get_NumLock(void);
void ScrollLockON(void);
void ScrollLockOFF(void);
char Get_ScrollLock(void);

/* DOING.C */
void InitDoing(char *startX,char *startY,char *HeaderWord,char *Len,char Cflag);
void Doing(char startX,char startY,char Percent,char Len,char Cflag);
void OffDoing(char startX,char startY,char Len,char Cflag);

/* SELFILE.C */
char DisketteReadReady(char driver);
char DisketteWriteReady(char driver);
long GetDiskState(char Driver,char Fflag);
long GetDiskFreeSpace(char Driver);
long GetDiskMinBlock(char Driver);
void SelectPathFile(int left,int top,int rows,char *Filename,char *FHeader,char *pathfile,char cmode,char fileflag);
void SelectFile(int left,int top,int rows,char *Filename,char *FHeader,char *pathfile,char cmode);
void SelectPath(int left,int top,int rows,char *FHeader,char *pathfile,char cmode);
char FileExist(char *sfilename);
void GetICPath(char *icPath);
void GetPathFile(char *Want_file,char *Path_file,char *fName,char *fExt,char eflag);
void GetPathFileExt(char *Want_file,char *Path_file,char *fExt);
void GetPathFileName(char *Want_file,char *Path_file,char *fName,char *fExt);

/* SCROLL.C */
void LightBarColor(int FFFF,int BBBB);
void SelectedColor(int FFFF,int BBBB);
void NormalColor  (int FFFF,int BBBB);
void ToTextWindow(int number,int length,char *word);    /* Set wintmp[] */
void FreeTextWindow();                                  /* Free wintmp[] */
void SetSelectColor(int left,int top,int right,int bottom,int length,char *word,int *TextI,int *TextJ,int ColorF,int ColorB);
void ShowTextWindowNoColor(int left,int top,int right,int bottom,int length,char *word,int *TextJ);
void ShowTextWindow(int left,int top,int right,int bottom,int length,char *word,int *TextI,int *TextJ);
int  TextWindow(int left,int top,int right,int bottom,int number,int length,char *word,int *TextI,int *TextJ,int *ch,char Backflag);

void ShowTextWindow2NoColor(char **word,int wRow,int fIndex);
void TextWindow2ScrollUp(char *newword);
void TextWindow2ScrollDown(char *newword);
void SetSelectColor2(char selectLine,int FFFF,int BBBB);
int  TextWindow2(char left,char top,char right,char bottom,int number,char **word,int *TextI,int *TextJ,char Backflag);

void ShowTextWindow3NoColor(char **word,int *windex,int wRow,int fIndex);
int  DrawTextWindow3(char left,char top,char right,char bottom,int number,char **word,int *windex,int *TextJ);
int  TextWindow3(char left,char top,char right,char bottom,int number,char **word,int *windex,int *TextI,int *TextJ,char Backflag);
int  TextWindow4(char left,char top,char right,char bottom,int number,char **word,int *TextI,int *TextJ);
int  TextWindow5(char left,char top,char right,char bottom,int number,char **word,int *windex,int *TextI,int *TextJ);

/* FRAME.C */
void Frame(char left,char top,char right,char bottom,char mode);
void CFrame(char left,char top,char right,char bottom,char mode);
void Clear_Frame(char left,char top,char right,char bottom);
void Afill(char far *farptr,unsigned char Attribute);
void Bfill(unsigned char Attribute);
void ALfill(char Fline,char far *farptr,unsigned char Attribute);
void BLfill(char Fline,unsigned char Attribute);
void ABfill(char ScrL,char ScrT,char ScrR,char ScrB,char far *farptr,unsigned char Attribute);
void BBfill(char ScrL,char ScrT,char ScrR,char ScrB,unsigned char Attribute);
void GetLineText(char *texttmp,char textline);
void GetLineTextBuf(char *texttmp,char textline,char *textbuf);

/* MENU.C */
void MenuColor   (int FFFF,int BBBB);
void NormalMColor(int FFFF,int BBBB);
int  CHBmenu(char ScrX,char ScrY,char Space,ItemType *Item,int *Hotkey,int *Otherkey,char Cflag);

/* MENU2.C */
void VRMenuColor   (int FFFF,int BBBB);
void VRNormalMColor(int FFFF,int BBBB);
char CVRmenuOn(ItemType *Item);
void CVRmenuOff(void);
void CVRmenuReturn(char ScrY,char CVRnumb);
int  CVRmenu(char ScrY,ItemType *Item,int *Hotkey,int *Otherkey,char MenuOn);

/* BEDIT.C */
void GetBlockColor(int FFFF,int BBBB);
void ShowBlockColor(int FFFF,int BBBB);
void ShowOneBlockLine(char *word,char width,char bfill);
void LineScrollUp(char *newword,char ScrL,char ScrT,char ScrR,char ScrB);
void LineScrollDown(char *newword,char ScrL,char ScrT,char ScrR,char ScrB);
void DrawBlock(char **word,int wRow,int fIndex);
void InsertLine(char **word,int *wRow,int rIns);
void DeleteLine(char **word,int *wRow,int rDel);
void SplitLine(char **word,int *wRow,int rSplit,char sCol);
int  JoinLine(char **word,int *wRow,int rJoin,char wCol);
int  StringKillBlank(char *word);
int  StringKillBlankBoth(char *word);
int  StringKillBlankAll(char *word);
int  GetLineBlock(char *word,char *cCol,int ScrX,int ScrY,int Long,char fullflag);
int  FindBlockEnd(char **word,int bMaxRow);
int  GetBlock(char **word,int *wRow,int bMaxRow,char ScrL,char ScrT,char ScrR,char ScrB);

/* LAYOUT.C */
void MessageColor(int FFFF,int BBBB);
void DataBaseColor(int FFFF,int BBBB);
void DataLightBarColor(int FFFF,int BBBB);
void Clrscr(void);
void MarkLine(char ScrII);
void UnMarkLine(char ScrII);
void DealWith_fget(char *fgetstring);
void StringKillString(char *src,char *kstr);       /******/
void OneBeep(unsigned int delaytime);
void Message(char beepflag,char blinkflag,char posflag,char *msg, ... );
void MessageOff(void);
void printfXY(char ScrX,char ScrY,char *msg, ... );
void cprintfXY(char ScrX,char ScrY,char *msg, ... );
BOOL2 Ask_Yes(char *askword);
BOOL2 Ask_No(char *askword);
void ToCwords(CWORDS *C,char *words,int size,int scrx,int scry,char space,char mode);
void CenterCwords(CWORDS *C,char *words,int row);     /* Change in CenterCwords (*,*,size) --> (*,*,rows) */
void BlockCenterCwords(CWORDS *C,char *words,int ulx,int uly,int brx,int bry);
void Cwords(CWORDS *C);
void CwordsOff(void);
void CenterCstring(char *dest,char *surc,int cCol);
void CenterCstring2(char *dest,char *surc,int cCol,int maxwspace);
void ShowCenterCstring2(int scrX,int scrY,char *surc,int cCol,int maxwspace);
void Encode1Output(char *s);
char *Decode1(char *t);
char *Encode1(char *t);

/* C_HELP.C */
void HelpColor(int FFFF,int BBBB);
void HelpMark(char ScrII);
char InitHelp(char *HelpFile);
void OffHelp(void);
void showh1(int ScrJ,int ScrI);
void showh2(int ScrJ,int ScrI);
void showh3(int ScrJ,int ScrI);
void showh4(int ScrJ,int ScrI);
void ShowHelpInfo(int ScrI);
void NoHelpFound(int *ScrJ,int *ScrI);
void ShowHelp(int *ScrJ,int *ScrI,int keystroke);
void Help(char *HelpFilename,char **CharIndex,int HelpItem);


/* XMS.C */
#include"\w\lee\xms_lee.i"
typedef struct
   {
      int handle;                /* handle of XMS */
      unsigned long offset;      /* offset of the handle */
   }  XMS;

BOOL2 CopyXms2Xms(XMS *dest,XMS *src,unsigned long clen);
BOOL2 CopyXms2Cnv(void far *dest,XMS *src,unsigned long clen);
BOOL2 CopyCnv2Xms(XMS *dest,void far *scr,unsigned long clen);
BOOL2 CopyCnv2Cnv(void far *dest,void far *scr,unsigned long clen);
BOOL2 CopyXms2XmsI(XMS *dest,XMS *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 CopyXms2CnvI(void far *dest,XMS *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 CopyCnv2XmsI(XMS *dest,void far *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 CopyCnv2CnvI(void far *dest,void far *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 FreeXMS(unsigned long *fxms);
BOOL2 LargestXMS(unsigned long *fxms);
BOOL2 XMSalloc(XMS *dest,unsigned long dlen);
BOOL2 XMSfree(XMS *dest);
BOOL2 GetXMSVer(int *xms_ver);
BOOL2 XMSinstall(void);
BOOL2 XMS_1Dalloc(XMS *dest,unsigned long nelem,unsigned long lelem);
BOOL2 XMS_1Dfree(XMS *dest);

