/*****************************************************************************/
/* MEMAIN.I      All function types and parameters for memain                */
/*****************************************************************************/

#include<alloc.h>
#include<conio.h>
#include<ctype.h>
#include<dos.h>
#include<dir.h>
#include<io.h>
#include<math.h>
#include<process.h>
#include<signal.h>
#include<stdarg.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include"lee_sub.i"
#include"keycode.ii"

typedef struct
   {
      char     ver;                    /* ver=03h dBase III data file */
      char     year;                   /* last modify date - year */
      char     mon;                    /* last modify date - month */
      char     day;                    /* last modify date - day */
      long int total;                  /* total number of records */
      int      header_len;             /* total header length */
      int      record_len;             /* length per record */
   }  DBF_Header;                      /* The Header of *.DBF (dBase III) */

typedef struct
   {
      char delete;                     /* * (2A)  R _ (20)  R */
      char unit;                       /*    A,B,C,D,E,F,G,....       */
      char type;                       /* ڶ   A,B,C                    */
      char person[ 8];                 /* ʤH                          */
      char date  [ 8];                 /*    00/00/00                 */
      char money [10];                 /* B   0000000000               */
      char memo  [40];                 /* Kn                            */
      char remark[20];                 /* Ƶ   ( _ ܪť )           */
   }  MEUNIT;

typedef struct
   {
      int  index;                      /* index in DBF file               */
      char delete;                     /* * (2A)  R _ (20)  R */
      char unit;                       /*    A,B,C,D,E,F,G,....       */
      char type;                       /* ڶ   A,B,C                    */
   }  MEUNITSHOW;

typedef struct
   {
      char ID1[3];                     /* ID1 words = "SAT"               */
      char units;                      /* total number of UNIT_KINDS      */
      char types;                      /* total number of TYPE_KINDS      */
      char ID2[75];                    /* ID2 words = Reserved            */
   }  STATHEAD;                        /* Length of (STATHEAD) = 80       */

typedef struct
   {
      char unit;                       /*    A,B,C,D,E,F,G,....       */
      char type;                       /* ڶ   A,B,C                    */
      char date1 [ 8+1];               /*    00/00/00                 */
      char date2 [ 8+1];               /*    00/00/00                 */
      char person[ 8+1];               /* ʤH                          */
      char memo  [40+1];               /* Kn                            */
      char money [ 8+1];               /* B   0000000000               */
      char money2[ 8+1];               /* B   0000000000               */
      char remark[20+1];               /* Ƶ                      v1.01 */
   }  MEUNITSEARCH;

#define UNIT_KINDS   13
#define TYPE_KINDS    4
#define PAGEL  20
#define First   3

extern char *NoFileSelected;
#ifndef NoExtern
extern FILE *Main_CFG;                  /* system  CFG file pointer */
extern FILE *File_CFG;                  /* current CFG file pointer */
extern FILE *File_DBF;                  /* current DBF file pointer */
extern FILE *File_SAT;                  /* current SAT file pointer */
extern char *IC_Path;                   /* initial PATH of MeMain */
extern char *System_CFG;                /* system  CFG file name */
extern char *Current_CFG;               /* current CFG file name */
extern char *Current_DBF;               /* current DBF file name */
extern char *Current_SAT;               /* current SAT file name */

extern char **unitshort;                /* short name of unit */
extern char far *unitshortbase;         /* memory base - short name of unit */
extern char **unitlong;                 /* long  name of unit */
extern char far *unitlongbase;          /* memory base - long  name of unit */
extern char **typeshort;                /* short name of type */
extern char far *typeshortbase;         /* memory base - short name of type */
extern MEUNITSHOW **ALL;                /* Be a Index */
extern MEUNITSHOW far *ALLbase;         /* Base for *ALL[] */
extern char       far *ALLindex;        /* Index of ALL[] */
extern int   *IndexY;                   /* Index of non-deleted data */
extern int   *IndexN;                   /* Index of deleted data */
extern int   *IndexS;                   /* Index of data to show */
extern char  *TitlePrn;                 /* registed name >=UnitPrn+14 */
extern char  *UnitPrn;                  /* registed name 20 chinese words */

extern long  STSET [UNIT_KINDS][TYPE_KINDS];  /* total available money */
extern long  STALL [UNIT_KINDS][TYPE_KINDS];  /* money used */
extern long  STREST[UNIT_KINDS][TYPE_KINDS];  /* money left */
extern long  STATSET[TYPE_KINDS];       /* stat all   total available money */
extern long  STATALL[TYPE_KINDS];       /* stat all   money used */
extern long  STATREST[TYPE_KINDS];      /* stat all   money left */
extern long  STATERR;                   /* stat all   money of undefined type */

extern char  BeepControlFlag;           /* Beep control flag */
extern char  FlagOfPrinting;            /* Flag of printing data */
extern char  FlagOfPrintBreak;          /* Flag of Break while printing */
extern char  FlagOfBreakPress;          /* Flag of Ctrl-Break Press */
extern char  FlagOfShowingCwords;       /* Flag of Showing Chinese Words */
extern char  FlagOfOpeningDBF;          /* Flag of Opening Current DBF file */
extern int   SleepSeconds;              /* Seconds for Screen Protect */
extern long  DBF_HeaderLen;             /* Header Len of DBF File */
extern char  unit_num;                  /* count number of unit */
extern char  type_num;                  /* count number of type */
extern int   C_IndexY;                  /* Count of IndexY */
extern int   C_IndexN;                  /* Count of IndexN */
extern int   C_IndexS;                  /* Count of IndexS */
extern long  totalnumb;                 /* The Number of Total Records */
extern int   MaxRecords;                /* Maximun Records in a DBF file */
extern long  MemLeft;                   /* Memory Left after Alloc_ALL() */

extern unsigned char Color_Message;
extern unsigned char Color_MenuNormal;
extern unsigned char Color_MenuLightBar;
extern unsigned char Color_DataNormal;
extern unsigned char Color_DataLightBar;
extern unsigned char Color_StringInput;

extern char  YearType;                  /* The type of the year     */
extern char  DisplayType;               /* The type of data display */
extern char  CurrentDataType;           /* Current Data Type flag */
extern char  CurrentSortType;           /* Current Sort Type flag */
extern char  CurrentYearOfDate[2];      /* Current YEAR of the data file  */
extern char  DevicePrinterName[61];     /* Print to ASCII file */
extern int   PrinterPort;               /* Printer Port 0:LPT1  1:LPT2 .. */
extern char  PrinterType;               /* 0 -> Printer   1 -> ASCII file */
extern unsigned char PrinterControlCode;/* Printer Control Code */
extern char  PrinterControlString[45];  /* Printer Control String */
extern char *FullNumb[];                /* Full type of number (CHINESE) */
extern char *FullNumb2[];               /* Full type of number (CHINESE) */
extern char *FullAlpha[];               /* Full type of alpha  (CHINESE) */
#endif

/******** STAT.C  ********/
void ResetMoney(void);
void PlusMoney(MEUNIT *Mtmp);
void MinusMoney(MEUNIT *Mtmp);
void CalculateMoney(void);

/******** UNIO0  .C ********/
void *exit_f1(void);
int  NormalControlBreak(void);
int  PrintControlBreak(void);
void interrupt clock(void);
void interrupt key(void);
void ShowProgram(void);
void CheckAllFile(void);
void PrepareMemain(void);

/******** UNIO1-1.C ********/
void OpenDBF(void);
void CloseDBF(void);
void Read_DBF_Header(DBF_Header *H,FILE *DBF_fptr);
void Write_DBF_Header(FILE *DBF_fptr);
void ReadOneUnit(MEUNIT *Mtmp,int RecNo);
void WriteOneUnit(MEUNIT *Mtmp,int RecNo);
void AppendOneUnit(MEUNIT *Mtmp,FILE *MeAppend);
char Load_DBF(void);
void Load_DBF2(void);
char Get_NewDBF(char *DBF_filename);
char Get_NewDBF_Restore(char *DBF_filename);

/******** UNIO1-2.C ********/
void CenterFrame(char rownumb);
void FreeCenterFrame(char rownumb);
char ModifyUnit(int RecNo_ScrI);
void DeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
void UnDeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
char DeleteUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
char AddOneUnit(char drawflag);
char AddUnit(void);
void ReStructure(void);
char UnDeleteUnit(void);

/******** UNIO1-3.C ********/
void Write_CFG(char *CFG_filename);
void Read_CFG(char *CFG_filename);
char SetSubstitution(void);

/******** UNIO1-4.C ********/
void Write_SAT(char *SAT_filename);
void Read_SAT(char *SAT_filename);
void DrawTable(void);
char SetBudget(void);

/******** UNIO1-5.C ********/
char Input_Year(int *defaultyear);
char CreateNew(void);
char DeleteOld(void);
char BackupCurrent(char cDrive);
char RestoreCurrent(char cDrive);

/******** UNIO1-6.C ********/
int   SelectColor(char left,char top,int *colorattr);
void  WriteSystemSetting(void);
void  SettingParameter(void);
void  ReadSystemSetting(void);
void  showcolordemo(unsigned char Scolor,char Ypos,unsigned char dcolor);
BOOL2 SystemSetting(void);

/******** UNIO2-1.C ********/
void Show_DBF_Header(DBF_Header *tmp);
void ShowOneUnit(MEUNITSHOW *S);
void ShowOneUnitWithHeader(char ScrY,MEUNITSHOW *S);
void OffShowOneUnitWithHeader(char ScrY);
void ShowOneNull(void);
void showu1(int ScrJ,int ScrI);
void showu2(int ScrJ,int ScrI);
void showu3(int ScrJ,int ScrI);
void showu4(int ScrJ,int ScrI);
void ShowInfo(int ScrI);
void NotFound(int *ScrJ,int *ScrI);
void ShowUnit(int *ScrJ,int *ScrI,int keystroke);
void Cwords2(CWORDS *C);
void CwordsOff2(void);

/******** UNIO2-2.C ********/
char CheckBudget(void);
void cline(int x1,int y1,int x2,int y2,int colors,char boundflag);
void ScreenProtect(void);

/******** UNIO2-3.C ********/
char OpenDevicePrinter(char *printername);
void CloseDevicePrinter(void);
char CheckDevicePrinterDriver(void);
char DealWithPrinterNotReady(void);
char PrinterOK(void);
int  ToPrinter(char *fmt, ... );
char PrintInit(void);
char PrintFormat(void);
char FormFeed(void);
char PrintTitle(void);
char PrintPages(int pTotalPage,int pCurrentPage);
char PrintHeader(void);
char PrintPartLine(void);
char PrintPUFrame(void);
char PrintPLFrame(void);
char PrintPCFrame(void);
char PrintNullFrame(void);
char PrintNull(void);
char PrintUnit(MEUNIT *pUnt);
char PrintCalculate(long pStat);
char PrintFooter(void);
char PrintUnitType(char pUnit,char pType,char frameflag);
char PrintStat(char pUnit,char pType);

/******** UNIO3-1.C ********/
void ConvertUntToShow(MEUNITSHOW *shoW,MEUNIT *unT,int index_in_f);
void Date_String(char *sdate);
void IntToString(char *sstring,int iint);
int  StringToInt(char *sstring);
char IsNumberChar(char numberchar);
void DealWithDateString(char *dstring);
void ShowFormat(char *headerword);
char GetOneUnit(MEUNIT *tmp,char Newflag,char Drawflag);
void GetCurrent_CFG(void);
void GetCurrent_SAT(void);

/******** UNIO3-2.C ********/
char GetOneUnitSearch(MEUNITSEARCH *tmp,char Newflag,char Drawflag,char Typeflag);

/******** UNIO3-3.C ********/
void SetDateRange(MEUNITSEARCH *Stmp);
char CheckDateRange(MEUNIT *Tmp);
char CheckYear(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckMon(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckDay(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckUnit(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckType(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckPerson(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckMemo(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckRemark(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckMoney(MEUNIT *Tmp);
void SetMoneyRange(MEUNITSEARCH *Stmp);
char CheckMoneyRange(MEUNIT *Tmp);
void SetPerson(MEUNITSEARCH *Stmp);
void SetMemo(MEUNITSEARCH *Stmp);
char Searching(MEUNITSEARCH *Stmp,char Typeflag);
char Search(void);

/******** UNIO4-1.C ********/
void MemNotEnough(void);
void Alloc_ALL(void);
void Reset_ALL(void);
void Free_ALL(void);
void Yes2Show(void);
void No2Show(void);

void SwapALL(MEUNITSHOW *unt1,MEUNITSHOW *unt2);
void SwapIndexS(int *i1,int *i2);
void DateToLong(unsigned long *lLong,char *sdate);
unsigned long DateToL(char *sdate);
int  UnitCmp(MEUNITSHOW *unt1,MEUNITSHOW *unt2,char cmpflag);
char ShellSortShow(char cmpflag);
char ShowSort(void);

/******** UNIO4-2.C ********/
char PrintBudget(void);
char AskPrintRange(int *pFirst,int *pEnd);
char PrintALL(int *ScrJJ,int *ScrII);

