/*****************************************************************************/
/* MENU.C      Pop-Up MENU light bar subroutine                              */
/*****************************************************************************/
/* Used        Frame(), CFrame(), TextWindow(), and include file KEYCODE.II  */
/*             and LEE_SUB.I  for  struct  ItemType                          */
/*****************************************************************************/

#include <alloc.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <bios.h>
#include "keycode.ii"
#include "lee_sub.i"

int MenuF=YELLOW;
int MenuB=BLUE;
int NormalMF=LIGHTGRAY;
int NormalMB=BLACK;

void MenuColor   (int FFFF,int BBBB) { MenuF   =FFFF; MenuB   =BBBB; }
void NormalMColor(int FFFF,int BBBB) { NormalMF=FFFF; NormalMB=BBBB; }

int  CHBmenu(char ScrX,char ScrY,char Space,ItemType *Item,
             int *Hotkey,int *Otherkey,char Cflag)
{
   char i,j;
   char changef,subf[2];
   char scrxx,scryy;                   /* Save cursor position */
   char maxN,maxL;                     /* max Number & Length of item */
   int  keyin,Status;                  /* get key from bioskey(1) */
   int  Mitem,Sitemj,Sitemi2,*Sitemi;  /* Main item & Sub item */
   char *scrbuf;                       /* Screen Buffer for sub_menu */
   char *spac;
   int  *Hkey;

   scrxx=wherex();scryy=wherey();      /* Save cursor position */
   for(maxN=0,maxL=0,i=1;i<=Item[0].Numb;i++)   /* Find maxN & maxL */
   {
      maxN=(Item[i].Numb > maxN) ? Item[i].Numb : maxN ;
      maxL=(Item[i].Len  > maxL) ? Item[i].Len  : maxL ;
   }
   Sitemi=(int *)calloc(Item[0].Numb,sizeof(int));
   scrbuf=(char *)malloc(sizeof(char)*2*(maxN+2)*(maxL+4+1));
   spac=(char *)malloc(sizeof(char)*(Space+1));
   gettext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf); /* Save Taxt */
   for(i=0;i<Space;i++)spac[i]=' ';
   spac[i]='\0';

   gotoxy(ScrX,ScrY);
   textcolor(NormalMF);
   textbackground(NormalMB);
   for(i=0;i<Item[0].Numb;i++)
      cprintf("%s%*s",(i!=0)?spac:"",Item[0].Len,(Item[0].Item+i*(Item[0].Len+1)));

   Mitem=1;Sitemj=0;changef=1;subf[0]=subf[1]=0;
   while(1)
   {
      if(changef==1)
      {
         textcolor(MenuF);
         textbackground(MenuB);
         gotoxy(ScrX+(Mitem-1)*(Space+Item[0].Len),ScrY);
         cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));
         changef=0;
         if(subf[0]==1)
         {
            puttext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf);
            textcolor(NormalMF);
            textbackground(NormalMB);
            if(Cflag==1)
               CFrame(1,ScrY-Item[Mitem].Numb-2,Item[Mitem].Len+4-1,ScrY-1,4);
            else
               Frame(2,ScrY-Item[Mitem].Numb-2,Item[Mitem].Len+4-1,ScrY-1,4);
            Sitemi[Mitem-1]=0;
         }
      }
      if(subf[0]!=subf[1])
         if(subf[0]==1)
         {
            puttext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf);
            textcolor(NormalMF);
            textbackground(NormalMB);
            if(Cflag==1)
               CFrame(1,ScrY-Item[Mitem].Numb-2,Item[Mitem].Len+4-1,ScrY-1,4);
            else
               Frame(2,ScrY-Item[Mitem].Numb-2,Item[Mitem].Len+4-1,ScrY-1,4);
            Sitemi[Mitem-1]=0;
         }
         else if(subf[0]==0)
         {
            puttext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf);
            Sitemi[Mitem-1]=0;
         }

      if(subf[0]==1)
         TextWindow(3,ScrY-Item[Mitem].Numb-1,Item[Mitem].Len+4,
                    ScrY-2,Item[Mitem].Numb,Item[Mitem].Len,Item[Mitem].Item,
                    &Sitemi[Mitem-1],&Sitemj,&keyin,1);
      else
         keyin=bioskey(0);

      for(Hkey=Otherkey,i=0;Hkey[i];i++)
         if(keyin==Hkey[i])
         {
            textcolor(NormalMF);
            textbackground(NormalMB);
            gotoxy(ScrX+(Mitem-1)*(Space+Item[0].Len),ScrY);
            cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));

            Sitemi2=Sitemi[Mitem-1];
            puttext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf);
            gotoxy(scrxx,scryy);

            free(spac);
            free(scrbuf);
            free(Sitemi);

            return keyin;
         }
      for(Hkey=Hotkey,i=0;i<=Item[0].Numb;i++)
         for(j=1;j<=Item[i].Numb;j++,Hkey++)
            if(keyin==*Hkey)
            {
               textcolor(NormalMF);
               textbackground(NormalMB);
               gotoxy(ScrX+(Mitem-1)*(Space+Item[0].Len),ScrY);
               cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));

               Sitemi2=Sitemi[Mitem-1];
               puttext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf);
               gotoxy(scrxx,scryy);

               free(spac);
               free(scrbuf);
               free(Sitemi);

               return i*100+j;
            }
      subf[1]=subf[0];
      switch(keyin)
      {
         case Right:
            textcolor(NormalMF);
            textbackground(NormalMB);
            gotoxy(ScrX+(Mitem-1)*(Space+Item[0].Len),ScrY);
            cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));
            Mitem=(Mitem<Item[0].Numb)?Mitem+1:1;
            changef=1;
            break;

         case Left:
            textcolor(NormalMF);
            textbackground(NormalMB);
            gotoxy(ScrX+(Mitem-1)*(Space+Item[0].Len),ScrY);
            cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));
            Mitem=(Mitem>1)?Mitem-1:Item[0].Numb;
            changef=1;
            break;

         case Esc:
            if(subf[0]==0)
            {
               textcolor(NormalMF);
               textbackground(NormalMB);
               gotoxy(ScrX+(Mitem-1)*(Space+Item[0].Len),ScrY);
               cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));

               Sitemi2=Sitemi[Mitem-1];
               puttext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf);
               gotoxy(scrxx,scryy);

               free(spac);
               free(scrbuf);
               free(Sitemi);

               return 0;
            }
            else
               subf[0]=0;
            break;
         case Enter:
            if(subf[0]==1)
            {
               textcolor(NormalMF);
               textbackground(NormalMB);
               gotoxy(ScrX+(Mitem-1)*(Space+Item[0].Len),ScrY);
               cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));

               Sitemi2=Sitemi[Mitem-1];
               puttext(1,ScrY-maxN-2,maxL+4+1,ScrY-1,scrbuf);
               gotoxy(scrxx,scryy);

               free(spac);
               free(scrbuf);
               free(Sitemi);

               return Mitem*100+Sitemi2+1;
            }
            else
               subf[0]=1;
            break;
      }
   }
}

long GetDiskFree(void)
{
   struct dfree disk;
   getdfree(getdisk()+1,&disk);
   return (long)disk.df_avail*(long)disk.df_sclus*(long)disk.df_bsec;
}
/******** MENU.C ****************************************** Test Program ******
main()
{
   int Hkey[]={  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,
                 0 , F2 , F3 , F4 ,  0 ,  0 ,  0 ,  0 ,  0 ,
                 0 , Ins, Del,  0 ,
                C_S, A_S, A_N,
                 0 ,  0 ,  0 ,  0 ,
                F7 ,
                F1 ,  0                                 };
   int Okey[]={ 0 };

   ItemType Item[7]=
      {
         6,
         6,
         "  ""\0"            /*   0   */
         "s  ""\0"            /*   0   */
         "u  ""\0"            /*   0   */
         "\\  ""\0"           /*   0   */
         "C  L""\0"            /*   0   */
         "  L""\0",           /*   0   */
         9,
         14,
         "J    ""\0"    /*   0   */
         "xs  F2""\0"    /*  F2   */
         "xsø  F3""\0"    /*  F3   */
         "xs  F4""\0"    /*  F4   */
         "    ""\0"    /*   0   */
         "ƥ    ""\0"    /*   0   */
         "^    ""\0"    /*   0   */
         "sW    ""\0"    /*   0   */
         "R    ""\0",   /*   0   */
         4,
         14,
         "sW      ""\0"    /*   0   */
         "ק   Ins""\0"    /*  Ins  */
         "R   Del""\0"    /*  Del  */
         "Ϧ^      ""\0",   /*   0   */
         3,
         16,
         "      Ctrl-S""\0"  /*  C-S  */
         "j  M     Alt-S""\0"  /*  A-S  */
         "U@     Alt-N""\0", /*  A-N  */
         4,
         12,
         "d   l B""\0"      /*   0   */
         "]w~׹w""\0"      /*   0   */
         "]w~ץN""\0"      /*   0   */
         "]wtΰѼ""\0",     /*   0   */
         1,
         12,
         "C  L    F7""\0",     /*  F7   */
         2,
         12,
         "D  U    F1""\0"      /*  F1   */
         "        ""\0",     /*   0   */
      };
   int select;
   Cursor(0);


   select=CHBmenu(1,24,5,Item,Hkey,Okey,0);
   switch(select)
   {
      case 0 :   printf("Esc press !");      break;

      case 101 : printf("J    ");   break;
      case 102 : printf("xs  F2");   break;
      case 103 : printf("xsø  F3");   break;
      case 104 : printf("xs  F4");   break;
      case 105 : printf("    ");   break;
      case 106 : printf("ƥ    ");   break;
      case 107 : printf("^    ");   break;
      case 108 : printf("sW    ");   break;
      case 109 : printf("R    ");   break;

      case 201 : printf("sW      ");   break;
      case 202 : printf("ק   Ins");   break;
      case 203 : printf("R   Del");   break;
      case 204 : printf("Ϧ^      ");   break;

      case 301 : printf("      Ctrl-S"); break;
      case 302 : printf("j  M     Alt-S"); break;
      case 303 : printf("U@     Alt-N"); break;

      case 401 : printf("d   l B");     break;
      case 402 : printf("]w~׹w");     break;
      case 403 : printf("]w~ץN");     break;
      case 404 : printf("]wtΰѼ");     break;

      case 501 : printf("C  L    F7");     break;

      case 601 : printf("D  U    F1");     break;
      case 602 : printf("        ");     break;

      default  : printf("Error key press");  break;
   }

   select=CHBmenu(1,24,5,Item,Hkey,Okey,1);
   switch(select)
   {
      case 0 :   printf("Esc press !");      break;

      case 101 : printf("J    ");   break;
      case 102 : printf("xs  F2");   break;
      case 103 : printf("xsø  F3");   break;
      case 104 : printf("xs  F4");   break;
      case 105 : printf("    ");   break;
      case 106 : printf("ƥ    ");   break;
      case 107 : printf("^    ");   break;
      case 108 : printf("sW    ");   break;
      case 109 : printf("R    ");   break;

      case 201 : printf("sW      ");   break;
      case 202 : printf("ק   Ins");   break;
      case 203 : printf("R   Del");   break;
      case 204 : printf("Ϧ^      ");   break;

      case 301 : printf("      Ctrl-S"); break;
      case 302 : printf("j  M     Alt-S"); break;
      case 303 : printf("U@     Alt-N"); break;

      case 401 : printf("d   l B");     break;
      case 402 : printf("]w~׹w");     break;
      case 403 : printf("]w~ץN");     break;
      case 404 : printf("]wtΰѼ");     break;

      case 501 : printf("C  L    F7");     break;

      case 601 : printf("D  U    F1");     break;
      case 602 : printf("        ");     break;

      default  : printf("Error key press");  break;
   }
   Cursor(3);
}
******************************************************************************/
