/*****************************************************************************/
/* MENU.C      Pop-Up MENU light bar subroutine                              */
/*****************************************************************************/
/* Used        Frame(), CFrame(), TextWindow(), and include file KEYCODE.II  */
/*             and LEE_SUB.I  for  struct  ItemType                          */
/*****************************************************************************/

#include <alloc.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <bios.h>
#include "keycode.ii"
#include "lee_sub.i"

int VRMenuF=YELLOW;
int VRMenuB=BLUE;
int VRNormalMF=LIGHTGRAY;
int VRNormalMB=BLACK;
void VRMenuColor   (int FFFF,int BBBB) { VRMenuF   =FFFF; VRMenuB   =BBBB; }
void VRNormalMColor(int FFFF,int BBBB) { VRNormalMF=FFFF; VRNormalMB=BBBB; }

char *_scrbufm;                        /* Screen Buffer for main_menu */
char *_scrbufs;                        /* Screen Buffer for sub_menu */
int  *Sitemi;                          /* Sub  item */
                  /* Pointer variable must be apart with Other variable */
                  /* To avoid NULL pointer assignment                   */
int  Mitem;                            /* Main item */
char mainX,subX;                       /* main & sub menu X position */
char maxN,maxL;                        /* max Number & Length of item */
char Mscrxx,Mscryy;                    /* Save cursor position */
char CVRmenuOn(ItemType *Item)
{
   int i;
   for(maxN=0,maxL=0,i=1;i<=Item[0].Numb;i++)   /* Find maxN & maxL */
   {
      maxN=(Item[i].Numb > maxN) ? Item[i].Numb : maxN ;
      maxL=(Item[i].Len  > maxL) ? Item[i].Len  : maxL ;
   }
   mainX=80-Item[0].Len-4-1;
   subX=80-Item[0].Len-4-1 - maxL-4-1;
   Sitemi=(int *)calloc(Item[0].Numb,sizeof(int));
   _scrbufm=(char *)malloc(sizeof(char)*2*(Item[0].Numb+2)*(Item[0].Len+4+2+1));
   _scrbufs=(char *)malloc(sizeof(char)*2*(maxN+2)*(maxL+4+2+1));
   if(_scrbufs==NULL)return 0;                          /* alloc error */
   Mitem=1;       /* Initialize main menu item position */
}
void CVRmenuOff(void)
{
   free(_scrbufs);
   free(_scrbufm);
   free(Sitemi);
}
void CVRmenuReturn(char ScrY,char CVRnumb)
{
   puttext(mainX-1,ScrY,80,CVRnumb+ScrY+2-1,_scrbufm);
   puttext(subX-1,ScrY,subX+maxL+4,ScrY+maxN+2-1,_scrbufs);
   normvideo();
   gotoxy(Mscrxx,Mscryy);
}
int  CVRmenu(char ScrY,ItemType *Item,int *Hotkey,int *Otherkey,char MenuOn)
{
   char i,j;
   char changef,subf[2];
   int  keyin,Status;                  /* get key from bioskey(1) */
   int  Sitemj,Sitemi2;                /* Main item & Sub item */
   int  *Hkey;

   if(MenuOn!=1)                    /* Menu is Non-Active */
   {
      keyin=bioskey(0);

      for(Hkey=Hotkey,i=0;i<=Item[0].Numb;i++)     /* Return HotKey */
         for(j=1;j<=Item[i].Numb;j++,Hkey++)
            if(keyin==*Hkey)
               return i*100+j;
      return keyin;                                /* Return Other key */
   }
                                    /* Menu is Active */
   Mscrxx=wherex();Mscryy=wherey();      /* Save cursor position */
   gettext(mainX-1,ScrY,80,Item[0].Numb+ScrY+2-1,_scrbufm); /* Save Text */
   gettext(subX-1,ScrY,subX+maxL+4,ScrY+maxN+2-1,_scrbufs); /* Save Text */
   textcolor(VRNormalMF);
   textbackground(VRNormalMB);
   Clear_Frame(mainX-1,ScrY,79,Item[0].Numb+ScrY+1);  /* Draw main menu */
   textcolor(VRMenuF);
   textbackground(VRMenuB);
   CFrame(mainX,ScrY,79,Item[0].Numb+ScrY+1,4);
   textcolor(VRNormalMF);
   textbackground(VRNormalMB);
   for(i=0;i<Item[0].Numb;i++)
      gotoxy(80-Item[0].Len-2,ScrY+i+1),
      cprintf("%s",(Item[0].Item+i*(Item[0].Len+1)));

   Sitemj=0;changef=1;subf[0]=subf[1]=0;
   while(1)
   {
      if(changef==1)
      {
         textcolor(VRMenuF);                /* Show Main Selected */
         textbackground(VRMenuB);
         gotoxy(80-Item[0].Len-2,ScrY+Mitem),
         cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));

         changef=0;
            /* Show the sub menu */
            puttext(subX-1,ScrY,subX+maxL+4,ScrY+maxN+2-1,_scrbufs);
            textcolor(VRNormalMF);
            textbackground(VRNormalMB);
            Clear_Frame(subX-1,ScrY,subX+Item[Mitem].Len+4,ScrY+Item[Mitem].Numb+1);
            textcolor(VRMenuF);
            textbackground(VRMenuB);
            CFrame(subX,ScrY,subX+Item[Mitem].Len+4-2,ScrY+Item[Mitem].Numb+1,4);
            textcolor(VRNormalMF);
            textbackground(VRNormalMB);
            ShowTextWindowNoColor(subX+2,ScrY+1,subX+Item[Mitem].Len+2,ScrY+Item[Mitem].Numb+1, Item[Mitem].Len,Item[Mitem].Item, &Sitemj);
      }

      if(subf[0]==1)
         TextWindow(subX+2,ScrY+1,subX+Item[Mitem].Len+2,ScrY+Item[Mitem].Numb+1,
                    Item[Mitem].Numb,Item[Mitem].Len,Item[Mitem].Item,
                    &Sitemi[Mitem-1],&Sitemj,&keyin,1);
      else
         keyin=bioskey(0);

      for(Hkey=Otherkey,i=0;Hkey[i];i++)
         if(keyin==Hkey[i])
         {
            CVRmenuReturn(ScrY,Item[0].Numb);
            return keyin;
         }
/*                            /* Set Hot Key Off as Menu is ON */
      for(Hkey=Hotkey,i=0;i<=Item[0].Numb;i++)
         for(j=1;j<=Item[i].Numb;j++,Hkey++)
            if(keyin==*Hkey)
            {
               CVRmenuReturn(ScrY,Item[0].Numb);
               return i*100+j;
            }                                                  */
      subf[1]=subf[0];
      switch(keyin)
      {
         case Down:
            if(subf[0]==1)break;
            textcolor(VRNormalMF);          /* Off Current Selected */
            textbackground(VRNormalMB);
            gotoxy(80-Item[0].Len-2,ScrY+Mitem),
            cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));
            Mitem=(Mitem<Item[0].Numb)?Mitem+1:1;
            changef=1;
            break;

         case Up:
            if(subf[0]==1)break;
            textcolor(VRNormalMF);          /* Off Current Selected */
            textbackground(VRNormalMB);
            gotoxy(80-Item[0].Len-2,ScrY+Mitem),
            cprintf("%*s",Item[0].Len,(Item[0].Item+(Mitem-1)*(Item[0].Len+1)));
            Mitem=(Mitem>1)?Mitem-1:Item[0].Numb;
            changef=1;
            break;

         case Esc:
            if(subf[0]==0)
            {
               CVRmenuReturn(ScrY,Item[0].Numb);
               return 0;
            }
            else
               subf[0]=0;
            break;
         case Enter:
            if(subf[0]==1)
            {
               CVRmenuReturn(ScrY,Item[0].Numb);
               return Mitem*100+Sitemi[Mitem-1]+1;
            }
            else
               subf[0]=1;
            break;
      }
   }
}
/******************************************************************************
int Ctrl_Break(void)
{
   gotoxy(1,24);
   printf("Ctrl_Break press ........");
}
main()
{
   int Hkey[]={  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,
                 0 , F2 , F3 , F4 ,  0 ,  0 ,  0 ,  0 ,  0 ,
                 0 , Ins, Del,  0 ,
                C_S, A_S, A_N,
                 0 ,  0 ,  0 ,  0 ,
                F7 ,
                F1 ,  0                                 };
   int Okey[]={ 0 };

   ItemType Item[7]=
      {
         6,
         6,
         "  ""\0"            /*   0   */
         "s  ""\0"            /*   0   */
         "u  ""\0"            /*   0   */
         "\\  ""\0"           /*   0   */
         "C  L""\0"            /*   0   */
         "  L""\0",           /*   0   */
         9,
         14,
         "J    ""\0"    /*   0   */
         "xs  F2""\0"    /*  F2   */
         "xsø  F3""\0"    /*  F3   */
         "xs  F4""\0"    /*  F4   */
         "    ""\0"    /*   0   */
         "ƥ    ""\0"    /*   0   */
         "^    ""\0"    /*   0   */
         "sW    ""\0"    /*   0   */
         "R    ""\0",   /*   0   */
         4,
         14,
         "sW      ""\0"    /*   0   */
         "ק   Ins""\0"    /*  Ins  */
         "R   Del""\0"    /*  Del  */
         "Ϧ^      ""\0",   /*   0   */
         3,
         16,
         "      Ctrl-S""\0"  /*  C-S  */
         "j  M     Alt-S""\0"  /*  A-S  */
         "U@     Alt-N""\0", /*  A-N  */
         4,
         12,
         "d   l B""\0"      /*   0   */
         "]w~׹w""\0"      /*   0   */
         "]w~ץN""\0"      /*   0   */
         "]wtΰѼ""\0",     /*   0   */
         1,
         12,
         "C  L    F7""\0",     /*  F7   */
         2,
         12,
         "D  U    F1""\0"      /*  F1   */
         "        ""\0",     /*   0   */
      };
   int select=0;
   char Mflag=1;
   char Lselect=1;
   Cursor(0);
   ctrlbrk(Ctrl_Break);

   if(CVRmenuOn(2,Item)==0)
   {
      printf("\nnot enough memory for open menu ");
      exit(0);
   }

   while(Mflag!=0 || select!=Esc)
   {
      select=CVRmenu(2,Item,Hkey,Okey,Mflag);
      gotoxy(1,24);
      switch(select)
      {
         case 0 :   printf("Esc press !"); Mflag=0; BLfill(Lselect,112); break;

         case 101 : printf("J    ");   break;
         case 102 : printf("xs  F2");   break;
         case 103 : printf("xsø  F3");   break;
         case 104 : printf("xs  F4");   break;
         case 105 : printf("    ");   break;
         case 106 : printf("ƥ    ");   break;
         case 107 : printf("^    ");   break;
         case 108 : printf("sW    ");   break;
         case 109 : printf("R    ");   break;

         case 201 : printf("sW      ");   break;
         case 202 : printf("ק   Ins");   break;
         case 203 : printf("R   Del");   break;
         case 204 : printf("Ϧ^      ");   break;

         case 301 : printf("      Ctrl-S"); break;
         case 302 : printf("j  M     Alt-S"); break;
         case 303 : printf("U@     Alt-N"); break;

         case 401 : printf("d   l B");     break;
         case 402 : printf("]w~׹w");     break;
         case 403 : printf("]w~ץN");     break;
         case 404 : printf("]wtΰѼ");     break;

         case 501 : printf("C  L    F7");     break;

         case 601 : printf("D  U    F1");     break;
         case 602 : printf("        ");     break;
         case Esc    : printf("Esc press to QUIT menu ");break;
         case F10    : printf("Menu On F10            ");Mflag=1; break;
         case Up     :
            if(Lselect==1)break;
            BLfill(Lselect,7);
            BLfill(--Lselect,112);
            printf("Up press                  ");break;
         case Down   :
            if(Lselect==25)break;
            BLfill(Lselect,7);
            BLfill(++Lselect,112);
            printf("Down press                ");break;
         case Left   : printf("Left press                ");break;
         case Right  : printf("Right press                ");break;
         case PgUp   : printf("PgUp press                ");break;
         case PgDn   : printf("PgDn press                ");break;
         case Home   : printf("Home press                ");break;
         case End    : printf("End  press                ");break;
         case C_PgUp :
            if(Lselect==1)break;
            BLfill(Lselect,7);
            BLfill((Lselect=1),112);
            printf("C_PgUp press              ");break;
         case C_PgDn :
            if(Lselect==25)break;
            BLfill(Lselect,7);
            BLfill((Lselect=25),112);
            printf("C_PgDn press              ");break;
         case C_Home : printf("C_Home press              ");break;
         case C_End  : printf("C_End  press              ");break;
         case C_C    : printf("C_C    press              ");break;
         default  : printf("Other key press");  break;
      }
   }

   CVRmenuOff();
   Cursor(1);
}
******************************************************************************/
