/*****************************************************************************/
/* SCROLL.C    Light Bar Selector                                            */
/*****************************************************************************/
/* Used        include file KEYCODE.II                                       */
/*****************************************************************************/

#include<bios.h>
#include<alloc.h>
#include<conio.h>
#include<stdio.h>
#include"keycode.ii"
#include"lee_sub.i"

int LightBarF=YELLOW;
int LightBarB=BLUE;
int SelectedF=GREEN;
int SelectedB=BLUE;
int NormalF  =LIGHTGRAY;
int NormalB  =BLACK;

void LightBarColor(int FFFF,int BBBB) { LightBarF=FFFF; LightBarB=BBBB; }
void SelectedColor(int FFFF,int BBBB) { SelectedF=FFFF; SelectedB=BBBB; }
void NormalColor  (int FFFF,int BBBB) { NormalF  =FFFF; NormalB  =BBBB; }

char *wintmp;  /* temp pointer for window content */

/* *TextI is current position     *TextY is top line position */
/* ToTextWindow : word[] --> wintmp[] for TextWindow() format */
void ToTextWindow(int number,int length,char *word)
{
   int i,j;
   if(wintmp==NULL)
   {
      wintmp=(char *)malloc(sizeof(char)*((length+1)*number));

   /* For Equal / Non Equal length strings (ASCIIZ) this will be fine */
      for(i=0;i<number;i++)
      {
         for(j=0;*word++!=0;j++)   *(wintmp+i*(length+1)+j)=*(word-1);
         for(;j<length;j++)        *(wintmp+i*(length+1)+j)=' ';
         *(wintmp+i*(length+1)+j)='\0';
      }
   }
}

/* FreeTextWindow : to free memmory (char pointer wintmp) */
void FreeTextWindow()
{
   free(wintmp);
}

/* SetSelectColor : use select color to print text (one term) */
void SetSelectColor(int left,int top,int right,int bottom,
    int length,char *word,int *TextI,int *TextJ,int ColorF,int ColorB)
{
   window(left,top,right,bottom);
   gotoxy(1,*TextI-*TextJ+1);
   textcolor(ColorF);
   textbackground(ColorB);
   cprintf("%s",word+*TextI*(length+1));
   gotoxy(1,*TextI-*TextJ+1);
   textcolor(NormalF);
   textbackground(NormalB);
   window(1,1,80,25);
}

/* ShowTextWindowNoColor : Show window content only  */
void ShowTextWindowNoColor(int left,int top,int right,int bottom,
                      int length,char *word,int *TextJ)
{
   int i;
   int high=bottom-top;

   textcolor(NormalF);
   textbackground(NormalB);
   window(left,top,right,bottom);
   for(i=0;i<=high;i++)
      gotoxy(1,i+1),cprintf("%s",word+(i+*(TextJ))*(length+1));
   window(1,1,80,25);
}

/* ShowTextWindow : Show window content and selected light bar */
/*                  For 2nd or other text window               */
void ShowTextWindow(int left,int top,int right,int bottom,
               int length,char *word,int *TextI,int *TextJ)
{

   ShowTextWindowNoColor(left,top,right,bottom,length,word,TextJ);
   SetSelectColor(left,top,right,bottom,length,word,TextI,TextJ,SelectedF,SelectedB);
}

/* TextWindow : Main window */
int TextWindow(int left,int top,int right,int bottom,int number,int length,
               char *word,int *TextI,int *TextJ,int *ch,char Backflag)
{
   int i,j,ScrY;
   int high=bottom-top;
   int page=high+1;
   char  cf;                        /* Change Flag */
   int   ci,cj;                     /* Change of TextI & TextJ */

   ShowTextWindowNoColor(left,top,right,bottom,length,word,TextJ);
   SetSelectColor(left,top,right,bottom,length,word,TextI,TextJ,LightBarF,LightBarB);
   i=*TextI,j=*TextJ;
   window(left,top,right,bottom);
   gotoxy(1,i-j+1);
   while(1)
   {
      cf=0;ci=i;cj=j;
      *ch=bioskey(0);
      switch(*ch)
      {
         case Up:
         case Left:  if(i==0)
                       if(Backflag!=1)break;
                       else
                       {               /* Goto End Page */
                          cf=1;
                          j=(number-page<0)?0:number-page;
                          i=number-1;
                          break;
                       }
                     cf=1;
                     if(i==j)j=--i;
                     else    i--;
                     break;
         case Down:
         case Right: if(i==number-1)
                       if(Backflag!=1)break;
                       else
                       {               /* Goto First Page */
                          cf=1;
                          j=i=0;
                          break;
                       }
                     cf=1;
                     if(i-j==page-1)j++,i++;
                     else           i++;
                     break;
         case C_Home:
         case Home:  if(i==0)break;
                     cf=1;
                     j=i=0;
                     break;
         case C_End:
         case End:   if(i==number-1)break;
                     cf=1;
                     j=(number-page<0)?0:number-page;
                     i=number-1;
                     break;
         case PgUp:  if(i==0)break;
                     cf=1;
                     if(j==0)i=0;
                     else  if(j-page<0)j=(i=i-j,0);
                           else j-=page,i-=page;
                     break;
         case PgDn:  if(i==number-1 || number<=high)break;
                     cf=1;
                     if(j==number-page)i=number-1;
                     else  if(number-j<page)j=number-page,i=(i+page>number)?number-1:i+page;
                           else j=(j+page*2>number-1)?(i+=(number-page-j),number-page):(i+=page,j+page);
                     break;
         default:    break;
      }
      if(cf)
      {
         if(j==cj)
         {
            if(i!=ci)
            {
               SetSelectColor(left,top,right,bottom,length,word,&ci,&cj,NormalF,NormalB);
               SetSelectColor(left,top,right,bottom,length,word,&i,&j,LightBarF,LightBarB);
            }
         }
         else
         {
            ShowTextWindowNoColor(left,top,right,bottom,length,word,&j);
            SetSelectColor(left,top,right,bottom,length,word,&i,&j,LightBarF,LightBarB);
         }
      }
      break;
   }
   *TextI=i,*TextJ=j;
   if(*ch==Enter || *ch==Esc)
      SetSelectColor(left,top,right,bottom,length,word,TextI,TextJ,SelectedF,SelectedB);
   window(1,1,80,25);
   return (*ch==Esc) ? (0) :  (i+1) ;
}

void ShowTextWindow2NoColor(char **word,int wRow,int fIndex)
{                                               /* fIndex_0_base */
   char i;
   char bheight,bwidth;
   struct text_info R;
   gettextinfo(&R);
   bheight=R.winbottom-R.wintop+1;    /* leave the bottom line */
   bwidth=R.winright-R.winleft+1;
   textcolor(NormalF);
   textbackground(NormalB);
   clrscr();
   window(R.winleft,R.wintop,R.winright,R.winbottom+1);
   for(i=0;i+fIndex<wRow;i++)
   {
      gotoxy(1,i+1);
      ShowOneBlockLine(word[i+fIndex],bwidth,0);
      if(i+1==bheight) break;
   }
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(1,1);
}
void TextWindow2ScrollUp(char *newword)
{
   char bwidth,bheight;
   struct text_info R;
   gettextinfo(&R);

   bheight=R.winbottom-R.wintop+1;
   bwidth=R.winright-R.winleft+1;

   gotoxy(1,1); delline();
   window(R.winleft,R.wintop,R.winright,R.winbottom+1);
   gotoxy(1,bheight);
   if(newword!=NULL)
      ShowOneBlockLine(newword,bwidth,0);

   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(R.curx,R.cury);
}
void TextWindow2ScrollDown(char *newword)
{
   char bwidth,bheight;
   struct text_info R;
   gettextinfo(&R);

   bheight=R.winbottom-R.wintop+1;
   bwidth=R.winright-R.winleft+1;

   gotoxy(1,bheight); delline();
   gotoxy(1,1); insline();
   gotoxy(1,1);
   if(newword!=NULL)
      ShowOneBlockLine(newword,bwidth,0);

   gotoxy(R.curx,R.cury);
}
void SetSelectColor2(char selectLine,int FFFF,int BBBB)
{
   char linepos;
   struct text_info R;
   gettextinfo(&R);

   linepos=R.wintop+selectLine-1;      /* Mark Line Position */
   BBfill(R.winleft,linepos,R.winright,linepos,FFFF+BBBB*16);
}
int DrawTextWindow2(char left,char top,char right,char bottom,int number,
                    char **word,int *TextJ)
{
   struct text_info R;
   gettextinfo(&R);

   bottom=(bottom>24)?24:bottom;
   window(left,top,right,bottom);
   ShowTextWindow2NoColor(word,number,*TextJ);
   window(R.winleft,R.wintop,R.winright,R.winbottom);
}
int  TextWindow2(char left,char top,char right,char bottom,int number,
                 char **word,int *TextI,int *TextJ,char Backflag)
{
   int page;
   int ch;
   int i,j,ScrY;
   struct text_info R;
   gettextinfo(&R);
   bottom=(bottom>24)?24:bottom;
   page=bottom-top+1;
   window(left,top,right,bottom);

   i=*TextI,j=*TextJ;

   SetSelectColor2(i-j+1,LightBarF,LightBarB);
   gotoxy(1,i-j+1);

      ch=bioskey(0);
      SetSelectColor2(i-j+1,NormalF,NormalB);
      switch(ch)
      {
         case Up:
         case Left:  if(i==0)
                        if(Backflag!=1)break;
                        else
                        {               /* Goto End Page */
                           j=(number-page<0)?0:number-page;
                           i=number-1;
                           if(j!=0) ShowTextWindow2NoColor(word,number,j);
                           break;
                        }
                     if(i==j)j=--i,TextWindow2ScrollDown(word[i]);
                     else    i--;
                     break;
         case Down:
         case Right: if(i==number-1)
                        if(Backflag!=1)break;
                        else
                        {               /* Goto First Page */
                           if(j!=0)ShowTextWindow2NoColor(word,number,0);
                           j=i=0;
                           break;
                        }
                     if(i-j==page-1)j++,i++,TextWindow2ScrollUp(word[i]);
                     else           i++;
                     break;
         case C_Home:
         case Home:  if(i==0)break;
                     if(j!=0)ShowTextWindow2NoColor(word,number,0);
                     j=i=0;
                     break;
         case C_End:
         case End:   if(i==number-1)break;
                     j=(number-page<0)?0:number-page;
                     i=number-1;
                     if(j!=0) ShowTextWindow2NoColor(word,number,j);
                     break;
         case PgUp:  if(i==0)break;
                     if(j==0)i=0;
                     else
                     {
                        if(j-page<0) j=(i=i-j,0);
                        else         j-=page,i-=page;
                        ShowTextWindow2NoColor(word,number,j);
                     }
                     break;
         case PgDn:  if(i==number-1)break;
                     if(number<=page)  {  i=number-1; break;   }
                     if(j==number-page){  i=number-1; break;   }
                     if(number-j<page)j=number-page,i=(i+page>number)?number-1:i+page;
                     else j=(j+page*2>number-1)?(i+=(number-page-j),number-page):(i+=page,j+page);
                     if(j!=0) ShowTextWindow2NoColor(word,number,j);
                     break;
         case C_PgUp:if(i==j)break;
                     i=j;
                     break;
         case C_PgDn:if(i==j+page-1)break;
                     i=j+page-1;
                     i=(i>number-1)?number-1:i;
                     break;
         default:    break;
      }
   /* SetSelectColor2(i-j+1,LightBarF,LightBarB);*/

   *TextI=i,*TextJ=j;
   SetSelectColor2(i-j+1,SelectedF,SelectedB);
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   return ch;
}
void ShowTextWindow3NoColor(char **word,int *windex,int wRow,int fIndex)
{                                               /* fIndex_0_base */
   char i;
   char bheight,bwidth;
   struct text_info R;
   gettextinfo(&R);
   bheight=R.winbottom-R.wintop+1;    /* leave the bottom line */
   bwidth=R.winright-R.winleft+1;
   textcolor(NormalF);
   textbackground(NormalB);
   clrscr();
   window(R.winleft,R.wintop,R.winright,R.winbottom+1);
   for(i=0;i+fIndex<wRow;i++)
   {
      gotoxy(1,i+1);
      ShowOneBlockLine(word[windex[i+fIndex]],bwidth,0);
      if(i+1==bheight) break;
   }
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(1,1);
}
int DrawTextWindow3(char left,char top,char right,char bottom,int number,
                    char **word,int *windex,int *TextJ)
{
   struct text_info R;
   gettextinfo(&R);

   bottom=(bottom>24)?24:bottom;
   window(left,top,right,bottom);
   ShowTextWindow3NoColor(word,windex,number,*TextJ);
   window(R.winleft,R.wintop,R.winright,R.winbottom);
}
int  TextWindow3(char left,char top,char right,char bottom,int number,
            char **word,int *windex,int *TextI,int *TextJ,char Backflag)
{
   int page;
   int ch;
   int i,j,ScrY;
   struct text_info R;
   gettextinfo(&R);
   bottom=(bottom>24)?24:bottom;
   page=bottom-top+1;
   window(left,top,right,bottom);

   i=*TextI,j=*TextJ;

   SetSelectColor2(i-j+1,LightBarF,LightBarB);
   gotoxy(1,i-j+1);

      ch=bioskey(0);
      SetSelectColor2(i-j+1,NormalF,NormalB);
      switch(ch)
      {
         case Up:
         case Left:  if(i==0)
                        if(Backflag!=1)break;
                        else
                        {               /* Goto End Page */
                           j=(number-page<0)?0:number-page;
                           i=number-1;
                           if(j!=0) ShowTextWindow3NoColor(word,windex,number,j);
                           break;
                        }
                     if(i==j)j=--i,TextWindow2ScrollDown(word[windex[i]]);
                     else    i--;
                     break;
         case Down:
         case Right: if(i==number-1)
                        if(Backflag!=1)break;
                        else
                        {               /* Goto First Page */
                           if(j!=0)ShowTextWindow3NoColor(word,windex,number,0);
                           j=i=0;
                           break;
                        }
                     if(i-j==page-1)j++,i++,TextWindow2ScrollUp(word[windex[i]]);
                     else           i++;
                     break;
         case C_Home:
         case Home:  if(i==0)break;
                     if(j!=0)ShowTextWindow3NoColor(word,windex,number,0);
                     j=i=0;
                     break;
         case C_End:
         case End:   if(i==number-1)break;
                     j=(number-page<0)?0:number-page;
                     i=number-1;
                     if(j!=0) ShowTextWindow3NoColor(word,windex,number,j);
                     break;
         case PgUp:  if(i==0)break;
                     if(j==0)i=0;
                     else
                     {
                        if(j-page<0) j=(i=i-j,0);
                        else         j-=page,i-=page;
                        ShowTextWindow3NoColor(word,windex,number,j);
                     }
                     break;
         case PgDn:  if(i==number-1)break;
                     if(number<=page)  {  i=number-1; break;   }
                     if(j==number-page){  i=number-1; break;   }
                     if(number-j<page)j=number-page,i=(i+page>number)?number-1:i+page;
                     else j=(j+page*2>number-1)?(i+=(number-page-j),number-page):(i+=page,j+page);
                     if(j!=0) ShowTextWindow3NoColor(word,windex,number,j);
                     break;
         case C_PgUp:if(i==j)break;
                     i=j;
                     break;
         case C_PgDn:if(i==j+page-1)break;
                     i=j+page-1;
                     i=(i>number-1)?number-1:i;
                     break;
         default:    break;
      }
   /* SetSelectColor2(i-j+1,LightBarF,LightBarB);*/

   *TextI=i,*TextJ=j;
   SetSelectColor2(i-j+1,SelectedF,SelectedB);
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   return ch;
}
int  TextWindow4(char left,char top,char right,char bottom,int number,
            char **word,int *TextI,int *TextJ)
{
   int page;
   int ch;
   int i,j,ScrY;
   struct text_info R;
   gettextinfo(&R);
   bottom=(bottom>24)?24:bottom;
   page=bottom-top+1;
   window(left,top,right,bottom);

   i=*TextI,j=*TextJ;

   gotoxy(1,i-j+1);

      ch=bioskey(0);
      switch(ch)
      {
         case Up:
         case Left:
                     if(j==0) break;
                     i=j,j=--i,TextWindow2ScrollDown(word[i]);
                     break;
         case Down:
         case Right:
                     if(i==number-1) break;
                     if(number<=page)  {  i=number-1; break;   }
                     if(j==number-page){  i=number-1; break;   }
                     i=j+page-1,j++,i++,TextWindow2ScrollUp(word[i]);
                     break;
         case C_Home:
         case Home:  if(j==0)break;
                     if(j!=0)ShowTextWindow2NoColor(word,number,0);
                     j=i=0;
                     break;
         case C_End:
         case End:   if(i==number-1)break;
                     j=(number-page<0)?0:number-page;
                     i=number-1;
                     if(j!=0) ShowTextWindow2NoColor(word,number,j);
                     break;
         case C_PgUp:
         case PgUp:  if(j==0){i=0;break;}
                     else
                     {
                        if(j-page<0) j=(i=i-j,0);
                        else         j-=page,i-=page;
                        ShowTextWindow2NoColor(word,number,j);
                     }
                     break;
         case C_PgDn:
         case PgDn:  if(i==number-1)break;
                     if(number<=page)  {  i=number-1; break;   }
                     if(j==number-page){  i=number-1; break;   }
                     if(number-j<page)j=number-page,i=(i+page>number)?number-1:i+page;
                     else j=(j+page*2>number-1)?(i+=(number-page-j),number-page):(i+=page,j+page);
                     if(j!=0) ShowTextWindow2NoColor(word,number,j);
                     break;
         default:    break;
      }

   *TextI=i,*TextJ=j;
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   return ch;
}
int  TextWindow5(char left,char top,char right,char bottom,int number,
            char **word,int *windex,int *TextI,int *TextJ)
{
   int page;
   int ch;
   int i,j,ScrY;
   struct text_info R;
   gettextinfo(&R);
   bottom=(bottom>24)?24:bottom;
   page=bottom-top+1;
   window(left,top,right,bottom);

   i=*TextI,j=*TextJ;

   gotoxy(1,i-j+1);

      ch=bioskey(0);
      switch(ch)
      {
         case Up:
         case Left:
                     if(j==0) break;
                     i=j,j=--i,TextWindow2ScrollDown(word[windex[i]]);
                     break;
         case Down:
         case Right:
                     if(i==number-1) break;
                     if(number<=page)  {  i=number-1; break;   }
                     if(j==number-page){  i=number-1; break;   }
                     i=j+page-1,j++,i++,TextWindow2ScrollUp(word[windex[i]]);
                     break;
         case C_Home:
         case Home:  if(j==0)break;
                     if(j!=0)ShowTextWindow3NoColor(word,windex,number,0);
                     j=i=0;
                     break;
         case C_End:
         case End:   if(i==number-1)break;
                     j=(number-page<0)?0:number-page;
                     i=number-1;
                     if(j!=0) ShowTextWindow3NoColor(word,windex,number,j);
                     break;
         case C_PgUp:
         case PgUp:  if(j==0){i=0;break;}
                     else
                     {
                        if(j-page<0) j=(i=i-j,0);
                        else         j-=page,i-=page;
                        ShowTextWindow3NoColor(word,windex,number,j);
                     }
                     break;
         case C_PgDn:
         case PgDn:  if(i==number-1)break;
                     if(number<=page)  {  i=number-1; break;   }
                     if(j==number-page){  i=number-1; break;   }
                     if(number-j<page)j=number-page,i=(i+page>number)?number-1:i+page;
                     else j=(j+page*2>number-1)?(i+=(number-page-j),number-page):(i+=page,j+page);
                     if(j!=0) ShowTextWindow3NoColor(word,windex,number,j);
                     break;
         default:    break;
      }

   *TextI=i,*TextJ=j;
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   return ch;
}
