/*****************************************************************************/
/* SELFILE.C   Select File in Light Bar Format                               */
/*****************************************************************************/
/* Used        Frame(), CFrame(), Clear_Frame(), TextWindow()                */
/*             and include file KEYCODE.II                                   */
/*****************************************************************************/
#pragma inline

#include<alloc.h>
#include<stdlib.h>
#include<stdio.h>
#include<io.h>
#include<conio.h>
#include<dir.h>
#include<dos.h>
#include<string.h>
#include"lee_sub.i"
#include"keycode.ii"

#define MaxFileNumber  255
#define MaxDriver       26

char *NoFileSelected="No One Selected";

char DisketteReadReady(char driver)
{
   int   drivernumber;
   int   status;
   char *buff;

   buff=(char *)calloc(512,sizeof(char));
   if(driver-'a'>=0 && driver-'z'<=0)driver+='A'-'a';
   if(driver<'C')
      drivernumber=driver-'A';
   else
      drivernumber=driver-'C'+'\x80';
   status=biosdisk(2,drivernumber,0,0,1,1,buff);
   free(buff);
   return (status==0) ? 0 : 1 ;        /* if error return 1 */
}
char DisketteWriteReady(char driver)
{
   int   drivernumber;
   int   status;
   char *buff;

   buff=(char *)calloc(512,sizeof(char));
   if(driver-'a'>=0 && driver-'z'<=0)driver+='A'-'a';
   if(driver<'C')
      drivernumber=driver-'A';
   else
      drivernumber=driver-'C'+'\x80';
   if(biosdisk(2,drivernumber,0,0,1,1,buff)!=0)
   {
      free(buff);
      return   2;                                     /* Not Ready */
   }
   status=biosdisk(3,drivernumber,0,0,1,1,buff);
   free(buff);
   return (status==0) ? 0 : ((status==3)? 1 : 3) ;    /* OK            -> 0 */
                                                      /* Write Protect -> 1 */
                                                      /* Read  Error   -> 2 */
                                                      /* Other Error   -> 3 */
}
long GetDiskState(char Driver,char Fflag)
{
   unsigned SectorPerCluster;
   unsigned FreeClusters;
   unsigned BytePerSector;

   Driver=(Driver>='a' && Driver<='z')?Driver-'a'+'A':Driver; /* to Upper */
   Driver=(Driver>='A' && Driver<='Z')?Driver-'A'+1:0;   /* if not A-Z set 0 */

   asm   mov   dl,Driver            /* 0->current, 1->A, 2->B, 3->C,... */
   asm   mov   ah,036h
   asm   int   21h
   asm   mov   SectorPerCluster,ax
   asm   mov   FreeClusters,bx
   asm   mov   BytePerSector,cx

   if(Fflag==1)
      return ((long)FreeClusters*(long)SectorPerCluster*(long)BytePerSector);
   else
      return ((long)SectorPerCluster*(long)BytePerSector);
}
long GetDiskFreeSpace(char Driver)
{
   return GetDiskState(Driver,1);
}
long GetDiskMinBlock(char Driver)
{
   return GetDiskState(Driver,0);
}
void SelectPathFile(int left,int top,int rows,
           char *Filename,char *FHeader,char *pathfile,char cmode,char fileflag)
{
   char *Oldpath;       /* Save Old Path */
   char *Name;          /* File Name Data Bank */
   char *wantfile;      /* Selected File Name */
   char *wantdir;       /* Directory to Change */
   char *ScrBuf;        /* Screen Buffer */
   char *s1;            /* temp strings for filename */
   char far *PtrOfDta;  /* Pointer Of DTA */
   struct ffblk F;      /* Struct for File Find */
   int  done;           /* Flag of File Search Done */
   char changedir;      /* Flag of Change Directory */
   char changedriver;   /* Flag of Change Driver */
   int  diskstatus;     /* diskette status */
   int  Status;         /* TextWindow return Item Number */
   int  total;          /* Total Number of File Find */
   int  totalf;         /* Total Number of File Find */
   int  totaldir;       /* Total Directory find */
   int  ch;             /* Key Press Record */
   char ScrX,ScrY;      /* Save Previous Cursor Position */
   int  texti,textj;    /* for TextWindow */
   char c_add;          /* for Chinese mode to add 1 char */
   char drivernumber;   /* Driver number include Floppy and Hard Disk */
   int  i;

   ScrX=wherex();       /* Save Previous Cursor Position */
   ScrY=wherey();
   s1=(char *)calloc(14,sizeof(char));          /* alloc moemory for varible */
   wantfile=(char *)calloc(14,sizeof(char));
   wantdir=(char *)calloc(16,sizeof(char));
   Name=(char *)calloc(14*(MaxFileNumber+MaxDriver),sizeof(char));
   ScrBuf=(char *)calloc((15+2+1)*(rows+2)*2,sizeof(char));
   Oldpath=(char *)calloc(128,sizeof(char));

   gettext(left,top,left+14+2+1,top+rows+1,ScrBuf); /* Save Screen Text */
   strcpy(Oldpath,"X:\\");                      /* Save Old Path */
   Oldpath[0]='A'+getdisk();
   getcurdir(0,Oldpath+3);
   PtrOfDta=(char far *)getdta();
   do
   {
      changedir=0;changedriver=0;total=0;

      drivernumber=setdisk(100);          /* get driver number */
      drivernumber=(drivernumber>26)?26:drivernumber;

      done=findfirst("*.*",&F,FA_DIREC);  /* Find Directory Fisrt */
      while(!done)
      {
         if(total>MaxFileNumber-drivernumber)
         {
            printf("\0x07");
            /*printf("\nFile Number too Large ! I can't Handle .\n");*/
            break;
         }
         if(F.ff_attrib==16)                 /* This file is a directory */
         {
            if(strncmp(F.ff_name,".",2)!=0)
            {
               for(i=0;i<13 && F.ff_name[i]!='\0';i++)
               s1[i]=F.ff_name[i];
               s1[i++]='\\';
               for(;i<13;i++)s1[i]=' ';
               s1[i]='\0';
               total++;
               strncpy(&Name[14*(total-1)],s1,14);
               Name[14*total]='\0';
            }
         }
         done=findnext(&F);
      }                          /* Find Directory  OK !! */
      totaldir=total;

      totalf=0;
      done=findfirst(Filename,&F,FA_ARCH); /* Find Specific Filename */
      while(!done)
      {
         if(total>MaxFileNumber-drivernumber)
         {
            printf("\0x07");
            /*printf("\nFile Number too Large ! I can't Handle .\n");*/
            break;
         }
         if(F.ff_attrib!=16)                 /* This file is  Wanted */
         {
            total++;
            totalf++;
            for(i=0;i<13 && F.ff_name[i]!='\0';i++)
               s1[i]=F.ff_name[i];
            for(;i<13;i++)s1[i]=' ';
            s1[i]='\0';
            strncpy(&Name[14*(total-1)],s1,14);
            Name[14*total]='\0';
         }
         done=findnext(&F);
      }                          /* Find file OK !! */

      strcpy(s1,"____[ A ]____");
      for(i=0;i<drivernumber;i++)
      {
         total++;
         strncpy(&Name[14*(total-1)],s1,14);
         Name[14*total]='\0';
         s1[6]++;
      }                             /* Find Driver OK !! */


      if(total<rows)
         for(i=total;i<=rows;i++)
            strcpy(&Name[14*i],"             ");

      if(cmode==1)
         c_add=1,CFrame(left,top,left+14+2,top+rows+1,7),
         Clear_Frame(left+2,top+1,left+14+1,top+rows);
      else
         c_add=0, Frame(left,top,left+14,top+rows+1,4),
         Clear_Frame(left+1,top+1,left+14-1,top+rows);
      gotoxy(left+1+c_add,top);cprintf(FHeader);
      gotoxy(left+3+c_add,top+rows+1);
      /* cprintf("%s%5d",(cmode==1)?"` @":"Total",total-totaldir-drivernumber);*/
      cprintf("%s%5d",(cmode==1)?"` @":"Total",totalf);

      texti=textj=0;
      while((Status=TextWindow(left+1+c_add,top+1,left+13+1+c_add,top+rows,total,13,Name,&texti,&textj,&ch,0))!=0)
      {
         for(i=0;i<13;i++)wantfile[i]=Name[14*(Status-1)+i];
         wantfile[13]='\0';
         if(ch==Enter)
         {
            if(wantfile[4]=='[')changedriver=1;
            for(i=0;i<13;i++)
               if(wantfile[i]=='\\')
                  {  changedir=1;   break;   }
            if(changedir==1)
            {
               strncpy(wantdir,wantfile,i);
               wantdir[i]='\0';
               chdir(wantdir);
               break;
            }
            else  if(changedriver==1)
                  {
                     if(wantfile[6]=='A' || wantfile[6]=='B')
                     {
                       DisketteReadReady(wantfile[6]);     /* Moter on First */
                        if(DisketteReadReady(wantfile[6])!=0)  /* Then chech */
                        {
                           changedir=1;
                           setdisk(Oldpath[0]-'A');   /* Back to Old Drive */
                           chdir(Oldpath);            /* Back to Old Path */
                           break;
                        }
                     }
                     setdisk(wantfile[6]-'A');
                     break;
                  }
                  else
                  {
                     strcpy(pathfile,"X:\\");
                     pathfile[0]='A'+getdisk();
                     getcurdir(0,pathfile+3);
                     if(pathfile[strlen(pathfile)-1]!='\\')
                        strcat(pathfile,"\\");
                     if(fileflag==1)strncat(pathfile,wantfile,12);
                     break;
                  }
         }
/*       gotoxy(50,24);printf("PATH = %s",pathfile);    /* Check */
         gotoxy(50,25);printf("FILE = %s",wantfile);             */
      }
      if(ch==Esc || Status==0)
      {
         if(fileflag==1)
            strcpy(pathfile,NoFileSelected);
         else
            strcpy(pathfile,"X:\\");
            pathfile[0]='A'+getdisk();
            getcurdir(0,pathfile+3);
            if(pathfile[strlen(pathfile)-1]!='\\')
               strcat(pathfile,"\\");
         break;
      }
   }while(changedir==1 || changedriver==1);

   setdta(PtrOfDta);
   setdisk(Oldpath[0]-'A');                     /* Back to Old Drive */
   chdir(Oldpath);                              /* Back to Old Path */
   puttext(left,top,left+14+2+1,top+rows+1,ScrBuf); /* Put Back Saved Screen */
   gotoxy(ScrX,ScrY);                           /* Set Previous Position */
   free(Oldpath);                               /* Free Memory allocation */
   free(ScrBuf);
   free(Name);
   free(wantdir);
   free(wantfile);
   free(s1);
}

void SelectFile(int left,int top,int rows,
           char *Filename,char *FHeader,char *pathfile,char cmode)
{
   SelectPathFile(left,top,rows,Filename,FHeader,pathfile,cmode,1);
}
void SelectPath(int left,int top,int rows,
           char *FHeader,char *pathfile,char cmode)
{
   SelectPathFile(left,top,rows,"*.*",FHeader,pathfile,cmode,0);
}
char FileExist(char *sfilename)
{
   return((access(sfilename,0)==0)? TRUE : FALSE );
}
void GetICPath(char *icPath)
{
   strcpy(icPath,"X:\\");
   icPath[0]='A'+getdisk();
   getcurdir(0,icPath+3);
   if(strlen(icPath)>3) strcat(icPath,"\\");
}
void GetPathFile(char *Want_file,char *Path_file,char *fName,char *fExt,char eflag)
{
   char *driver, *dir, *name, *ext;

   driver=(char *)calloc( 3,sizeof(char));
   dir   =(char *)calloc(66,sizeof(char));
   name  =(char *)calloc( 9,sizeof(char));
   ext   =(char *)calloc( 5,sizeof(char));

   fnsplit(Path_file,driver,dir,name,ext);
   if(eflag==0)strcpy(name,fName);
   strcpy(ext,fExt);
   fnmerge(Want_file,driver,dir,name,ext);

   free(ext);
   free(name);
   free(dir);
   free(driver);
}
void GetPathFileExt(char *Want_file,char *Path_file,char *fExt)
{
   GetPathFile(Want_file,Path_file,"",fExt,1);
}
void GetPathFileName(char *Want_file,char *Path_file,char *fName,char *fExt)
{
   GetPathFile(Want_file,Path_file,fName,fExt,0);
}
/******** SELFILE.C *************************************** Test Program ******
main()
{
   char *pathfile=(char *)calloc(128,sizeof(char));
   SelectFile(1,1,20,"*.*","Test OK",pathfile,7);
   printf("\nFile Selected : %s\n",pathfile);
}
******************************************************************************/
