/*****************************************************************************/
/* ITX.C         Read ITX file                                               */
/*****************************************************************************/
/* Call :   BLFill(),Message(),Clrscr(),                                     */
/*****************************************************************************/

#include "viewer2.i"

#define MAXITXLINE 800
#define ITXFirst 4
#define ITXPAGEL 20

FILE *File_ITX;
char *ITXBuf;
unsigned int *IndexOfITX;
int  Total_ITX_Line;

int  ITXMarkF=WHITE;
int  ITXMarkB=BLUE;
void ITXColor(int FFFF,int BBBB){ITXMarkF=FFFF;ITXMarkB=BBBB;}
void ITXMark(char ScrII)
{
   BLfill(ScrII,ITXMarkF+ITXMarkB*16);
}
void Clrscr2(void)
{
   extern int DataBaseF,DataBaseB;
   window(1,ITXFirst,80,ITXFirst+ITXPAGEL-1);
   textcolor(DataBaseF);
   textbackground(DataBaseB);
   clrscr();
   window(1,1,80,25);
}
char InitITX(char *ITXFile)
{
   unsigned long FileLens;
   unsigned int i;
   if(FileExist(ITXFile)!=TRUE)
   {
      Message(1,0,0,"ޤr\"%s\"sbI",ITXFile);
      return ERROR;                    /* ERROR -> Error As Open ITX File */
   }
   if((File_ITX=fopen(ITXFile,"r"))==NULL)
   {
      Message(1,0,0,"ޤr\"%s\"}ҿ~I",ITXFile);
      return ERROR;                    /* ERROR -> Error As Open ITX File */
   }
   FileLens=filelength(fileno(File_ITX));
   ITXBuf=(char *)calloc(FileLens,sizeof(char));
   IndexOfITX=(unsigned int *)calloc(MAXITXLINE,sizeof(unsigned int));
   rewind(File_ITX);
   fread(ITXBuf,FileLens,1,File_ITX);
   for(i=0,IndexOfITX[0]=0,Total_ITX_Line=1;i<FileLens;i++)
      if(ITXBuf[i]=='\n')
         ITXBuf[i]='\0', IndexOfITX[Total_ITX_Line++]=i+1;
   Total_ITX_Line--;
   return OK;                           /* OK -> Read ITX File to Buf */
}
void OffITX(void)
{
   free(IndexOfITX);
   free(ITXBuf);
   fclose(File_ITX);
}
void showh1(int ScrJ,int ScrI)               /* show ITX as total not */
{                                            /* enough for a page      */
   int i;                                    /* or specific top of ITX */
   Clrscr2();
   for(i=ScrJ;i<ScrJ+ITXPAGEL && i<Total_ITX_Line;i++)
      printfXY(1,ITXFirst+i-ScrJ,"%-80.80s",&ITXBuf[IndexOfITX[i]]);
   if(i>=Total_ITX_Line)
      for(;i<ScrJ+ITXPAGEL;i++)printfXY(1,ITXFirst+i-ScrJ,"\n");
   ITXMark(ScrI-ScrJ+ITXFirst);
}
void showh2(int ScrJ,int ScrI)                  /* show ITX  only mark */
{                                               /* different position   */
   ITXMark(ScrI-ScrJ+ITXFirst);
}
void showh3(int ScrJ,int ScrI)                  /* show ITX Up scroll */
{
   window(1,ITXFirst,80,ITXFirst+ITXPAGEL-1);
   gotoxy(1,1);
   delline();
   if(Total_ITX_Line-ScrJ>=ITXPAGEL)
      printfXY(1,ITXPAGEL,"%-80.80s",&ITXBuf[IndexOfITX[ScrJ+ITXPAGEL-1]]);
   else
      printfXY(1,ITXPAGEL,"\n");
   window(1,1,80,25);
   ITXMark(ScrI-ScrJ+ITXFirst);
}
void showh4(int ScrJ,int ScrI)                  /* show ITX Down Scroll */
{
   window(1,ITXFirst,80,ITXFirst+ITXPAGEL-1);
   gotoxy(1,ITXPAGEL);
   delline();
   gotoxy(1,1);
   insline();
   printfXY(1,1,"%-80.80s",&ITXBuf[IndexOfITX[ScrJ]]);
   window(1,1,80,25);
   ITXMark(ScrI-ScrJ+ITXFirst);
}
void ShowITXInfo(int ScrI)
{
   extern char *showmsgwords,*showmsgwords1;
   static i;

   if(ScrI==Total_ITX_Line-1) Message(0,0,0,showmsgwords,"ɮ׵");
   else if(ScrI==0)           Message(0,0,0,showmsgwords,"ɮ׶}Y");
        else                  Message(0,0,0,showmsgwords,(Total_ITX_Line>23-4+1)?showmsgwords1:"");
   if(i==ScrI)OneBeep(200),Clear_KeyBuf();
   i=ScrI;

/*   Message(0,0,0,"ШϥδӬdݻAESC C");     */
/*   printfXY(63,25,"@%4d %4d",Total_ITX_Line,ScrI+1); */
}
void NoITXFound(int *ScrJ,int *ScrI)
{
   Clrscr2();
   *ScrJ=*ScrI=0;
   ShowITXInfo(*ScrI);
   showh2(*ScrJ,*ScrI);
}
void ShowITX(int *ScrJ,int *ScrI,int keystroke)
{                                                 /* ScrJ -- Top Line No */
   static int  totalpages;                        /* ScrI -- Current Line No */
   void  (*showh)();
   char  cmdflag;
   int   tmpI;

   if(Total_ITX_Line==0){ NoITXFound(ScrJ,ScrI);return; }
   totalpages=((Total_ITX_Line%ITXPAGEL == 0) ? Total_ITX_Line/ITXPAGEL : Total_ITX_Line/ITXPAGEL+1) ;

   UnMarkLine(*ScrI-*ScrJ+ITXFirst);                  /* need unmark line first */
   cmdflag=0;showh=showh2;
   switch(keystroke)
   {
      case Up     :  if(*ScrI<=0)break;             /* top already */
                     cmdflag=1;
                     if(*ScrJ==*ScrI)                /* current at the top */
                        *ScrJ-=1, *ScrI-=1, showh=showh4;
                     else
                        *ScrI-=1,           showh=showh2;
                     break;
      case Down   :  if(*ScrI>=Total_ITX_Line-1)break;    /* end already */
                     cmdflag=1;
                     if(*ScrI-*ScrJ==ITXPAGEL-1)    /* current at the bottom */
                        *ScrJ+=1, *ScrI+=1, showh=showh3;
                     else
                        *ScrI+=1,           showh=showh2;
                     break;
      case Home   :  if(*ScrI==*ScrJ)break;       /* current at the top already */
                     cmdflag=1;
                     *ScrI=*ScrJ,  showh=showh2;
                     break;
      case End    :  if(*ScrI-*ScrJ==ITXPAGEL-1)break;  /* current at the bottom already */
                     cmdflag=1;
                     *ScrI=*ScrJ+ITXPAGEL-1,
                     *ScrI=((*ScrI>=Total_ITX_Line-1)?Total_ITX_Line-1:*ScrI), showh=showh2;
                     break;
      case C_Home :  if(*ScrI==0)break;          /* current at home already */
                     cmdflag=1;
                     if(*ScrJ==0)                /* at the first page */
                        *ScrI=0,         showh=showh2;
                     else
                        *ScrJ=0, *ScrI=0, showh=showh1;
                     break;
      case C_End  :  if(*ScrI==Total_ITX_Line-1)break; /* current at the end already */
                     cmdflag=1;
                     if(*ScrJ>=Total_ITX_Line-ITXPAGEL && Total_ITX_Line>*ScrJ)   /* at the end page */
                        *ScrI=Total_ITX_Line-1,            showh=showh2;
                     else
                        *ScrJ=((Total_ITX_Line-ITXPAGEL<0)?0:Total_ITX_Line-ITXPAGEL), *ScrI=Total_ITX_Line-1, showh=showh1;
                     break;
      case PgUp   :  if(*ScrJ==0 && *ScrI==0)break;/* at the top already */
                     cmdflag=1;
                     if(*ScrJ==0)   /* at the first page */
                        *ScrI=0, showh=showh2;
                     else
                     {
                        tmpI=*ScrI-*ScrJ;
                        *ScrJ-=ITXPAGEL-1;             /* turn 1 page */
                        *ScrJ=(*ScrJ<0)?0:*ScrJ;
                        *ScrI=*ScrJ+tmpI;
                        showh=showh1;
                     }
                     break;
      case PgDn   :  if(*ScrJ>=Total_ITX_Line-ITXPAGEL && Total_ITX_Line>*ScrJ && *ScrI==Total_ITX_Line-1)break;/* at the end already */
                     cmdflag=1;
                     if(*ScrJ>=Total_ITX_Line-ITXPAGEL && Total_ITX_Line>*ScrJ)   /* at the end page */
                        *ScrI=Total_ITX_Line-1,            showh=showh2;
                     else
                     {
                        tmpI=*ScrI-*ScrJ;
                        *ScrJ+=ITXPAGEL-1;             /* turn 1 page */
                        *ScrJ=(*ScrJ>Total_ITX_Line-ITXPAGEL)?Total_ITX_Line-ITXPAGEL:*ScrJ;
                        *ScrI=*ScrJ+tmpI;
                        *ScrI=((*ScrI>=Total_ITX_Line-1)?Total_ITX_Line-1:*ScrI);
                        showh=showh1;
                     }
                     break;
      case C_PgUp :  if(*ScrJ==0)break;          /* at the first page already */
                     cmdflag=1;
                     tmpI=*ScrI-*ScrJ;
                     *ScrJ-=(ITXPAGEL-1)*5;         /* turn 5 page */
                     *ScrJ=(*ScrJ<0)?0:*ScrJ;
                     *ScrI=*ScrJ+tmpI;
                     showh=showh1;
                     break;
      case C_PgDn :  if(*ScrJ>=Total_ITX_Line-ITXPAGEL)break;/* at the end page already */
                     cmdflag=1;
                     tmpI=*ScrI-*ScrJ;
                     *ScrJ+=(ITXPAGEL-1)*5;         /* turn 5 page */
                     *ScrJ=(*ScrJ>Total_ITX_Line-ITXPAGEL)?Total_ITX_Line-ITXPAGEL:*ScrJ;
                     *ScrI=*ScrJ+tmpI;
                     *ScrI=((*ScrI>=Total_ITX_Line-1)?Total_ITX_Line-1:*ScrI);
                     showh=showh1;
                     break;
      case 0      :  cmdflag=1;                 /* I.C. at the current pos */
                     Clrscr2();
                     *ScrJ=(*ScrJ>Total_ITX_Line-ITXPAGEL)?Total_ITX_Line-ITXPAGEL:*ScrJ;
                     *ScrI=(*ScrI>Total_ITX_Line-1    )?Total_ITX_Line      :*ScrI;
                     *ScrJ=(*ScrJ<0)?0:*ScrJ;
                     *ScrI=(*ScrI<0)?0:*ScrI;
                     showh=showh1;
                     break;
   }
   showh(*ScrJ,*ScrI);
   if(cmdflag==0)return;            /* other key input */
   ShowITXInfo(*ScrI);
}
void NumberString(char **CharIndex,char *nstr,char numb)
{
   numb=(numb<0 || numb>99)?1:numb;
   if(numb/20>=1)                   /* three digit */ /* >=20 */
   {
      strcpy(nstr,CharIndex[(numb/10)-1]);            /* B */
      strcat(nstr,CharIndex[9]);                      /*  Q  */
      if(numb%10 != 0)                                /* Ӧ */
         strcat(nstr,CharIndex[(numb%10)-1]);
   }
   else  if(numb/10>=1)             /* two digit */   /* >=10 */
         {
            strcpy(nstr,CharIndex[9]);                /*  Q  */
            if(numb%10 != 0)
               strcat(nstr,CharIndex[(numb%10)-1]);   /* Ӧ */
         }
         else                       /* one digit */
            strcpy(nstr,CharIndex[numb-1]);           /* Ӧ */
}
extern char *menuselectmsg;
extern char *menuselectmsg2;
extern char *upperline;
extern char *lowerline;
char *FullNumb3[]={ "@", "G", "T", "|", "", "", "C", "K", "E", "Q"};
BOOL2 ShowITXfile(CWORDS *CC,char sTop,char sBottom,char *ITXFilename,void (func)())
{
   char *quit=  "^De";
   char *ITXIndexString;
   char **items;
   char **titleA;
   char *stmp;
   CWORDS *CCA;
   char **CharIndex;
   char totalitems;
   int II,JJ;                       /* JJ -- first line, II -- current line */
   int i,j,ch;

   CharIndex=FullNumb3;
   if(InitITX(ITXFilename)!=OK) return NotOK;
   ITXIndexString=(char *)calloc(7,sizeof(char)); /* Max 99 Index */
   items=(char **)calloc(100,sizeof(char));
   titleA=(char **)calloc(100,sizeof(char));
   CCA=(CWORDS *)calloc(100,sizeof(CWORDS));
   stmp=(char *)calloc(81,sizeof(char));

   if(stmp==NULL || coreleft()<64000L)
   {
      free(stmp);
      free(CCA);
      free(titleA);
      free(items);
      free(ITXIndexString);
      Message(1,0,0,"O餣I");
      return NotOK;
   }

   totalitems=0;
   NumberString(CharIndex,ITXIndexString,totalitems+1);
   JJ=strlen(ITXIndexString);
   for(II=0;II<=Total_ITX_Line;II++)
      if(strncmp(ITXIndexString,&ITXBuf[IndexOfITX[II]],JJ)==0)
      {
         items[totalitems]=(char *)calloc(81,sizeof(char));
         titleA[totalitems]=(char *)calloc(81,sizeof(char));
         strncpy(stmp,&ITXBuf[IndexOfITX[II]+JJ],80);stmp[80]='\0';
         StringKillString(stmp," ");
         StringKillString(stmp,"G");
         StringKillString(stmp,"D");
         StringKillString(stmp,"B");
         strncpy(titleA[totalitems],stmp,80);
         titleA[totalitems][80]='\0';
         CenterCstring2(items[totalitems],titleA[totalitems],80,1);
         CenterCwords(&CCA[totalitems],titleA[totalitems],2);
         totalitems++;
         NumberString(CharIndex,ITXIndexString,totalitems+1);
         JJ=strlen(ITXIndexString);
      }

   if(totalitems==0)    /* view as a TXT file */
   {
      Message(0,0,0,"NOT a ITX file");
      free(stmp);
      free(CCA);
      free(titleA);
      free(items);
      free(ITXIndexString);
      return;
   }

   items[totalitems]=(char *)calloc(81,sizeof(char));
   titleA[totalitems]=(char *)calloc(81,sizeof(char));
   strcpy(titleA[totalitems],quit);
   CenterCstring2(items[totalitems],titleA[totalitems],80,3);
   CenterCwords(&CCA[totalitems],titleA[totalitems],2);
   totalitems++;

   ICScreen();
   Clrscr();
   func();
   window(1,sTop,80,sBottom);
   ShowTextWindow2NoColor(items,totalitems,0);
   /*FlagOfShowingCwords=1;*/
   i=j=0;
   CenterCwords(CC,CC->words,4);
   while(TRUE)
   {
      window(1,1,80,24);
      Cwords(CC);
      Message(0,0,0,menuselectmsg2,menuselectmsg);
      Cursor(0);
      while((ch=TextWindow2(1,sTop,80,sBottom,totalitems,items,&i,&j,0))!=Esc && ch!=Enter);
      if(ch==Esc || i+1==totalitems)
      {
         break;
      }

      NumberString(CharIndex,ITXIndexString,i+1);
      JJ=strlen(ITXIndexString);
      for(II=0;II<=Total_ITX_Line;II++)
         if(strncmp(ITXIndexString,&ITXBuf[IndexOfITX[II]],JJ)==0)break;
      if(II==Total_ITX_Line+1) II=0;         /* not found */
      JJ=II;

      GetScreen(); Clrscr();
      Cwords(&CCA[i]);
      gotoxy(1,3); printf(upperline);
      gotoxy(1,24);printf(lowerline);
      ch=0;
      while(ch!=Esc)
      {
         ShowITX(&II,&JJ,ch);
         ch=bioskey(0);
      }
      Clrscr();
      PutScreen();
   }
   FreeScreen();

   for(i=totalitems-1;i>=0;i--) free(titleA[i]),free(items[i]);
   free(stmp);
   free(CCA);
   free(titleA);
   free(items);
   free(ITXIndexString);
   OffITX();
}
/*****************************************************************************
void ITXColor(int FFFF,int BBBB);
void ITXMark(char ScrII);
char InitITX(char *ITXFile);
void OffITX(void);
void showh1(int ScrJ,int ScrI);
void showh2(int ScrJ,int ScrI);
void showh3(int ScrJ,int ScrI);
void showh4(int ScrJ,int ScrI);
void ShowITXInfo(int ScrI);
void NoITXFound(int *ScrJ,int *ScrI);
void ShowITX(int *ScrJ,int *ScrI,int keystroke);
BOOL2 ShowITXfile(CWORDS *CC,char sTop,char sBottom,char *ITXFilename,void (func)());
******************************************************************************/
