/*****************************************************************************/
/* UNIO1.C       Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"daymain.i"

void OpenDBF(void)                           /* ver 0.249 */
{
   if(FlagOfOpeningDBF==1)return;            /* File Already Open */
   FlagOfOpeningDBF=1;
   if( (File_DBF=fopen(Current_DBF,"r+b"))==NULL )
   {
      Message(1,0,0,"Lk}ҸɡI%s",Current_DBF);
      exit(0);
   }
}
void CloseDBF(void)                          /* ver 0.249 */
{
   if(FlagOfOpeningDBF==0)return;            /* File Already Close */
   FlagOfOpeningDBF=0;
   fclose(File_DBF);
}
void Read_DBF_Header(DBF_Header *H,FILE *DBF_fptr)
{
   rewind(DBF_fptr);
   fread(H,sizeof(DBF_Header),1,DBF_fptr);      /* Read DBF Header */
}
void Write_DBF_Header(FILE *DBF_fptr)
{
   DBF_Header H;
   struct date dtmp;
   getdate(&dtmp);
   Read_DBF_Header(&H,DBF_fptr);
   H.year =(dtmp.da_year % 100);
   H.mon  = dtmp.da_mon;
   H.day  = dtmp.da_day;
   H.total=totalnumb;
   rewind(DBF_fptr);
   fwrite(&H,sizeof(DBF_Header),1,DBF_fptr);    /* write DBF Header */
   fflush(DBF_fptr);
}
void ReadOneUnit(DAYUNIT *Mtmp,int RecNo)
{
   OpenDBF();
   rewind(File_DBF);
   fseek(File_DBF,DBF_HeaderLen,SEEK_SET);
   fseek(File_DBF,(long)((long)RecNo*sizeof(DAYUNIT)),SEEK_CUR);
   fread((char *)Mtmp,sizeof(DAYUNIT),1,File_DBF);
}
void WriteOneUnit(DAYUNIT *Mtmp,int RecNo)
{
   OpenDBF();
   Write_DBF_Header(File_DBF);
   rewind(File_DBF);
   fseek(File_DBF,DBF_HeaderLen,SEEK_SET);
   fseek(File_DBF,(long)((long)RecNo*sizeof(DAYUNIT)),SEEK_CUR);
   fwrite((char *)Mtmp,sizeof(DAYUNIT),1,File_DBF);
   fflush(File_DBF);
}
void AppendOneUnit(DAYUNIT *Mtmp,FILE *MeAppend)
{
   fwrite((char *)Mtmp,sizeof(DAYUNIT),1,MeAppend);
   fflush(MeAppend);
}
char Load_DBF(void)
{
   BOOL2 change=NotOK;
   char *dbf_file;         /* Selected DBF file, and for Current_CFG usage */

   dbf_file=(char *)calloc(61,sizeof(char));
   SelectFile(1,1,20,"day___??.dbf","пܸJɮ",dbf_file,1);
   if(FileExist(dbf_file)==TRUE)
   {
      change=OK;
      strcpy(Current_DBF,dbf_file);
      Load_DBF2();
   }
   free(dbf_file);
   return change;
}
void Load_DBF2(void)
{
   DBF_Header *H;          /* Struct of DBF_Header , for read DBF_Header */
   char       *defaultfile;/* Default File Name */
   DAYUNIT     Unt;        /* Struct of DAYUNIT , temp for fread() */
   char   startx,starty,slen;
   int    k;

   H=(DBF_Header *)calloc(1,sizeof(DBF_Header));
   GetCurrent_CFG();
   if(FileExist(Current_CFG)!=TRUE)
   {
      Message(1,0,0,"䤣]wɡIHw]ɨNC");
      defaultfile=(char *)calloc(81,sizeof(char));
      GetPathFileName(defaultfile,IC_Path,"DAYCFG00",".CFG");
      Read_CFG(defaultfile);
      free(defaultfile);
      if(GetDiskFreeSpace(Current_CFG[0])>=1024L)
         Write_CFG(Current_CFG),
         Read_CFG(Current_CFG);
      else
         Message(1,0,0,"%sЪŶI]wɵLkإߡI",FullAlpha[Current_CFG[0]]);
   }
   else
      Read_CFG(Current_CFG);
   GetCurrent_SAT();
   if(FileExist(Current_SAT)!=TRUE)
   {
      Message(1,0,0,"䤣έpɡIHw]ɨNC");
      defaultfile=(char *)calloc(81,sizeof(char));
      GetPathFileName(defaultfile,IC_Path,"DAYSAT00",".SAT");
      Read_SAT(defaultfile);
      free(defaultfile);
      if(GetDiskFreeSpace(Current_SAT[0])>=512L)
         Write_SAT(Current_SAT),
         Read_SAT(Current_SAT);
      else
         Message(1,0,0,"%sЪŶIέpɵLkإߡI",FullAlpha[Current_CFG[0]]);
   }
   else
      Read_SAT(Current_SAT);

   CloseDBF();/* Close preverious DBF file (if possible) for loading new file */
   k=strlen(Current_DBF);
   CurrentYearOfDate[0]=Current_DBF[k-6],
   CurrentYearOfDate[1]=Current_DBF[k-5];
   OpenDBF();
   Read_DBF_Header(H,File_DBF);
   totalnumb=H->total;
   DBF_HeaderLen=(long)H->header_len;

   if(totalnumb>MaxRecords)
   {
      clrscr();
      printf("\7");
      printf("\nثe̦hiJ %d ",MaxRecords);
      printf("\nӦɤw %d ",totalnumb);
      MemNotEnough();
   }

   Reset_ALL();
   ResetMoney();
   C_IndexY=C_IndexN=0;
   strcpy(FirstDay,"49/12/31");
   strcpy(LastDay, "50/12/31");
   fseek(File_DBF,DBF_HeaderLen,SEEK_SET);

   InitDoing(&startx,&starty,"     O b   Ū    DDD   ",&slen,1);
   for(k=0;k<totalnumb;k++)               /* Read All Records */
   {
      Doing(startx,starty,100*((float)(k+1)/(float)totalnumb),slen,1);
      fread((char *)&Unt,sizeof(DAYUNIT),1,File_DBF);
      if(Unt.delete=='*') IndexN[C_IndexN++]=k;
      else
      {
         IndexY[C_IndexY++]=k,AddUnitMoney(&Unt);
         if(DateToL(Unt.date)<DateToL(FirstDay))strncpy(FirstDay,Unt.date,8);
         if(DateToL(Unt.date)>DateToL(LastDay)) strncpy(LastDay,Unt.date,8);
      }
      ConvertUntToShow(ALL[k],&Unt,k);
   }
   CalculateMoney();
   OffDoing(startx,starty,slen,1);
   CloseDBF();
   Cursor(0);
   free(H);
}

char Get_NewDBF(char *DBF_filename)
{
   char *messagewords="M̷s...%s%s~";
   struct ffblk F;      /* Struct for File Find */
   int  done;           /* Flag of File Search Done */
   int  findflag;       /* Flag of File Find */
   int  Year1,Year2;    /* Year of DBF_filename */
   char y[3];

   Message(0,0,0,messagewords,FullNumb[0],FullNumb[0]);
   Year1=Year2=0;
   findflag=0;
   done=findfirst("DAY___??.DBF",&F,FA_ARCH); /* Find Specific Filename */
   while(!done)
   {
      if(F.ff_attrib!=16)                 /* This file is  Wanted */
      {
         findflag=1;
         strncpy(y,&F.ff_name[6],2);
         y[2]='\0';
         Year1=atoi(y);
         if(Year1<60)Year1+=100;
         if(Year1>Year2)
         {
            strcpy(DBF_filename,IC_Path);
            strcat(DBF_filename,F.ff_name);
            Year2=Year1;
            Message(0,0,0,messagewords,FullNumb[y[0]-'0'],FullNumb[y[1]-'0']);
         }
      }
      done=findnext(&F);
   }                          /* Find file OK !! */
   if(findflag==0)
   {
      Clrscr();
      Message(1,0,0,"䤣ɡI");
      Message(0,0,0,"бz󴫥ؿAɮ׸JAΫ Ӣ HsWɡC");
      SelectFile(1,1,20,"day___??.dbf","пܸJɮ",DBF_filename,1);
      if(FileExist(DBF_filename)!=TRUE)
      {
         if(CreateNew()==OK)
            return OTHER;         /* OTHER -> New Data File Created */
         else
         {
            Message(1,0,0,"LɸJA{I");
            exit(0);
         }
      }
      else
         return OK;            /* OK -> file seleted in other path */
   }
   else
      return OK;               /* OK -> New Data File Found */
}
char Get_NewDBF_Restore(char *DBF_filename)
{
   char *messagewords="M̷s...%s%s~";
   struct ffblk F;      /* Struct for File Find */
   int  done;           /* Flag of File Search Done */
   int  findflag;       /* Flag of File Find */
   int  Year1,Year2;    /* Year of DBF_filename */
   char y[3];

   Message(0,0,0,messagewords,FullNumb[0],FullNumb[0]);
   Year1=Year2=0;
   findflag=0;
   done=findfirst("DAYBAK??.DBF",&F,FA_ARCH); /* Find Specific Filename */
   while(!done)
   {
      if(F.ff_attrib!=16)                 /* This file is  Wanted */
      {
         findflag=1;
         strncpy(y,&F.ff_name[6],2);
         y[2]='\0';
         Year1=atoi(y);
         if(Year1<60)Year1+=100;
         if(Year1>Year2)
         {
            strcpy(DBF_filename,F.ff_name);
            Year2=Year1;
            Message(0,0,0,messagewords,FullNumb[y[0]-'0'],FullNumb[y[1]-'0']);
         }
      }
      done=findnext(&F);
   }                          /* Find file OK !! */
   if(findflag==0)
   {
      Message(1,0,0,"䤣ƥɡI");
      return NotOK;            /* NotOK -> No File Found */
   }
   else
      return OK;               /* OK -> New Data File Found */
}
/******************************************************************************
void OpenDBF(void);
void CloseDBF(void);
void Read_DBF_Header(DBF_Header *H,FILE *DBF_fptr);
void Write_DBF_Header(FILE *DBF_fptr);
void ReadOneUnit(DAYUNIT *Mtmp,int RecNo);
void WriteOneUnit(DAYUNIT *Mtmp,int RecNo);
void AppendOneUnit(DAYUNIT *Mtmp,FILE *MeAppend);
char Load_DBF(void);
void Load_DBF2(void);
char Get_NewDBF(char *DBF_filename);
char Get_NewDBF_Restore(char *DBF_filename);
******************************************************************************/
