/*****************************************************************************/
/* UNIO1-2.C     Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"daymain.i"

char *upperb="";
char *lowerb="";
char *framebuf;
struct text_info BeforeCenterFrame;
void CenterFrame(char rownumb)
{
   gettextinfo(&BeforeCenterFrame);
   window(1,1,80,25);
   framebuf=(char *)calloc(rownumb*80*2,sizeof(char));
   gettext(1,(25-rownumb)/2,80,(25-rownumb)/2+rownumb-1,framebuf);
   window (1,(25-rownumb)/2,80,(25-rownumb)/2+rownumb-1);
   clrscr();
   gotoxy(1,1);printf(upperb);
   gotoxy(1,rownumb);printf(lowerb);
}
void FreeCenterFrame(char rownumb)
{
   clrscr();
   window(1,1,80,25);
   puttext(1,(25-rownumb)/2,80,(25-rownumb)/2+rownumb-1,framebuf);
   free(framebuf);
   normvideo();
   window(BeforeCenterFrame.winleft,BeforeCenterFrame.wintop,BeforeCenterFrame.winright,BeforeCenterFrame.winbottom);
}
char ModifyUnit(int RecNo_ScrI)
{
   char *mscrbuf;
   DAYUNIT Mtmp;
   int  locindex;
   locindex=ALL[IndexS[RecNo_ScrI]]->index;     /* file index */
   mscrbuf=(char *)calloc(80*24*2,sizeof(char));
   gettext(1,1,80,24,mscrbuf);
   Replace_Mode();
   OpenDBF();
   ReadOneUnit(&Mtmp,locindex);
   DelUnitMoney(&Mtmp);
   CalculateMoney();
   if(GetOneUnit(&Mtmp,0,1)==OK)
   {
      WriteOneUnit(&Mtmp,locindex);

      if(DateToL(Mtmp.date)<DateToL(FirstDay))        /* DW First Day */
         strncpy(FirstDay,Mtmp.date,8);
      if(DateToL(Mtmp.date)>DateToL(LastDay))         /* DW Last Day */
         strncpy(LastDay,Mtmp.date,8);

      ConvertUntToShow(ALL[IndexS[RecNo_ScrI]],&Mtmp,locindex);
      AddUnitMoney(&Mtmp);
      CalculateMoney();
      CloseDBF();
      CwordsOff2();
      free(mscrbuf);
      return OK;
   }
   ReadOneUnit(&Mtmp,locindex);
   AddUnitMoney(&Mtmp);
   CalculateMoney();
   CloseDBF();
   CwordsOff2();
   puttext(1,1,80,24,mscrbuf);
   free(mscrbuf);
   return NotOK;
}
void DeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI)
{
   DAYUNIT Mtmp;
   int  allindex;
   int  locindex;
   int  i;
   allindex=IndexS[*RecNo_ScrI];          /* ALL  index */
   locindex=ALL[allindex]->index;         /* file index */
   OpenDBF();
   ReadOneUnit(&Mtmp,locindex);
   DelUnitMoney(&Mtmp);
   CalculateMoney();
   Mtmp.delete='*';
   WriteOneUnit(&Mtmp,locindex);
   CloseDBF();
   ConvertUntToShow(ALL[allindex],&Mtmp,locindex);
                                          /* remove ALL index from show index */
   for(i=0;i<C_IndexS;i++)                      /* find that index */
      if(IndexS[i]==allindex)
         break;
   for(;i<C_IndexS;i++)
      IndexS[i]=IndexS[i+1];                    /* remove from indexS[] */
   C_IndexS-=1;

   C_IndexN=C_IndexY=0;                         /* reset IndexN[] & IndexY[] */
   for(i=0;i<totalnumb;i++)
      if(ALL[i]->delete=='*')IndexN[C_IndexN++]=i;
      else                   IndexY[C_IndexY++]=i;

   if(*RecNo_ScrJ>=C_IndexS-PAGEL)   /* delete data at the end page */
      *RecNo_ScrI-=1,*RecNo_ScrJ=C_IndexS-PAGEL;
   *RecNo_ScrI=(*RecNo_ScrI>C_IndexS-1) ? C_IndexS-1 : *RecNo_ScrI;
   *RecNo_ScrJ=(*RecNo_ScrJ<0) ? 0 : *RecNo_ScrJ;
}
void UnDeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI)
{
   DAYUNIT Mtmp;
   int  allindex;
   int  locindex;
   int  i;
   allindex=IndexS[*RecNo_ScrI];          /* ALL  index */
   locindex=ALL[allindex]->index;         /* file index */
   OpenDBF();
   ReadOneUnit(&Mtmp,locindex);
   AddUnitMoney(&Mtmp);
   CalculateMoney();
   Mtmp.delete=' ';
   WriteOneUnit(&Mtmp,locindex);

   if(DateToL(Mtmp.date)<DateToL(FirstDay))           /* DW First Day */
      strncpy(FirstDay,Mtmp.date,8);
   if(DateToL(Mtmp.date)>DateToL(LastDay))            /* DW Last Day */
      strncpy(LastDay,Mtmp.date,8);

   CloseDBF();
   ConvertUntToShow(ALL[allindex],&Mtmp,locindex);
                                          /* remove ALL index from show index */
   for(i=0;i<C_IndexS;i++)                      /* find that index */
      if(IndexS[i]==allindex)
         break;
   for(;i<C_IndexS;i++)
      IndexS[i]=IndexS[i+1];                    /* remove from indexS[] */
   C_IndexS-=1;

   C_IndexN=C_IndexY=0;                         /* reset IndexN[] & IndexY[] */
   for(i=0;i<totalnumb;i++)
      if(ALL[i]->delete=='*')IndexN[C_IndexN++]=i;
      else                   IndexY[C_IndexY++]=i;

   if(*RecNo_ScrJ>=C_IndexS-PAGEL)   /* undelete data at the end page */
      *RecNo_ScrI-=1,*RecNo_ScrJ=C_IndexS-PAGEL;
   *RecNo_ScrI=(*RecNo_ScrI>C_IndexS-1) ? C_IndexS-1 : *RecNo_ScrI;
   *RecNo_ScrJ=(*RecNo_ScrJ<0) ? 0 : *RecNo_ScrJ;
}
char DeleteUnit(int *RecNo_ScrJ,int *RecNo_ScrI)
{
   int  ch;

   UnMarkLine(*RecNo_ScrI-*RecNo_ScrJ+First);     /* need unmark line first */
   CenterFrame(7);
   ShowOneUnitWithHeader(2,ALL[IndexS[*RecNo_ScrI]]);
   gotoxy(25,6);printf("ƬO_nR]Bܡ^H");
   MarkLine(12);
   Cursor(2);
   Clear_KeyBuf();
   SetEnglishInput();
   ch=bioskey(0);
   ch=(ch==Esc)?N_N:ch;
   if(ch==N_Y || ch==S_Y)
      DeleteOneUnit(RecNo_ScrJ,RecNo_ScrI);
   Cursor(0);
   FreeCenterFrame(7);
   MarkLine(*RecNo_ScrI-*RecNo_ScrJ+First);   /* mark line */
   if(ch==N_Y || ch==S_Y)
   {
      Message(0,0,0,"ƤwRC");
      return OK;
   }
   else
   {
      Message(0,0,0,"ƥRC");
      return NotOK;
   }
}
char AddOneUnit(char drawflag)
{
   DAYUNIT Mtmp;
   BOOL2 cflag;
   CalculateMoney();
   if((cflag=GetOneUnit(&Mtmp,1,drawflag))==OK)    /* Input a new unit */
   {
      Message(0,1,0,"sɤDDD");
      IndexY[C_IndexY]=totalnumb;
      IndexS[C_IndexS]=totalnumb;
      totalnumb++;            /* totalnumb should change before write unit */
      WriteOneUnit(&Mtmp,totalnumb-1);

      if(DateToL(Mtmp.date)<DateToL(FirstDay))        /* DW First Day */
         strncpy(FirstDay,Mtmp.date,8);
      if(DateToL(Mtmp.date)>DateToL(LastDay))         /* DW Last Day */
         strncpy(LastDay,Mtmp.date,8);

      AddUnitMoney(&Mtmp);
      CalculateMoney();
      ConvertUntToShow(ALL[totalnumb-1],&Mtmp,totalnumb-1);
      C_IndexY++;C_IndexS++;
      Message(0,0,0,"sɧC");
   }
   return ((cflag==OK)? OK : NotOK);
}
char AddUnit(void)
{
   char *ascrbuf;
   char cflag1,cflag2;
   ascrbuf=(char *)calloc(80*24*2,sizeof(char));
   gettext(1,1,80,24,ascrbuf);
   Replace_Mode();
   OpenDBF();
   cflag1=cflag2=0;
   do{
      if(GetDiskFreeSpace(Current_DBF[0])<GetDiskMinBlock(Current_DBF[0]))
      {
         Message(1,0,0,"%sЪŶILkAsWơI",FullAlpha[Current_CFG[0]]);
         break;
      }
      if(totalnumb>=MaxRecords)
      {
         Message(1,0,0,"ѾlOŶILkAsWơI");
         break;
      }
      cflag1=(cflag2==0)?AddOneUnit(1) :AddOneUnit(0);
      if(cflag1!=1)break;        /* No unit input */
      cflag2++;
   }while(cflag1==1);
   CloseDBF();
   CwordsOff2();
   puttext(1,1,80,24,ascrbuf);
   free(ascrbuf);
   if(cflag2>=1)
   {
      Message(0,0,0,"ƿJAæsɧC");
      return OK;                   /* at least 1 unit input -> 1 */
   }
   else
      return NotOK;                   /* no data input */
}
void ReStructure(void)        /*  -- RwR */
{
   char   *tmpfile;
   char   *writetmp;
   FILE   *DBFtmp;
   DAYUNIT Mtmp;
   int    ch;
   int    i,j,ccount;
   char   startx,starty,slen;

   if(C_IndexN==0)
   {
      Message(1,0,0,"ObɨSQRơAC");
      return;
   }
   CenterFrame(7);
   gotoxy(24,3);
   printf("Obɦ %d QRơC",C_IndexN);
   gotoxy(15,5);
   printf("O_nN %d ƱqObɤhH]Bܡ^",C_IndexN);
   Cursor(2);
   Clear_KeyBuf();
   SetEnglishInput();
   ch=bioskey(0);
   ch=(ch==Esc)?N_N:ch;
   Cursor(0);
   FreeCenterFrame(7);

   if(!(ch==N_Y || ch==S_Y))return;

   if(GetDiskFreeSpace(Current_DBF[0])<(DBF_HeaderLen+C_IndexY*sizeof(DAYUNIT)))
   {
      Message(1,0,0,"%sЪŶILkȦsơI",FullAlpha[Current_CFG[0]]);
      return;
   }
   tmpfile=(char *)calloc(81,sizeof(char));
   writetmp=(char *)calloc(DBF_HeaderLen,sizeof(char));
   GetPathFileExt(tmpfile,Current_DBF,"._T_");
   if( (DBFtmp=fopen(tmpfile,"wb")) == NULL)
   {
      Message(1,0,0,"Ȧsɮ׶}ҿ~ I");
      free(writetmp);
      free(tmpfile);
      return;
   }
   OpenDBF();
   InitDoing(&startx,&starty,"     O b        DDD   ",&slen,1);
   rewind(File_DBF);
   fread(writetmp,sizeof(char),DBF_HeaderLen,File_DBF);
   fwrite(writetmp,sizeof(char),DBF_HeaderLen,DBFtmp);
   for(i=0,ccount=0;i<totalnumb;i++)
   {
      Doing(startx,starty,100.0*((float)i/(float)totalnumb),slen,1);
      ReadOneUnit(&Mtmp,i);
      if(Mtmp.delete==' ')
         AppendOneUnit(&Mtmp, DBFtmp), ccount++;
   }
   C_IndexN=0;                      /* no one unit is deleted */
   memset(IndexN,0,sizeof(int)*MaxRecords);
   totalnumb=ccount;
   Doing(startx,starty,100,slen,1);
   Write_DBF_Header(DBFtmp);
   OffDoing(startx,starty,slen,1);
   CloseDBF();
   fclose(DBFtmp);
   remove(Current_DBF);
   rename(tmpfile,Current_DBF);
   free(writetmp);
   free(tmpfile);
   Message(0,0,0,"ɮ׭㧹C");
}
char UnDeleteUnit(void)
{
   char *messagewords="HܸơAEnter Ϧ^ơAF8BEsc ^ɡC";
   char *scrbufall;
   int  ScrII,ScrJJ;
   int  CurrentDataTypeBak,CurrentSortTypeBak;
   int  ch;
   char undeleteflag;

   CurrentDataTypeBak=CurrentDataType;
   CurrentSortTypeBak=CurrentSortType;
   CurrentDataType=3;
   CurrentSortType=1;

   scrbufall=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbufall);

   ScrJJ=ScrII=0;
   No2Show();
   ShowUnit(&ScrJJ,&ScrII,0);
   undeleteflag=0;
   Message(0,0,0,messagewords);
   SetEnglishInput();
   while(1)
   {
      ch=bioskey(0);
      Message(0,0,0,messagewords);
      switch(ch)
      {
         case Enter  :
            UnMarkLine(ScrII-ScrJJ+First);     /* need unmark line first */
            CenterFrame(7);
            ShowOneUnitWithHeader(2,ALL[IndexS[ScrII]]);
            gotoxy(25,6);printf("ƬO_nϦ^]^H");
            MarkLine(12);
            Cursor(2);
            Clear_KeyBuf();
            SetEnglishInput();
            ch=bioskey(0);
            ch=(ch==Esc)?N_N:ch;
            Cursor(0);
            FreeCenterFrame(7);
            if(ch!=N_N && ch!=S_N)
               UnDeleteOneUnit(&ScrJJ,&ScrII),undeleteflag=1;
            MarkLine(ScrII-ScrJJ+First);   /* mark line */
            ShowUnit(&ScrJJ,&ScrII,2);
            if(ch!=N_N && ch!=S_N)
               Message(0,0,0,"ƤwϦ^C");
            else
               Message(0,0,0,"ƥϦ^C");
            if(C_IndexS!=0)break;            /* if still have data than go on */
                                             /* else than  exit */
         case Esc    : case F8     :
            CurrentDataType=CurrentDataTypeBak;
            CurrentSortType=CurrentSortTypeBak;
            Yes2Show();
            if(undeleteflag==0)
               puttext(1,1,80,24,scrbufall);
            free(scrbufall);
            MessageOff();
            if(undeleteflag==0)  return NotOK;
            else                 return OK;

         case Up     : case Down   :
         case Home   : case End    :
         case PgUp   : case PgDn   :
         case C_PgUp : case C_PgDn :
         case C_Home : case C_End  : ShowUnit(&ScrJJ,&ScrII,ch);  break;
      }
   }
}
/******************************************************************************
void CenterFrame(char rownumb);
void FreeCenterFrame(char rownumb);
char ModifyUnit(int RecNo_ScrI);
void DeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
void UnDeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
char DeleteUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
char AddOneUnit(char drawflag);
char AddUnit(void);
void ReStructure(void);
char UnDeleteUnit(void);
******************************************************************************/
