/*****************************************************************************/
/* UNIO1-3.C     Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"memain.i"

char *unitheader=
            ";ɦW : MEUTL.CFG\n"
            ";\n"
            ";for UNIT\n"
            ";榡:\n"
            ";A=B=B    \n"
            ";         \n"
            ";x  x       |w W (Ӥr,tťճ̦heQ)\n"
            ";x  |wwwww  ² (TӤr,tťճ̦he)\n"
            ";|wwwwwww  N (A  M) ̦hQTء]tťա^\n"
            "; =  w=      w\n"
            ";\n"
            ";x\n"
            ";|wwwwwww  ť,|]wκA\n";
char *typeheader=
            ";for TYPE\n"
            ";榡:\n"
            ";A=~\n"
            "; \n"
            ";x |wwwww   W (Ӥr,tťճ̦he|)\n"
            ";|wwwwwww  N (A  D) ̦h|ء]tťա^\n"
            "; =w\n"
            ";\n"
            ";x\n"
            ";|wwwwwww  ť,|]wκA\n";
char *endfooter=
            ";H \";\" }Y,(Remark Line)\n"
            ";\n"
            ";C@W٦bwqᶷ@欰\n"
            ";[END]\n";
char *unitbegin="[W]\n";
char *typebegin="[ڶW]\n";
char *ending   ="[END]\n";

void Write_CFG(char *CFG_filename)     /* Setting unitshort[],unitlong[], */
{                                      /* and typeshort[]                 */
   int   i;

   if(GetDiskFreeSpace(CFG_filename[0])<1024L)
   {
      Message(1,0,0,"%sЪŶI]wɵLkإߡI",FullAlpha[CFG_filename[0]]);
      return;
   }
   if( (File_CFG=fopen(CFG_filename,"w"))==NULL)
   {
      Message(1,0,0,"]wɼgJ~I");
      return;
   }
   fprintf(File_CFG,"%s\n",unitheader);
   fprintf(File_CFG,"%s\n",unitbegin);
   for(i=0;i<unit_num;i++)
   {
      if(i==0)
         fprintf(File_CFG," =%6s=%10s\n",unitshort[i],unitlong[i]);
      else
         fprintf(File_CFG,"%c=%6s=%10s\n",'A'+i-1,unitshort[i],unitlong[i]);
   }
   fprintf(File_CFG,"\n%s\n",ending);

   fprintf(File_CFG,"%s\n",typeheader);
   fprintf(File_CFG,"%s\n",typebegin);
   for(i=0;i<type_num;i++)
   {
      if(i==0)
         fprintf(File_CFG," =%4s\n",typeshort[i]);
      else
         fprintf(File_CFG,"%c=%4s\n",'A'+i-1,typeshort[i]);
   }
   fprintf(File_CFG,"\n%s\n",ending);
   fprintf(File_CFG,"%s",endfooter);
   fclose(File_CFG);                            /* Close CFG file */
}
void Read_CFG(char *CFG_filename)      /* Setting unitshort[],unitlong[], */
{                                      /* and typeshort[] from CFG file   */
   char *linetemp;     /* Size : 20 */ /* read line temp from file */
   char *nullunitshort="      ";
   char *nullunitlong ="          ";
   char *nulltypeshort="    ";
   char  unitflag=0;                   /* If unit setting in CFG file */
   char  typeflag=0;                   /* If type setting in CFG file */
   int   i;

   unit_num=0; type_num=0;
   linetemp=(char *)calloc(22,sizeof(char)); /* Memory locate for Data */
   if( (File_CFG=fopen(CFG_filename,"r"))==NULL)
   {
      Message(1,0,0,"]wŪ~I");
      exit(0);
   }

   for(;fgets(linetemp,22,File_CFG)!=NULL;)
   {
      if(linetemp[0]==';')continue;              /* Deal with remark line */
      if(strnicmp(linetemp,"[W]",10)==0)  /* if [W] */
      {  unitflag=1;continue; }
      if(strnicmp(linetemp,"[ڶW]",10)==0)  /* if [ڶW] */
      {  typeflag=1;continue; }
      if(strnicmp(linetemp,"[END]",5)==0)       /* if [END] */
      {  unitflag=0;typeflag=0;continue;  }
      if(unitflag==1 && ( (linetemp[0] >= 'A' && linetemp[0] <= 'A'+UNIT_KINDS) || strncmp(linetemp," =",2)==0 ) )
      {
         i=(linetemp[0]==' ') ? 0 : linetemp[0]-'A'+1 ;
         if(linetemp[1]=='=')
            strncpy(unitshort[i],&linetemp[2],6);
         unitshort[i][6]='\0';
         unit_num++;                            /* Count include ' ' */
         if(linetemp[8]=='=')
            strncpy(unitlong[i],&linetemp[9],10);
         unitlong[i][10]='\0';
         continue;
      }
      if(typeflag==1 && ( (linetemp[0] >= 'A' && linetemp[0] <= 'A'+TYPE_KINDS) || strncmp(linetemp," =",2)==0 ) )
      {
         i=(linetemp[0]==' ') ? 0 : linetemp[0]-'A'+1 ;
         if(linetemp[1]=='=')
            strncpy(typeshort[i],&linetemp[2],4);
         typeshort[i][4]='\0';
         type_num++;                            /* Count include ' '*/
      }
   }
   fclose(File_CFG);                            /* Close CFG file */
   free(linetemp);                      /* free unused memory */

   for(i=unit_num;i<=UNIT_KINDS;i++)
      strcpy(unitshort[i],nullunitshort),
      strcpy(unitlong[i], nullunitlong);
   for(i=type_num;i<=TYPE_KINDS;i++)
      strcpy(typeshort[i],nulltypeshort);
/*                                              /* Check */
   for(i=0;i<unit_num;i++)
      printf("\n%c=%s=%s",'A'+i-1,unitshort[i],unitlong[i]);
   for(i=0;i<type_num;i++)
      printf("\n%c=%s",'A'+i-1,typeshort[i]);
   getch();                                              */
}
/******************************************************** Layout Mode *********
1
2        ]w~ץN
3
4
5                    N      ²                 W
6        W     A   =   [123456]   =   [1234567890]
7                     B   =   [123456]   =   [1234567890]
8                     C   =   [123456]   =   [1234567890]
9                     D   =   [123456]   =   [1234567890]
01                    E   =   [123456]   =   [1234567890]
1                     F   =   [123456]   =   [1234567890]
2                     G   =   [123456]   =   [1234567890]
3                     H   =   [123456]   =   [1234567890]
4                     I   =   [123456]   =   [1234567890]
5                     J   =   [123456]   =   [1234567890]
6                     K   =   [123456]   =   [1234567890]
7                     L   =   [123456]   =   [1234567890]
8                     M   =   [123456]   =   [1234567890]
9
02       ڶW     A   =   [1234]
1                     B   =   [1234]
2                     C   =   [1234]
3                     D   =   [1234]
4
 ]wAХ Ԣ s C  Ӣ ]w C
******************************************************************************/

char SetSubstitution(void)
{
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   char *scrbuf;                    /* screen buffer */
   char *format1="      ";          /* format of unitshort */
   char *format2="          ";      /* format of unitlong  */
   char *format3="    ";            /* format of typeshort */
   char *helpmsg="]wAХ Ԣ s C  Ӣ ]w C";
   char Totalitem=30;
   char Hlen[]={  6,10, 6,10, 6,10, 6,10, 6,10,
                  6,10, 6,10, 6,10, 6,10, 6,10,
                  6,10, 6,10, 6,10, 4, 4, 4, 4};
   CWORDS CC;
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem;i++)total_stemp+=Hlen[i]+1;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen[i++]+1)
      stemp[i]=(sstemp+total_stemp);
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);

   normvideo();
   Clrscr();                                       /* Drawing Screen */
   /* ToCwords(&CC,"]w~ץN",48,90,10,36,'o'); */
   CenterCwords(&CC,"]w~ץN",3);             /* ver 1.0 */
   Cwords2(&CC);
   gotoxy(22, 5); printf("N      ²                 W");
   gotoxy(10, 6); printf("W");
   gotoxy(10,20); printf("ڶW");
   for(i=0;i<UNIT_KINDS;i++)
   {
      strcpy(stemp[i*2],unitshort[i+1]);
      strcpy(stemp[i*2+1],unitlong [i+1]);
      gotoxy(23,6+i);
      printf("%c   =   [",'A'+i);
      DrawWords2(stemp[i*2],wherex(),wherey(),Hlen[i*2]);
      printf("]   =   [");
      DrawWords2(stemp[i*2+1],wherex(),wherey(),Hlen[i*2+1]);
      printf("]");
   }
   for(i=0;i<TYPE_KINDS;i++)
   {
      strcpy(stemp[UNIT_KINDS*2+i],typeshort[i+1]);
      gotoxy(23,20+i);
      printf("%c   =   [",'A'+i);
      DrawWords2(stemp[UNIT_KINDS*2+i],wherex(),wherey(),Hlen[UNIT_KINDS*2+i]);
      printf("]");
   }
   Replace_Mode();
   do{
      Message(0,0,0,helpmsg);
      ch=0;eitem=0;
      while(1)
      {
         SetChineseInput();
         switch(eitem)
         {
            case  0: case  2: case  4: case  6: case  8:
            case 10: case 12: case 14: case 16: case 18:
            case 20: case 22: case 24:
               ch=FGetWords(stemp[eitem],format1,32,6+eitem/2);
               DrawWords2(stemp[eitem],32,6+eitem/2,Hlen[eitem]);
               break;

            case  1: case  3: case  5: case  7: case  9:
            case 11: case 13: case 15: case 17: case 19:
            case 21: case 23: case 25:
               ch=FGetWords(stemp[eitem],format2,47,6+(eitem-1)/2);
               DrawWords2(stemp[eitem],47,6+(eitem-1)/2,Hlen[eitem]);
               break;

            case 26: case 27: case 28: case 29:
               ch=FGetWords(stemp[eitem],format3,32,20+eitem-UNIT_KINDS*2);
               DrawWords2(stemp[eitem],32,20+eitem-UNIT_KINDS*2,Hlen[eitem]);
               break;
         }
         if(ch==F2)break;              /* Save */
         if(ch==Esc)                   /* Exit No save */
         {
            CwordsOff2();
            puttext(1,1,80,24,scrbuf);
            free(scrbuf);
            free(sstemp);
            free(stemp);
            Cursor(0);
            Message(0,0,0,"~ץN]wSܡC");
            return NotOK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem-1)?0:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?Totalitem-1:eitem-1;
      }
      SetEnglishInput();
      Message(0,0,1,"]w~ץNAO_sɡH]^");
      Cursor(2);
      Clear_KeyBuf();
      ch=bioskey(0);
      ch=(ch==Esc)?N_N:ch;
      Cursor(0);
   }while(ch==N_N||ch==S_N);
   Message(0,1,0,"~ץN]wxsDDD");
                                          /* find the last substitution */
   unit_num=type_num=1;
   for(i=0;i<UNIT_KINDS;i++)
      if(strcmp(stemp[i*2],format1)!=0 && strcmp(stemp[i*2+1],format2)!=0)
      {
         unit_num++;
         strcpy(unitshort[i+1],stemp[i*2]);
         strcpy(unitlong [i+1],stemp[i*2+1]);
      }
      else
      {
         for(;i<UNIT_KINDS;i++)
            strcpy(unitshort[i+1],format1),
            strcpy(unitlong [i+1],format2);
      }

   for(i=0;i<TYPE_KINDS;i++)
      if(strcmp(stemp[UNIT_KINDS*2+i],format3)!=0)
      {
         type_num++;
         strcpy(typeshort[i+1],stemp[UNIT_KINDS*2+i]);
      }
      else
      {
         for(;i<TYPE_KINDS;i++)
            strcpy(typeshort[i+1],format3);
      }

   Write_CFG(Current_CFG);

   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   free(sstemp);
   free(stemp);
   Cursor(0);
   Message(0,0,0,"~ץN]wxsC");
   return OK;
}
/******************************************************************************
void Write_CFG(char *CFG_filename);
void Read_CFG(char *CFG_filename);
char SetSubstitution(void);
******************************************************************************/
