/*****************************************************************************/
/* UNIO1-4.C     Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"memain.i"

void Write_SAT(char *SAT_filename)
{
   STATHEAD htmp;
   int   i,j;

   if(GetDiskFreeSpace(SAT_filename[0])<512L)
   {
      Message(1,0,0,"%sЪŶIέpɵLkإߡI",FullAlpha[SAT_filename[0]]);
      return;
   }
   if( (File_SAT=fopen(SAT_filename,"wb"))==NULL)
   {
      Message(1,0,0,"wɼgJ~I");
      return;
   }
   htmp.ID1[0]='S';                       /* prepare header of SAT file */
   htmp.ID1[1]='A';
   htmp.ID1[2]='T';
   htmp.units=UNIT_KINDS;
   htmp.types=TYPE_KINDS;
   for(i=0;i<sizeof(STATHEAD)-5;i++)
      htmp.ID2[i]='\0';
   fwrite(&htmp,sizeof(STATHEAD),1,File_SAT);   /* Write Sat Header */
   fwrite(STATSET,sizeof(long),TYPE_KINDS,File_SAT);
   fwrite(STSET,sizeof(long),UNIT_KINDS*TYPE_KINDS,File_SAT);
   fflush(File_SAT);
   fclose(File_SAT);                            /* Close CFG file */
}
void Read_SAT(char *SAT_filename)
{
   STATHEAD htmp;
   int   i,j;

   if( (File_SAT=fopen(SAT_filename,"rb"))==NULL)
   {
      Message(1,0,0,"wŪ~I");
      exit(0);
   }
   fread(&htmp,sizeof(STATHEAD),1,File_SAT);    /* Read Sat Header */
   if(htmp.ID1[0]!='S' || htmp.ID1[1]!='A' || htmp.ID1[2]!='T')
   {
      Message(1,0,0,"wɸƿ~I");
      exit(0);
   }
   fread(STATSET,sizeof(long),TYPE_KINDS,File_SAT);
   fread(STSET,sizeof(long),UNIT_KINDS*TYPE_KINDS,File_SAT);
   fclose(File_SAT);                            /* Close CFG file */
}
/******************************************************** Layout Mode *********
1
2        ]w~׹w
3
4
5  zwwwwwwwswwwwwwswwwwwwswwwwwwswwwwww{
6  x     @ ڶ  x  ~      x        x  ]      x  12    34  x
7  x   @     x            x            x            x            x
8  
9  x  `  g  O  x [12345678] x [12345678] x [12345678] x  12345678  x
0  x  B      x [12345678] x [12345678] x [12345678] x  12345678  x
1  x  ҥ~ʲ  x [12345678] x [12345678] x [12345678] x  12345678  x
2  x    |    x [12345678] x [12345678] x [12345678] x  12345678  x
3  x  ͬɲ  x [12345678] x [12345678] x [12345678] x  12345678  x
4  x  ~ɫ  x [12345678] x [12345678] x [12345678] x  12345678  x
5  x  åͫO  x [12345678] x [12345678] x [12345678] x  12345678  x
6  x  ߲zɫ  x [12345678] x [12345678] x [12345678] x  12345678  x
7  x   ĳ |  x [12345678] x [12345678] x [12345678] x  12345678  x
8  x  ͻɫ  x [12345678] x [12345678] x [12345678] x  12345678  x
9  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
0  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
1  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
2  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
3  |wwwwwwwrwwwwwwrwwwwwwrwwwwwwrwwwwww}
4
 ]wAХ Ԣ s C  Ӣ ]w C
******************************************************************************/
void DrawTable(void)
{
   char *vframe="sxr";
   char *hframe="";
   int  i,j;

   CFrame(4,5,76,23,4);
   for(i=0;i<4;i++)
      gotoxy(20+i*14,5),printf("%c%c",vframe[0],vframe[1]);
   for(j=6;j<=22;j++)
      for(i=0;i<4;i++)
         gotoxy(20+i*14,j),printf("%c%c",vframe[2],vframe[3]);
   for(i=0;i<4;i++)
      gotoxy(20+i*14,23),printf("%c%c",vframe[4],vframe[5]);
   gotoxy(4,8);
      printf(hframe);
   for(i=0;i<type_num-1;i++)
      gotoxy(24+14*i,6),printf("%c%c",typeshort[i+1][0],typeshort[i+1][1]),
      gotoxy(30+14*i,6),printf("%c%c",typeshort[i+1][2],typeshort[i+1][3]);
   gotoxy(8,9);printf("`  g  O");
   for(i=0;i<unit_num-1;i++)
      gotoxy(8,10+i),printf("%s",unitlong[i+1]);
   gotoxy(11,6);printf("@ ڶ");
   gotoxy( 8,7);printf(" @");
}
char SetBudget(void)
{
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   char *scrbuf;                    /* screen buffer */
   char *format="        ";         /* format of unitshort */
   char *helpmsg="]wAХ Ԣ s C  Ӣ ]w C";
   char Totalitem=56;               /* Maximum items to edit */
   char Hlen=8;                     /* length of each items */
   CWORDS CC;
   long TTASET[TYPE_KINDS];
   long TTASUM[TYPE_KINDS];
   long TTSET[UNIT_KINDS][TYPE_KINDS];
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char i,j;

   if((type_num-1)<=0)
   {
      Message(1,0,0,"Х]wڶNI");
      return NotOK;
   }
   Totalitem=unit_num*(type_num-1);
   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   total_stemp=(Hlen+1)*Totalitem;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen+1,i++)
      stemp[i]=(sstemp+total_stemp);
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);

   normvideo();
   Clrscr();                                       /* Drawing Screen */
   /* ToCwords(&CC,"]w~׹w",48,90,10,36,'o'); */
   CenterCwords(&CC,"]w~׹w",3);             /* ver 1.0 */
   Cwords2(&CC);
   DrawTable();


   for(j=0;j<type_num-1;j++)
   {
      ltoa(STATSET[j],stemp[j*unit_num],10);
      gotoxy(23+j*14,9);printf("[");
      DrawWords2(stemp[j*unit_num],wherex(),wherey(),Hlen);
      printf("]");
   }
   for(i=0;i<unit_num-1;i++)
      for(j=0;j<type_num-1;j++)
      {
         ltoa(STSET[i][j],stemp[j*unit_num+(i+1)],10);
         gotoxy(23+j*14,10+i);printf("[");
         DrawWords2(stemp[j*unit_num+(i+1)],wherex(),wherey(),Hlen);
         printf("]");
      }

   Replace_Mode();
   ch=0;eitem=0;
   do{
      Message(0,0,0,helpmsg);
      while(1)
      {
         SetEnglishInput();
         eitem=(eitem>=Totalitem-1)?Totalitem-1:eitem;
         eitem=(eitem<=0)?0:eitem;
         ch=FGetWords(stemp[eitem],format,24+(eitem/unit_num)*14,9+(eitem%unit_num));
         DrawWords2(stemp[eitem],24+(eitem/unit_num)*14,9+(eitem%unit_num),Hlen);
         if(ch==F2)break;              /* Save */
         if(ch==Esc)                   /* Exit No save */
         {
            CwordsOff2();
            puttext(1,1,80,24,scrbuf);
            free(scrbuf);
            free(sstemp);
            free(stemp);
            Cursor(0);
            Message(0,0,0,"~׹w]wSܡC");
            return NotOK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem-1)?0:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?Totalitem-1:eitem-1;
      }
      /* need to check data if not satisfy continue */
      memset(TTASET,0,TYPE_KINDS*sizeof(long));
      memset(TTASUM,0,TYPE_KINDS*sizeof(long));
      memset(TTSET,0,UNIT_KINDS*TYPE_KINDS*sizeof(long));
      for(j=0;j<type_num-1;j++)
         TTASET[j]=atol(stemp[j*unit_num]);
      for(j=0;j<type_num-1;j++)
         for(i=0;i<unit_num-1;i++)
            TTSET[i][j]=atol(stemp[j*unit_num+(i+1)]),
            TTASUM[j]+=TTSET[i][j];
      ch=0;
      for(j=0;j<type_num-1;j++)
         if(TTASET[j]<TTASUM[j])ch=1;
      if(ch==1)
      {
         Message(1,0,0,"~׹w]wJȦDIбzATwC");
         Clear_KeyBuf();
         bioskey(0);
         eitem=0;
         ch=N_N;
         continue;
      }
      /* check ok */
      SetEnglishInput();
      Message(0,0,1,"]w~׹w⧹AO_sɡH]^");
      Cursor(2);
      Clear_KeyBuf();
      ch=bioskey(0);
      ch=(ch==Esc)?N_N:ch;
      Cursor(0);
   }while(ch==N_N||ch==S_N);
   gotoxy(1,1);
   Message(0,1,0,"~׹w]wxsDDD");

   memset(STATSET,0,TYPE_KINDS*sizeof(long));
   memset(STSET,0,UNIT_KINDS*TYPE_KINDS*sizeof(long));
   for(j=0;j<type_num-1;j++)
      STATSET[j]=TTASET[j];
   for(j=0;j<type_num-1;j++,printf("\n"))
      for(i=0;i<unit_num-1;i++)
         STSET[i][j]=TTSET[i][j];

   Write_SAT(Current_SAT);

   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   free(sstemp);
   free(stemp);
   Cursor(0);
   CalculateMoney();
   Message(0,0,0,"~׹w]wxsC");
   return OK;
}
/******************************************************************************
void Write_SAT(char *SAT_filename);
void Read_SAT(char *SAT_filename);
void DrawTable(void);
char SetBudget(void);
******************************************************************************/
