/*****************************************************************************/
/* UNIO1-4.C     Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"daymain.i"

void Write_SAT(char *SAT_filename)
{
   STATHEAD htmp;
   int   i,j;

   if(GetDiskFreeSpace(SAT_filename[0])<512L)
   {
      Message(1,0,0,"%sЪŶIέpɵLkإߡI",FullAlpha[SAT_filename[0]]);
      return;
   }
   if( (File_SAT=fopen(SAT_filename,"wb"))==NULL)
   {
      Message(1,0,0,"wɼgJ~I");
      return;
   }
   htmp.ID1[0]='S';                       /* prepare header of SAT file */
   htmp.ID1[1]='A';
   htmp.ID1[2]='T';
   htmp.account=ACCOUNT_KINDS;
   for(i=0;i<sizeof(STATHEAD)-4;i++)
      htmp.ID2[i]='\0';
   fwrite(&htmp,sizeof(STATHEAD),1,File_SAT);   /* Write Sat Header */
   fwrite(AccountLEST,sizeof(double),ACCOUNT_KINDS,File_SAT);
   fflush(File_SAT);
   fclose(File_SAT);                            /* Close CFG file */
}
void Read_SAT(char *SAT_filename)
{
   STATHEAD htmp;
   int   i,j;

   if( (File_SAT=fopen(SAT_filename,"rb"))==NULL)
   {
      Message(1,0,0,"wŪ~I");
      exit(0);
   }
   fread(&htmp,sizeof(STATHEAD),1,File_SAT);    /* Read Sat Header */
   if(htmp.ID1[0]!='S' || htmp.ID1[1]!='A' || htmp.ID1[2]!='T')
   {
      Message(1,0,0,"wɸƿ~I");
      exit(0);
   }
   fread(AccountLEST,sizeof(double),ACCOUNT_KINDS,File_SAT);
   fclose(File_SAT);                            /* Close CFG file */
}
/******************************************************** Layout Mode *********
1
2                             ]wWUbᤧ
3
4
5
6                       zwwwwwwswwwwwww{
7                       xb        x W     x
8                       uwwwwwwqwwwwwwwt
9                       x   b x[123456789012]x
0                       xs ï  b x[123456789012]x
1                       xs ï  b x[123456789012]x
2                       xs ï  b x[123456789012]x
3                       xs ï  b x[123456789012]x
4                       xs ï  b x[123456789012]x
5                       xs ï  b x[123456789012]x
6                       xs ï  b x[123456789012]x
7                       xs ï  b x[123456789012]x
8                       xs ï  b x[123456789012]x
9                       |wwwwwwrwwwwwww}
 ]wAХ Ԣ s C  Ӣ ]w C
******************************************************************************/
void DrawTable(void)
{
   char *vframe="sxr";
   char *titleofframe="b        x W    ";
   char *hframe="uwwwwwwqwwwwwwwt";
   int  i;

   CFrame(25,6,55,19,4);
   printfXY(39,6,"%c%c",vframe[0],vframe[1]);
   printfXY(27,7,titleofframe);
   printfXY(25,8,hframe);
   for(i=9;i<=18;i++)
      printfXY(39,i,"%c%c",vframe[2],vframe[3]);
   printfXY(39,19,"%c%c",vframe[4],vframe[5]);

   for(i=0;i<account_num;i++)
      printfXY(27,9+i,account[i+1]);
}
char SetBudget(void)
{
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   char *scrbuf;                    /* screen buffer */
   char *format="            ";     /* format of unitshort */
   char *helpmsg="]wAХ Ԣ s C  Ӣ ]w C";
   char *titlemsg="]wWUbᤧ";
   char Totalitem=10;               /* Maximum items to edit */
   char Hlen=12;                    /* length of each items */
   CWORDS CC;
   double TTLEST[ACCOUNT_KINDS];    /* temp used for AccountLEST */
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char i,j;

   if((account_num-1)<=0)
   {
      Message(1,0,0,"Х]wbNI");
      return NotOK;
   }
   Totalitem=account_num-1;
   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   total_stemp=(Hlen+1)*Totalitem;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen+1,i++)
      stemp[i]=(sstemp+total_stemp);
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);

   normvideo();
   Clrscr();                                       /* Drawing Screen */
   /* CenterCwords(&CC,titlemsg,48); */
   CenterCwords(&CC,titlemsg,3);                   /* ver 0.248 */
   Cwords2(&CC);
   DrawTable();

   for(i=0;i<account_num-1;i++)
   {
      gcvt(AccountLEST[i],12,stemp[i]);
      gotoxy(41,9+i);printf("[");
      DrawWords2(stemp[i],wherex(),wherey(),Hlen);
      printf("]");
   }

   Replace_Mode();
   ch=0;eitem=0;
   do{
      Message(0,0,0,helpmsg);
      SetEnglishInput();
      while(1)
      {
         eitem=(eitem>=Totalitem-1)?Totalitem-1:eitem;
         eitem=(eitem<=0)?0:eitem;
         ch=DFGetWords(stemp[eitem],format,42,9+eitem);
         while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
         {
            for(i=0;i<Hlen-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
            stemp[eitem][i++]=' ';
            stemp[eitem][i]='\0';
         }
         if(atol(stemp[eitem])<=0)strcpy(stemp[eitem],"0");
         DrawWords2(stemp[eitem],42,9+eitem,Hlen);
         if(ch==F2)break;              /* Save */
         if(ch==Esc)                   /* Exit No save */
         {
            CwordsOff2();
            puttext(1,1,80,24,scrbuf);
            free(scrbuf);
            free(sstemp);
            free(stemp);
            Cursor(0);
            Message(0,0,0,"%s]wSܡC",&titlemsg[4]);
            return NotOK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem-1)?0:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?Totalitem-1:eitem-1;
      }
      memset(TTLEST,0,ACCOUNT_KINDS*sizeof(double));
      for(i=0;i<account_num-1;i++)
         TTLEST[i]=atof(stemp[i]);

      /* check ok */
      Message(0,0,1,"%sAO_sɡH]^",titlemsg);
      Cursor(2);
      Clear_KeyBuf();
      SetEnglishInput();
      ch=bioskey(0);
      ch=(ch==Esc)?N_N:ch;
      Cursor(0);
   }while(ch==N_N||ch==S_N);
   gotoxy(1,1);
   Message(0,1,0,"%s]wxsDDD",&titlemsg[4]);

   memset(AccountLEST,0,ACCOUNT_KINDS*sizeof(double));
   for(i=0;i<account_num-1;i++)
      AccountLEST[i]=TTLEST[i];

   Write_SAT(Current_SAT);

   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   free(sstemp);
   free(stemp);
   Cursor(0);
   CalculateMoney();
   Message(0,0,0,"%s]wxsC",&titlemsg[4]);
   return OK;
}

/******************************************************************************
void Write_SAT(char *SAT_filename);
void Read_SAT(char *SAT_filename);
void DrawTable(void);
char SetBudget(void);
******************************************************************************/
