
void CheckROWCOLHeader(ROWCOL *r)
{
   int i;
   clrscr();
   printf("\n");
   printf("ID[6]    =%6.6s\n",r->ID);
   printf("trow     =%d\n",r->trow);
   printf("tcol     =%d\n",r->tcol);
   printf("col[0]   =%d\n",r->col[0]);
   printf("len[0]   =%d\n",r->len[0]);
   printf("width    =%d\n",r->width);
   printf("height   =%d\n",r->height);
   printf("headerlen=%d\n",r->headerlen);
   printf("hdlen    =%d\n",r->hdlen);
   printf("hdrow    =%d\n",r->hdrow);
   printf("hdwordbeg=%d\n",r->hdwordbeg);
   for(i=0;i<r->trow;i++)
      printf("row[%3d]=%d\t",i,r->row[i]);
   printf("\n");
}
void ShowROWCOLHeader(char **rch,ROWCOL *rc,char ScrY)
{
   unsigned char i;
   printfXY(rc->col[0],ScrY,rch[0]);         /* Table Header */
   for(i=0;i<rc->hdrow;i++)               /* Header Words */
      printfXY(rc->col[0],i+ScrY+1,rch[rc->hdwordbeg+i]);
   printfXY(rc->col[0],i+ScrY+1,rch[1]);         /* Part Line */
   gotoxy(1,i+ScrY+2);
}
BOOL2 ShowROWCOLOneRow(char **rch,ROWCOL *rc,unsigned char rowno,int sOff,char ScrY)
{                                                 /* 1_base */  /*1_base*/
   int i;
   int offs;
   if(rowno>rc->trow)return (OK);
   window(1,ScrY,80,23); clrscr(); window(1,1,80,24);
   for(i=1,offs=rc->hdwordbeg+rc->hdrow;i<rowno;i++)  /* count */
      offs+=rc->row[i-1];
   offs+=sOff-1;
   for(i=0;i<rc->row[rowno-1];i++)              /* draw word */
   {
      if(i+ScrY>=23)break;
      printfXY(rc->col[0],i+ScrY,rch[offs+i]);
      gotoxy(1,i+ScrY+1);
   }
   if(i!=rc->row[rowno-1])    /* break occur */
      return (NotOK);         /* NotOK - Show to the end with no-complete row */
   if(rowno!=rc->trow)
      printfXY(rc->col[0],i+ScrY,rch[1]);       /* Part Line */
   else
      printfXY(rc->col[0],i+ScrY,rch[2]);       /* Table end Line */
   gotoxy(1,i+ScrY+1);
   if(i+ScrY+1>=23 && rowno!=rc->trow)
      return (OK);            /* OK - already show to the end */
   else
      return (OTHER);         /* OTHER - Still has space for OTHER row */
}
void LinesScrollUp(char **newword,int totalrow,int bindex,char rows,char ScrL,char ScrT,char ScrR,char ScrB)
{                                 /* 1_base */ /* 0_base */
   char i;
   char bheight;
   struct text_info R;
   gettextinfo(&R);

   bheight=ScrB-ScrT+1;
   window(ScrL,ScrT,ScrR,ScrB);
   for(i=0;i<rows;i++)
   {
      gotoxy(1,1); delline();
      gotoxy(1,bheight);
      if(bindex+i<totalrow)
         printfXY(1,bheight,newword[bindex+i]);
   }

   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(R.curx,R.cury);
}
void LinesScrollDown(char **newword,int bindex,char rows,char ScrL,char ScrT,char ScrR,char ScrB)
{
   char i;
   char bheight;
   struct text_info R;
   gettextinfo(&R);

   bheight=ScrB-ScrT+1;
   window(ScrL,ScrT,ScrR,ScrB);
   for(i=bindex;i<rows;i++)
   {
      gotoxy(1,bheight); delline();
      gotoxy(1,1); insline();
      if(bindex-i>=0)
         printfXY(1,1,newword[bindex-i]);
      else
         break;
   }

   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(R.curx,R.cury);
}
