/*****************************************************************************/
/* XMS.C       use the XMSIF.LIB to alloc XMS memory                         */
/*****************************************************************************/

#include<alloc.h>
#include<stdio.h>
#include<stdlib.h>

#include"keycode.ii"
#include"lee_sub.i"

BOOL2 CopyXms2Xms(XMS *dest,XMS *src,unsigned long clen)
{
   int ecode=_XMMcopy(clen,src->handle,src->offset,dest->handle,dest->offset);
   return (ecode==0)?OK:NotOK;
}
BOOL2 CopyXms2Cnv(void far *dest,XMS *src,unsigned long clen)
{
   int ecode=_XMMcopy(clen,src->handle,src->offset,0,(unsigned long)dest);
   return (ecode==0)?OK:NotOK;
}
BOOL2 CopyCnv2Xms(XMS *dest,void far *scr,unsigned long clen)
{
   int ecode=_XMMcopy(clen,0,(unsigned long)scr,dest->handle,dest->offset);
   return (ecode==0)?OK:NotOK;
}
BOOL2 CopyCnv2Cnv(void far *dest,void far *scr,unsigned long clen)
{
   int ecode=_XMMcopy(clen,0,(unsigned long)scr,0,(unsigned long)dest);
   return (ecode==0)?OK:NotOK;
}

BOOL2 CopyXms2XmsI(XMS *dest,XMS *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip)
{
   int ecode=_XMMicopy(nelem,esize,sskip,src->handle,src->offset,dest->handle,dest->offset,dskip);
   return (ecode==0)?OK:NotOK;
}
BOOL2 CopyXms2CnvI(void far *dest,XMS *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip)
{
   int ecode=_XMMicopy(nelem,esize,sskip,src->handle,src->offset,0,(unsigned long)dest,dskip);
   return (ecode==0)?OK:NotOK;
}
BOOL2 CopyCnv2XmsI(XMS *dest,void far *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip)
{
   int ecode=_XMMicopy(nelem,esize,sskip,0,(unsigned long)src,dest->handle,dest->offset,dskip);
   return (ecode==0)?OK:NotOK;
}
BOOL2 CopyCnv2CnvI(void far *dest,void far *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip)
{
   int ecode=_XMMicopy(nelem,esize,sskip,0,(unsigned long)src,0,(unsigned long)dest,dskip);
   return (ecode==0)?OK:NotOK;
}

BOOL2 FreeXMS(unsigned long *fxms)
{
   *fxms=XMMallcoreleft();
   if(*fxms==0)return NotOK;
   return OK;
}

BOOL2 LargestXMS(unsigned long *fxms)
{
   *fxms=XMMcoreleft();
   if(*fxms==0)return NotOK;
   return OK;
}

BOOL2 XMSalloc(XMS *dest,unsigned long dlen)
{
   dest->handle=XMMalloc(dlen);
   dest->offset=0L;
   return (_XMMerror==0) ? OK : NotOK ;
}
BOOL2 XMSfree(XMS *dest)
{
   int ecode=XMMfree(dest->handle);
   return (ecode==0) ? OK : NotOK ;
}

BOOL2 GetXMSVer(int *xms_ver)
{
   *xms_ver=XMMgetversion();
   return (_XMMerror==0) ? OK : NotOK ;
}

BOOL2 XMSinstall(void)
{
   int ecode=XMMlibinit();
   return (ecode==0) ? OK :( (ecode==NOXMM) ? NotOK : ERROR );
}


BOOL2 XMS_1Dalloc(XMS *dest,unsigned long nelem,unsigned long lelem)
{                 /* dest is an 1-D array of XMS */
   unsigned long i;
   if(XMSalloc(&dest[0],lelem*nelem)!=OK)return NotOK;
   for(i=1;i<nelem;i++)
   {
      dest[i].handle=dest[0].handle;
      dest[i].offset=dest[i-1].offset+lelem;
   }
   return OK;
}
BOOL2 XMS_1Dfree(XMS *dest)
{                 /* dest is an 1-D array of XMS */
   if(XMSfree(&dest[0])!=OK)return NotOK;
   return OK;
}

/******************************************************************************
BOOL2 CopyXms2Xms(XMS *dest,XMS *src,unsigned long clen);
BOOL2 CopyXms2Cnv(void far *dest,XMS *src,unsigned long clen);
BOOL2 CopyCnv2Xms(XMS *dest,void far *scr,unsigned long clen);
BOOL2 CopyCnv2Cnv(void far *dest,void far *scr,unsigned long clen);
BOOL2 CopyXms2XmsI(XMS *dest,XMS *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 CopyXms2CnvI(void far *dest,XMS *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 CopyCnv2XmsI(XMS *dest,void far *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 CopyCnv2CnvI(void far *dest,void far *src,unsigned long nelem,int esize,unsigned int sskip,unsigned int dskip);
BOOL2 FreeXMS(unsigned long *fxms);
BOOL2 LargestXMS(unsigned long *fxms);
BOOL2 XMSalloc(XMS *dest,unsigned long dlen);
BOOL2 XMSfree(XMS *dest);
BOOL2 GetXMSVer(int *xms_ver);
BOOL2 XMSinstall(void);
BOOL2 XMS_1Dalloc(XMS *dest,unsigned long nelem,unsigned long lelem);
BOOL2 XMS_1Dfree(XMS *dest);
******************************************************************************/
/*** Test Program *************************************************************
#include<alloc.h>
#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include"lee_sub.i"
main()
{
   char *t="1234567890090938092384092384092384Lee";
   char *tt,*tt2;
   XMS  *tall;

   XMSinstall();
   printf("t=%s\n",t);
   tt=(char *)malloc(sizeof(char)*100);
   tt2=(char *)malloc(sizeof(char)*100);
   tall=(XMS *)calloc(3,sizeof(XMS));

   XMS_1Dalloc(tall,3,100);

   CopyCnv2Cnv(tt,t,strlen(t)+1);
   printf("tt=%s\n",tt);

   CopyCnv2Xms(&tall[0],tt,100);
   CopyXms2Xms(&tall[2],&tall[0],100);
   CopyXms2Xms(&tall[1],&tall[2],100);
   CopyXms2Cnv(tt2,&tall[0],100);
   printf("tt2=%s\n",tt2);
   CopyXms2Cnv(tt2,&tall[1],100);
   printf("tt2=%s\n",tt2);
   CopyXms2Cnv(tt2,&tall[2],100);
   printf("tt2=%s\n",tt2);

   XMS_1Dfree(tall);
   free(tall);
   free(tt2);
   free(tt);
}
******************************************************************************/
